#include "jbsql.h"

void Describe(TextWidget *text,char *as_command)
{
  char *str,*owner,*object,*object_type;
  char query[4000];
  int x;
  ExecuteStruct *es;
  
  if (!odbc_connected && !ora_connected)
  {
    WPrintf("Not connected to a database\n");
    ClearCommand(text,1,0);
    return;
  }
  Trim(as_command);
  object=strchr(as_command,' ');
  if (object==NULL)
  {
    WPrintf("Usage: desc[ribe] [owner.]object\n");
    ClearCommand(text,1,0);
    return;
  }
  if (text->datasource==DS_ORACLE)
  {
    str=_strdup(object);
    Trim(str);
    for (x=0;x<(int)strlen(str);x++)
      str[x]=toupper(str[x]);
    object=strchr(str,'.');
    if (object==NULL)
    {
      GetUserID(str,&owner,&object,1);
    }
    else
    {
      *object='\0';
      owner=_strdup(str);
      object++;
      object=_strdup(object);
    }
    free(str);
    if (owner!=NULL)
    {
      object_type=GetOracleObjectType(owner,object,1);
      if (object_type!=NULL)
      {
        if (!strcmp(object_type,"TABLE") || !strcmp(object_type,"VIEW"))
        {
          sprintf(query,"select t.column_name,t.data_type,decode(t.data_type,'VARCHAR2',t.data_length,'CHAR',t.data_length,'RAW',t.data_length,null) data_length,t.data_precision,t.data_scale,t.nullable,c.comments from all_tab_columns t,all_col_comments c where t.table_name='%s' and t.owner='%s' and c.owner(+)='%s' and c.table_name(+)='%s' and c.column_name(+)=t.column_name order by column_id",object,owner,owner,object);
          es=malloc(sizeof(ExecuteStruct));
          es->text=text;
          es->data=_strdup(query);
          strcpy(es->action,"");
          es->fast=0;
          if (tid == 0)
          {
              CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)ExecuteQuery, es, 0, &tid);
          }
          else
          {
              ExecuteQuery(es);
          }
        }
        else if (!strcmp(object_type,"PACKAGE"))
        {
          sprintf(query,"select case when row_number() over (partition by ap.procedure_name,ap.overload order by aa.sequence)=1 then ap.procedure_name||decode(ap.overload,null,null,' ('||to_char(ap.overload)||')') || decode(aa.position,0,' (FUNCTION)','') else '' end procedure,               lpad(' ',aa.data_level*4,' ')||nvl(aa.argument_name,decode(aa.in_out,'OUT','<return value>','<none>')) argument,                decode(aa.data_level,0,decode(aa.argument_name,null,decode(aa.in_out,'OUT','OUT',''),aa.in_out)) in_out,                decode(aa.type_subname,null,decode(aa.type_name,null,decode(aa.data_type,'VARCHAR2',decode(aa.data_length,null,aa.data_type,aa.data_type||' ('||aa.data_length||')'),aa.data_type),aa.data_type||' ('||aa.type_owner||'.'||aa.type_name||')'),aa.data_type||' ('||aa.type_subname||')') datatype   from all_procedures ap,      (  select sequence,nvl(overload,-1) overload,position,data_level,argument_name,in_out,type_subname,type_name,data_type,data_length,type_owner,object_name,package_name,owner          from all_arguments) aa  where ap.owner='%s'   and ap.object_name='%s'  and ap.procedure_name is not null  and aa.owner(+)=ap.owner  and aa.package_name(+)=ap.object_name  and aa.object_name (+)=ap.procedure_name and aa.overload (+)= NVL(ap.overload,-1)  order by ap.subprogram_id,aa.sequence",owner,object);
          es=malloc(sizeof(ExecuteStruct));
          es->text=text;
          es->data=_strdup(query);
          strcpy(es->action,"");
          es->fast=0;
          if (tid == 0)
          {
              CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)ExecuteQuery, es, 0, &tid);
          }
          else
          {
              ExecuteQuery(es);
          }
        }
        else if (!strcmp(object_type,"FUNCTION") || !strcmp(object_type,"PROCEDURE"))
        {
          sprintf(query,"select ap.object_name procedure,               lpad(' ',aa.data_level*4,' ')||nvl(aa.argument_name,decode(aa.in_out,'OUT','<return value>','<none>')) argument,                decode(aa.data_level,0,decode(aa.argument_name,null,decode(aa.in_out,'OUT','OUT',''),aa.in_out)) in_out,                decode(aa.type_subname,null,decode(aa.type_name,null,decode(aa.data_type,'VARCHAR2',decode(aa.data_length,null,aa.data_type,aa.data_type||' ('||aa.data_length||')'),aa.data_type),aa.data_type||' ('||aa.type_owner||'.'||aa.type_name||')'),aa.data_type||' ('||aa.type_subname||')') datatype   from all_procedures ap,      (  select sequence,nvl(overload,-1) overload,position,data_level,argument_name,in_out,type_subname,type_name,data_type,data_length,type_owner,object_name,package_name,owner          from all_arguments) aa  where ap.owner='%s'   and ap.object_name='%s'  and aa.owner(+)=ap.owner  and aa.object_name (+)=ap.object_name order by ap.subprogram_id,aa.sequence",owner,object);
          es=malloc(sizeof(ExecuteStruct));
          es->text=text;
          es->data=_strdup(query);
          strcpy(es->action,"");
          es->fast=0;
          if (tid == 0)
          {
              CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)ExecuteQuery, es, 0, &tid);
          }
          else
          {
              ExecuteQuery(es);
          }
        }
        else if (!strcmp(object_type,"TYPE"))
        {
          sprintf(query,"select text from all_source where owner='%s' and name='%s' and type='TYPE' order by line",owner,object);
          es=malloc(sizeof(ExecuteStruct));
          es->text=text;
          es->data=_strdup(query);
          strcpy(es->action,"");
          es->fast=0;
          if (tid == 0)
          {
              CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)ExecuteQuery, es, 0, &tid);
          }
          else
          {
              ExecuteQuery(es);
          }
        }
        else
        {
          WPrintf("Feature not implemented yet: %s\n",object_type);
          ClearCommand(text,1,0);
        }
      }
      else
      {
        ClearCommand(text,1,0);
      }
    }
    else
    {
      ClearCommand(text,1,0);
    }
    free(object);
    free(owner);
  }
  else
  {
    char catalog[40]="",schema[40]="",table[40]="",column[40]="";

    x=sscanf(object,"%[^.].%[^.].%s",catalog,schema,table);
    Trim(catalog);
    Trim(schema);
    Trim(table);
    switch (x)
    {
      case 1:
        strcpy(table,catalog);
        strcpy(catalog,"");
        strcpy(schema,"");
        break;
      case 2:
        strcpy(table,schema);
        strcpy(schema,catalog);
        strcpy(catalog,"");
        break;
      case 0:
        return;
    }
    ODBC_DescribeTable(text,catalog,schema,table);
  }
}
