#include "jbsql.h"

char *GetFavouritesDirectory(TextWidget *text)
{
	char static initialdir[MAX_PATH];
	char appdata[MAX_PATH];

  strcpy(initialdir,STR_OPTION(FAVDIR));
  if (initialdir[0]=='\0')
  {
	  GetEnvironmentVariable("APPDATA",appdata,MAX_PATH);
	  sprintf(initialdir,"%s\\jbsql",appdata);
	  CreateDirectory(initialdir,NULL);
	  strcat(initialdir,"\\favourites");
	  CreateDirectory(initialdir,NULL);
  }
	return initialdir;
}

void AddFavourite(TextWidget *text,HWND hWnd)
{
	OPENFILENAME openFile;
	char filename[MAX_PATH]="\0";
	char filter[200]="SQL Scripts (*.sql)\0*.sql\0\0\0";
	char extentions[][5]={".sql"};
  char *str,*pos1,*pos2;
  int x,ncommand,lastx=0;
  int slen;
  HANDLE f;
  DWORD bytes_written;

 	ncommand=GetPreviousSQLCommand();
	if (ncommand==-1)
	{
		MessageBox(hWnd,"No previous command\n","Add favourite",MB_ICONINFORMATION);
		return;
	}
  sprintf(filename,"%s\\*.sql",GetFavouritesDirectory(text));
  openFile.lStructSize=sizeof(OPENFILENAME);
	openFile.hwndOwner=g_hWnd;
	openFile.hInstance=NULL;
	openFile.lpstrFilter=filter;
	openFile.lpstrCustomFilter=NULL;
	openFile.nMaxCustFilter=255;
	openFile.nFilterIndex=0;
	openFile.lpstrFile=filename;
	openFile.nMaxFile=MAX_PATH;
	openFile.lpstrFileTitle=NULL;
	openFile.nMaxFileTitle=0;
	openFile.lpstrInitialDir=GetFavouritesDirectory(text);
	openFile.lpstrTitle="Add favourite";
	openFile.Flags=OFN_OVERWRITEPROMPT;
	openFile.nFileOffset=0;
	openFile.nFileExtension=0;
	openFile.lpstrDefExt=".sql";
	openFile.lCustData=0;
	openFile.lpfnHook=NULL;
	openFile.lpTemplateName=NULL;
	if (GetSaveFileName(&openFile))
  {
	  if (filename[0]=='\0')
		  return;
    pos1=strrchr(filename,'.');
    pos2=strrchr(filename,'\\');
    if (pos1==NULL)
      strcat(filename,extentions[openFile.nFilterIndex-1]);
    else
    {
      if (pos2!=NULL && pos2>pos1)
        strcat(filename,extentions[openFile.nFilterIndex-1]);
    }
	  f=CreateFile(filename,
		  GENERIC_READ|GENERIC_WRITE,
		  FILE_SHARE_READ,
		  NULL,
		  CREATE_ALWAYS,
		  0,
		  NULL);

	  if (f==INVALID_HANDLE_VALUE)
	  {
		  DisplayLastError(NULL);
		  return;
	  }
	  if (ncommand!=-1)
		  str=_strdup(old_commands[ncommand].command);
	  else
		  str=_strdup("");
	  slen=(int)strlen(str);
	  for (x=0;x<slen;x++)
	  {
		  switch (str[x])
		  {
			  case '\n':
				  str[x]='\0';
				  WriteFile(f,&str[lastx],(DWORD)strlen(&str[lastx]),&bytes_written,NULL);
				  WriteFile(f,"\r\n",(DWORD)strlen("\r\n"),&bytes_written,NULL);
				  lastx=x+1;
				  break;
			  default:
				  break;
		  }
	  }
	  if (lastx<slen)
		  WriteFile(f,&str[lastx],(DWORD)strlen(&str[lastx]),&bytes_written,NULL);
	  WriteFile(f,"\r\n/",3,&bytes_written,NULL);
	  CloseHandle(f);
	  free(str);
  }
}

void ShowFavourites(HWND parent,TextWidget *text)
{
  char command[MAX_PATH];
	PROCESS_INFORMATION p;
  STARTUPINFO si;

	si.cb=sizeof(STARTUPINFO);
	si.lpReserved=NULL;
	si.lpDesktop=NULL;
	si.lpTitle=NULL;
	si.dwFlags=0;
	si.cbReserved2=0;
	si.lpReserved2=NULL;
  sprintf(command,"explorer %s",GetFavouritesDirectory(text));
  if (CreateProcess(NULL,command,NULL,NULL,FALSE,0,NULL,NULL,&si,&p)==0)
  {
    DisplayLastError(NULL);
    return;
  }
}

void FindFavouriteFiles(TextWidget *text,HMENU menu,char *directory)
{
  HANDLE hfiles;
  WIN32_FIND_DATA finddata;
  char *pos;
  HMENU submenu_item;
  UINT_PTR menuitem;
  char filename[MAX_PATH];
  char subdir[MAX_PATH];

  sprintf(filename,"%s\\*",directory);
  hfiles=FindFirstFile(filename,&finddata);
  if (hfiles!=INVALID_HANDLE_VALUE)
  {
    for (;;)
    {
      strcpy(filename,finddata.cFileName);
      pos=strrchr(filename,'.');
      if (pos)
        *pos='\0';
      if (finddata.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY)
      {
        if (strcmp(finddata.cFileName,".") && strcmp(finddata.cFileName,".."))
        {
          submenu_item=CreateMenu();
          menuitem=(UINT_PTR)submenu_item;
          AppendMenu(menu,MF_ENABLED|MF_POPUP|MF_STRING,menuitem,finddata.cFileName);
          sprintf(subdir,"%s\\%s",directory,finddata.cFileName);
          FindFavouriteFiles(text,submenu_item,subdir);
        }
      }
      else
      {
        menuitem=(UINT_PTR)ID_FAVOURITE_BASE + text->nfavourite_items;
        AppendMenu(menu,MF_ENABLED|MF_STRING,menuitem,filename);
        sprintf(filename,"%s\\%s",directory,finddata.cFileName);
        text->favourite_items=realloc(text->favourite_items,(text->nfavourite_items+1)*sizeof(FavouriteItem));
        text->favourite_items[text->nfavourite_items].filename=_strdup(filename);
        text->favourite_items[text->nfavourite_items].item=(UINT)menuitem;
        text->favourite_items[text->nfavourite_items].menu=menu;
        text->nfavourite_items++;
      }
      if (!FindNextFile(hfiles,&finddata))
      {
        break;
      }
    }
    FindClose(hfiles);
  }

}

void ClearFavouritesMenu(TextWidget *text,HWND hwnd)
{
  int x;

  for (x=0;x<text->nfavourite_items;x++)
  {
    RemoveMenu(text->favourite_items[x].menu,text->favourite_items[x].item,MF_BYCOMMAND);
    if (GetSubMenu(GetMenu(hwnd),4)!=text->favourite_items[x].menu && IsMenu(text->favourite_items[x].menu))
      DestroyMenu(text->favourite_items[x].menu);
    free(text->favourite_items[x].filename);
  }
  while (GetMenuItemCount(GetSubMenu(GetMenu(hwnd),4))>3)
  {
    if (RemoveMenu(GetSubMenu(GetMenu(hwnd),4),3,MF_BYPOSITION)==0)
      DisplayLastError(hwnd);
  }
  free(text->favourite_items);
  text->favourite_items=NULL;
  text->nfavourite_items=0;
}

void AddFavouritesMenu(TextWidget *text,HWND hwnd)
{
  HMENU menu;

  ClearFavouritesMenu(text,hwnd);
  menu=GetSubMenu(GetMenu(hwnd),4);
  if (menu==NULL)
  {
    MessageBox(hwnd,"Cannot find favourites menu","ERROR",MB_ICONERROR);
    return;
  }
  FindFavouriteFiles(text,menu,GetFavouritesDirectory(text));
}

int IsFavouriteItem(TextWidget *text,DWORD item)
{
  int x;

  for (x=0;x<text->nfavourite_items;x++)
  {
    if (text->favourite_items[x].item==item)
    {
      if (!tid)
      {
        int old_termout=text->termout;
        text->termout=0;
        ClearCommand(text,0,0);
        text->termout=old_termout;
        InsertLineBuffer(text,"@\"%s\"\n",text->favourite_items[x].filename);
      }
      return 1;
    }
  }
  return 0;
}