#include "jbsql.h"

#define HINT_CLASS_NAME "HintClass"

ODBCToken odbc_tokens[]={
  {"set","update",OT_COLUMNS,"where"},
  {"update","",OT_TABLES,"set"},
  {"into","insert",OT_TABLES,"values"},
  {"select","",OT_COLUMNS,"from"},
  {"unique","select",OT_COLUMNS,"from"},
  {"distinct","select",OT_COLUMNS,"from"},
  {"where",NULL,OT_COLUMNS,"order,group"},
  {"from",NULL,OT_TABLES,"where,order,group"},
  {"delete",NULL,OT_TABLES,"where"},
  {"table",NULL,OT_TABLES,NULL},
  {"by","group",OT_COLUMNS,NULL},
  {"by","order",OT_COLUMNS,NULL},
  {"desc",NULL,OT_TABLES,NULL},
  {"descr",NULL,OT_TABLES,NULL},
  {"descri",NULL,OT_TABLES,NULL},
  {"describ",NULL,OT_TABLES,NULL},
  {"describe",NULL,OT_TABLES,NULL},
  {"","",0,"commit,connect,delete,disconnect,edit,exit,insert,rollback,select,spool,truncate,update"},
  {NULL,NULL,0,NULL}
};

SQLToken sql_tokens[]={
  {"set","update","select distinct lower(column_name) from all_tab_columns where owner=sys_context( 'userenv', 'current_schema' ) and column_name like upper(:1||'%')","where"},
  {"update","","select distinct lower(table_name) from all_tables where table_name like upper(:1||'%') union select distinct lower(view_name) from all_views where view_name like upper(:1||'%') union select distinct lower(synonym_name) from all_synonyms where synonym_name like upper(:1||'%')","set"},
  {"materialized","alter",NULL,"view"},
  {"materialized","create",NULL,"view"},
  {"materialized","drop",NULL,"view"},
  {"view","materialized","select distinct lower(name) from all_snapshots where name like upper(:1||'%')","log"},
  {"resource","alter",NULL,"cost"},
  {"rollback","alter",NULL,"segment"},
  {"rollback","create",NULL,"segment"},
  {"rollback","drop",NULL,"segment"},
  {"package","create",NULL,"body"},
  {"temporary","create",NULL,"tablespace"},
  {"type","create",NULL,"body"},
  {"type","drop",NULL,"body"},
  {"associate","",NULL,"statistics"},
  {"disassociate","",NULL,"statistics"},
  {"explain","",NULL,"plan"},
  {"lock","",NULL,"table"},
  {"truncate","",NULL,"table,cluster"},
  {"database","create",NULL,"link"},
  {"database","drop",NULL,"link"},
  {"insert","",NULL,"into"},
  {"spool","",NULL,"off"},
  {"desc","","select distinct lower(object_name) from all_objects where object_name like upper(:1||'%') and object_type in ('FUNCTION','PACKAGE','PROCEDURE','TABLE','VIEW','TYPE') union select distinct lower(synonym_name) from all_synonyms where synonym_name like upper(:1||'%')",NULL},
  {"descr","","select distinct lower(object_name) from all_objects where object_name like upper(:1||'%') and object_type in ('FUNCTION','PACKAGE','PROCEDURE','TABLE','VIEW','TYPE') union select distinct lower(synonym_name) from all_synonyms where synonym_name like upper(:1||'%')",NULL},
  {"descri","","select distinct lower(object_name) from all_objects where object_name like upper(:1||'%') and object_type in ('FUNCTION','PACKAGE','PROCEDURE','TABLE','VIEW','TYPE') union select distinct lower(synonym_name) from all_synonyms where synonym_name like upper(:1||'%')",NULL},
  {"descri","","select distinct lower(object_name) from all_objects where object_name like upper(:1||'%') and object_type in ('FUNCTION','PACKAGE','PROCEDURE','TABLE','VIEW','TYPE') union select distinct lower(synonym_name) from all_synonyms where synonym_name like upper(:1||'%')",NULL},
  {"describ","","select distinct lower(object_name) from all_objects where object_name like upper(:1||'%') and object_type in ('FUNCTION','PACKAGE','PROCEDURE','TABLE','VIEW','TYPE') union select distinct lower(synonym_name) from all_synonyms where synonym_name like upper(:1||'%')",NULL},
  {"describe","","select distinct lower(object_name) from all_objects where object_name like upper(:1||'%') and object_type in ('FUNCTION','PACKAGE','PROCEDURE','TABLE','VIEW','TYPE') union select distinct lower(synonym_name) from all_synonyms where synonym_name like upper(:1||'%')",NULL},
  {"or","create",NULL,"replace"},
  {"replace","or",NULL,"function,procedure,package,view,type"},
  {"rename","","select distinct lower(table_name) from all_tables where table_name like upper(:1||'%') union select distinct lower(view_name) from all_views where view_name like upper(:1||'%') union select distinct lower(sequence_name) from all_sequences where sequence_name like upper(:1||'%')",NULL},
  {"into","insert","select distinct lower(table_name) from all_tables where table_name like upper(:1||'%') union select distinct lower(view_name) from all_views where view_name like upper(:1||'%')","values"},
  {"to","grant","select distinct lower(role) from dba_roles where role like upper(:1||'%') union select distinct lower(username) from dba_users where username like upper(:1||'%')","public"},
  {"from","revoke","select distinct lower(role) from dba_roles where role like upper(:1||'%') union select distinct lower(username) from dba_users where username like upper(:1||'%')","public"},
  {"select",NULL,"select /*+ FIRST_ROWS */ distinct lower(column_name) from all_tab_columns where column_name like upper(:1||'%')  union select /*+ FIRST_ROWS */ lower(object_name) from all_objects where object_name like upper(:1)||'%' and object_type in ('PACKAGE','FUNCTION')","from,distinct,unique"},
  {"unique","select","select /*+ FIRST_ROWS */ distinct lower(column_name) from all_tab_columns where column_name like upper(:1||'%') union select /*+ FIRST_ROWS */ lower(object_name) from all_objects where object_name like upper(:1)||'%' and object_type in ('PACKAGE','FUNCTION')","from"},
  {"distinct","select","select /*+ FIRST_ROWS */ distinct lower(column_name) from all_tab_columns where column_name like upper(:1||'%') union select /*+ FIRST_ROWS */ lower(object_name) from all_objects where object_name like upper(:1)||'%' and object_type in ('PACKAGE','FUNCTION')","from"},
  {"where",NULL,"select distinct /*+ FIRST_ROWS */ lower(column_name) from all_tab_columns where column_name like upper(:1||'%') union select /*+ FIRST_ROWS */ lower(object_name) from all_objects where object_name like upper(:1)||'%' and object_type in ('PACKAGE','FUNCTION')","order,group"},
  {"from",NULL,"select distinct lower(table_name) from all_tables where table_name like upper(:1||'%') union select distinct lower(view_name) from all_views where view_name like upper(:1||'%') union select distinct lower(synonym_name) from all_synonyms where synonym_name like upper(:1||'%')","where,order,group"},
  {"delete",NULL,"select distinct lower(table_name) from all_tables where table_name like upper(:1||'%') union select distinct lower(view_name) from all_views where view_name like upper(:1||'%') union select distinct lower(synonym_name) from all_synonyms where synonym_name like upper(:1||'%')","where,order,group"},
  {"table",NULL,"select distinct lower(table_name) from all_tables where table_name like upper(:1||'%')",NULL},
  {"view",NULL,"select distinct lower(view_name) from all_views where view_name like upper(:1||'%')",NULL},
  {"cluster",NULL,"select distinct lower(cluster_name) from all_clusters where cluster_name like upper(:1||'%')",NULL},
  {"dimension",NULL,"select distinct lower(dimension_name) from all_dimensions where dimension_name like upper(:1||'%')",NULL},
  {"index",NULL,"select distinct lower(index_name) from all_indexes where index_name like upper(:1||'%')",NULL},
  {"directory",NULL,"select distinct lower(directory_name) from all_directories where directory_name like upper(:1||'%')",NULL},
  {"indextype",NULL,"select distinct lower(indextype_name) from all_indextypes where indextype_name like upper(:1||'%')",NULL},
  {"library",NULL,"select distinct lower(library_name) from all_libraries where library_name like upper(:1||'%')",NULL},
  {"operator",NULL,"select distinct lower(operator_name) from all_operators where operator_name like upper(:1||'%')",NULL},
  {"trigger",NULL,"select distinct lower(trigger_name) from all_triggers where trigger_name like upper(:1||'%')",NULL},
  {"sequence",NULL,"select distinct lower(sequence_name) from all_sequences where sequence_name like upper(:1||'%')",NULL},
  {"profile",NULL,"select distinct lower(profile) from dba_profiles where profile like upper(:1||'%')",NULL},
  {"tablespace",NULL,"select distinct lower(tablespace_name) from dba_tablespaces where tablespace_name like upper(:1||'%')",NULL},
  {"role",NULL,"select distinct lower(role) from dba_roles where role like upper(:1||'%')",NULL},
  {"user","alter","select distinct lower(username) from dba_users where username like upper(:1||'%')",NULL},
  {"user","drop","select distinct lower(username) from dba_users where username like upper(:1||'%')",NULL},
  {"outline",NULL,"select distinct lower(name) from all_outlines where name like upper(:1||'%')",NULL},
  {"function",NULL,"select distinct lower(object_name) from all_objects where object_name like upper(:1||'%') and object_type='FUNCTION'",NULL},
  {"type",NULL,"select distinct lower(object_name) from all_objects where object_name like upper(:1||'%') and object_type='TYPE'",NULL},
  {"package",NULL,"select distinct lower(object_name) from all_objects where object_name like upper(:1||'%') and object_type='PACKAGE'",NULL},
  {"procedure",NULL,"select distinct lower(object_name) from all_objects where object_name like upper(:1||'%') and object_type='PROCEDURE'",NULL},
  {"alter","",NULL,"cluster,database,dimension,function,index,java,materialized,outline,package,procedure,profile,resource,role,rollback,sequence,session,system,table,tablespace,trigger,type,user,view"},
  {"create","",NULL,"cluster,context,controlfile,database,dimension,directory,function,index,indextype,java,library,materialized,operator,or,outline,package,procedure,profile,role,rollback,schema,sequence,synonym,table,tablespace,temporary,trigger,type,user,view"},
  {"drop","",NULL,"cluster,context,database,dimension,directory,function,index,indextype,java,library,materialized,operator,outline,package,procedure,profile,role,rollback,sequence,synonym,table,tablespace,trigger,type,user,view"},
  {"by","group","select distinct lower(column_name) from all_tab_columns where owner=sys_context( 'userenv', 'current_schema' ) and column_name like upper(:1||'%')",NULL},
  {"by","order","select distinct lower(column_name) from all_tab_columns where owner=sys_context( 'userenv', 'current_schema' ) and column_name like upper(:1||'%')",NULL},
  {"exec","","select distinct lower(object_name) from all_objects where object_name like upper(:1||'%') and object_type in ('FUNCTION','PACKAGE','PROCEDURE')",NULL},
  {"execu","","select distinct lower(object_name) from all_objects where object_name like upper(:1||'%') and object_type in ('FUNCTION','PACKAGE','PROCEDURE')",NULL},
  {"execut","","select distinct lower(object_name) from all_objects where object_name like upper(:1||'%') and object_type in ('FUNCTION','PACKAGE','PROCEDURE')",NULL},
  {"execute","","select distinct lower(object_name) from all_objects where object_name like upper(:1||'%') and object_type in ('FUNCTION','PACKAGE','PROCEDURE')",NULL},
  {"","",NULL,"alter,analyze,associate,audit,begin,call,comment,commit,connect,create,declare,delete,describe,disassociate,disconnect,drop,edit,exit,explain,grant,insert,lock,noaudit,prompt,rename,revoke,rollback,savepoint,select,show,spool,truncate,update"},
  {NULL,NULL,NULL,NULL}};

int start_of_dir=1;

LRESULT CALLBACK HintWndProc(HWND   hwnd,
														 UINT   uiMessage,
														 WPARAM wParam,
														 LPARAM lParam)
{
  TextWidget *text;

  text=(TextWidget*)GetWindowLongPtr(hwnd, 0);
  switch (uiMessage) 
	{
		case WM_CREATE:
			{
        LPCREATESTRUCT csWindowLong = (LPCREATESTRUCT) lParam;

				text = (TextWidget*)csWindowLong->lpCreateParams;
				SetWindowLongPtr(hwnd, 0, (LONG_PTR)text);
      }
      break;
    case WM_COMMAND:
      switch (HIWORD(wParam))
      {
        case LBN_DBLCLK:    /* The user double-clicks an item in the list box */
          SelectFromHint(text,linepos);
          break;
        case LBN_KILLFOCUS: /* The list box loses the keyboard focus. */
          break;
        case LBN_SELCANCEL: /* The user cancels the selection of an item in the list box. */
          DestroyHintList(text);
          break;
        case LBN_SELCHANGE: /* The selection in a list box is about to change. */
          break;
        case LBN_SETFOCUS:  /*The list box receives the keyboard focus. */
          break;
      }
      break;
		default:
			return DefWindowProc(hwnd, uiMessage, wParam, lParam);
  }
  return 0L;
}

void ShowHintList(TextWidget *text)
{
  static int initialized=0;
	RECT  sr;
	HWND        hwnd;
	WNDCLASSEX  wcex;
	ATOM        aReturn;

  if (!initialized)
  {
	  wcex.cbSize          = sizeof(WNDCLASSEX);
	  wcex.style           = 0;
	  wcex.lpfnWndProc     = (WNDPROC)HintWndProc;
	  wcex.cbClsExtra      = 0;
	  wcex.cbWndExtra      = sizeof(TextWidget*);
	  wcex.hInstance       = hInst;
	  wcex.hCursor         = LoadCursor(NULL, IDC_ARROW);
	  wcex.hbrBackground   = NULL;
	  wcex.lpszMenuName    = NULL;
	  wcex.lpszClassName   = HINT_CLASS_NAME;
	  wcex.hIcon           = NULL;
	  wcex.hIconSm         = NULL;

	  aReturn = RegisterClassEx(&wcex);
    if (aReturn==0)
      DisplayLastError(NULL);
    initialized=1;
  }

	GetWindowRect(hwndTextBox, &sr);
	
  hwnd = CreateWindowEx( 0,                         // ex style
												 HINT_CLASS_NAME,           // class name - defined in commctrl.h
												 "",                        // dummy text
												 WS_POPUP,                  // style
                         sr.left+(int)(text->cur_pos-text->left)*text->f_width+X_OFFSET,
                         sr.top+(text->lines-(int)text->top)*text->f_height+Y_OFFSET+CARET_OFFSET,
                         100,
                         40,
												 hwndTextBox,               // parent
												 (HMENU)0,                  // ID
												 hInst,                     // instance
												 text);                     // extra data
	if(!hwnd)
	{
		DisplayLastError(NULL);
	  return;
  }

  text->hintlist=CreateWindowEx(0,
                              "LISTBOX",
                              "HINTLIST",
                              WS_CHILD|WS_BORDER|WS_VSCROLL|LBS_NOTIFY|LBS_SORT|LBS_WANTKEYBOARDINPUT,
                              0,
                              0,
                              0,
                              0,
                              hwnd,
                              NULL,
                              g_hInst,
                              NULL);
  if (text->hintlist==NULL)
  {
    DisplayLastError(NULL);
    return;
  }
}

void DestroyHintList(TextWidget *text)
{
  HWND hWnd;

  hWnd=(HWND)GetWindowLongPtr(text->hintlist,GWLP_HWNDPARENT);
  DestroyWindow(hWnd);
  text->hintlist=NULL;
}

void AddToHintList(TextWidget *text,char *str,int sort)
{
  int count,x,ret;
  char value[256];

  if (sort)
  {
    count=(int)SendMessage(text->hintlist,LB_GETCOUNT,0,0);
    for (x=0;x<count;x++)
    {
      SendMessage(text->hintlist,LB_GETTEXT,x,(LPARAM)value);
      ret=_stricmp(str,value);
      if (ret<0)
      {
        SendMessage(text->hintlist,LB_INSERTSTRING,(WPARAM)x,(LPARAM)str);
        SendMessage(text->hintlist,LB_SETCURSEL,0,0);
        return;
      }
      else if (ret==0) // already in list
        return;
    }
  }
  SendMessage(text->hintlist,LB_INSERTSTRING,(WPARAM)-1,(LPARAM)str);
  if (SendMessage(text->hintlist,LB_GETCOUNT,0,0)==1)
    SendMessage(text->hintlist,LB_SETCURSEL,0,0);
}

char *FindLastWord(char *command,int linepos,int point)
{
  static char token[200]="";
  int x;

  for (x=linepos-1;x>=0;x--)
  {
    if (strchr(SQL_DELIMITERS,command[x])!=NULL)
    {
      if (!point)
      {
        strncpy(token,&command[x+1],linepos-1-x);
        token[linepos-1-x]=0;
        return token;
      }
      else
      {
        if (command[x]=='.')
        {
          strncpy(token,&command[x+1],linepos-1-x);
          token[linepos-1-x]=0;
          return token;
        }
        else
        {
          token[0]='\0';
          return token;
        }
      }
    }
  }   
  return command;
}

char *FindSecondWord(char *command,int linepos)
{
  static char token[200]="";
  int x,pos1=-1;

  for (x=linepos-1;x>=0;x--)
  {
    if (strchr(SQL_DELIMITERS,command[x])!=NULL)
    {
      if (command[x]=='.')
      {
        if (pos1==-1)
          pos1=x;
        else
        {
          strncpy(token,&command[x+1],pos1-1-x);
          token[pos1-1-x]=0;
          return token;
        }
      }
      else
      {
        if (pos1!=-1)
        {
          strncpy(token,&command[x+1],pos1-1-x);
          token[pos1-1-x]=0;
          return token;
        }
      }
    }
  }   
  return "";
}

char *FindFirstWord(char *command,int linepos)
{
  static char token[200]="";
  int x,pos1=-1,y=0;

  for (x=linepos-1;x>=0;x--)
  {
    if (strchr(SQL_DELIMITERS,command[x])!=NULL)
    {
      if (command[x]=='.')
      {
        if (y==0)
          y=1;
        else if (pos1==-1)
          pos1=x;
        else
        {
          strncpy(token,&command[x+1],pos1-1-x);
          token[pos1-1-x]=0;
          return token;
        }
      }
      else
      {
        if (y && pos1!=-1)
        {
          strncpy(token,&command[x+1],pos1-1-x);
          token[pos1-1-x]=0;
          return token;
        }
      }
    }
  }   
  return "";
}

int IsKnownToken(char *token)
{
  int x;

  for (x=0;sql_tokens[x].token!=NULL;x++)
  {
    if (!_stricmp(sql_tokens[x].token,token))
    {
      return 1;
    }
  }
  return 0;
}

int IsKnownODBCToken(char *token)
{
  int x;

  for (x=0;odbc_tokens[x].token!=NULL;x++)
  {
    if (!_stricmp(odbc_tokens[x].token,token))
    {
      return 1;
    }
  }
  return 0;
}

int TokenMatches(char *prev_token,char *token,int *ntoken)
{
  int x;

  for (x=0;sql_tokens[x].token!=NULL;x++)
  {
    if (!_stricmp(sql_tokens[x].token,token))
    {
      if (sql_tokens[x].prev_token==NULL || !_stricmp(sql_tokens[x].prev_token,prev_token))
      {
        *ntoken=x;
        return 1;
      }
    }
  }
  return 0;
}

int ODBCTokenMatches(char *prev_token,char *token,int *ntoken)
{
  int x;

  for (x=0;odbc_tokens[x].token!=NULL;x++)
  {
    if (!_stricmp(odbc_tokens[x].token,token))
    {
      if (odbc_tokens[x].prev_token==NULL || !_stricmp(odbc_tokens[x].prev_token,prev_token))
      {
        *ntoken=x;
        return 1;
      }
    }
  }
  return 0;
}

int FindLastKnownToken(char *command,int linepos)
{
  char token[200]="",next_token[200]="";
  char *str;
  int x,lastpos;
  int ntoken;

  str=command;
  lastpos=linepos-1;
  token[0]='\0';
  for (x=linepos-1;(int)x>=0;x--)
  {
    if (strchr(SQL_DELIMITERS,str[x])!=NULL)
    {
      if (x>=lastpos-1) // two delimiters in a row
      {
        lastpos=x;
      }
      else
      {
        strncpy(token,&str[x+1],lastpos-x-1);
        token[lastpos-x-1]=0;
        lastpos=x;
        if (TokenMatches(token,next_token,&ntoken))
          return ntoken;
        else if (IsKnownToken(token))
          strcpy(next_token,token);
      }
    }
    else if (x==0)
    {
      strncpy(token,&str[x],lastpos-x);
      token[lastpos-x]=0;
      if (TokenMatches(token,next_token,&ntoken))
        return ntoken;
      else if (IsKnownToken(token))
        strcpy(next_token,token);
    }
  }
  if (TokenMatches("",token,&ntoken))
    return ntoken;
  return -1;
}
 
int FindLastKnownODBCToken(char *command,int linepos)
{
  char token[200]="",next_token[200]="";
  char *str;
  int x,lastpos;
  int ntoken;

  str=command;
  lastpos=linepos-1;
  token[0]='\0';
  for (x=linepos-1;(int)x>=0;x--)
  {
    if (strchr(SQL_DELIMITERS,str[x])!=NULL)
    {
      if (x>=lastpos-1) // two delimiters in a row
      {
        lastpos=x;
      }
      else
      {
        strncpy(token,&str[x+1],lastpos-x-1);
        token[lastpos-x-1]=0;
        lastpos=x;
        if (ODBCTokenMatches(token,next_token,&ntoken))
          return ntoken;
        else if (IsKnownODBCToken(token))
          strcpy(next_token,token);
      }
    }
    else if (x==0)
    {
      strncpy(token,&str[x],lastpos-x);
      token[lastpos-x]=0;
      if (ODBCTokenMatches(token,next_token,&ntoken))
        return ntoken;
      else if (IsKnownODBCToken(token))
        strcpy(next_token,token);
    }
  }
  if (ODBCTokenMatches("",token,&ntoken))
    return ntoken;
  return -1;
}
 
int SetHintListSize(TextWidget *text,int linepos)
{
  int w=0,x;
  LRESULT cnt,h;
  HDC hdc;
  char *selection;
  SIZE s;
  int len;

  cnt=SendMessage(text->hintlist,LB_GETCOUNT,0,0);
  if (cnt==0)
  {
    DestroyHintList(text);
    return 1;
  }
  else if (cnt==1)
  {
    SelectFromHint(text,linepos);
    return 1;
  }
  else
  {
    h=SendMessage(text->hintlist,LB_GETITEMHEIGHT,0,0);
    hdc=GetDC(text->hintlist);
    for (x=0;x<cnt;x++)
    {
      len=(int)SendMessage(text->hintlist,LB_GETTEXTLEN,x,0);
      selection=(char*)malloc(len+1);
      SendMessage(text->hintlist,LB_GETTEXT,(WPARAM)x,(LPARAM)selection);
      GetTextExtentPoint32(hdc,selection,(int)strlen(selection),&s);
      free(selection);
      w=MAX(w,s.cx);
    }
    ReleaseDC(text->hintlist,hdc);
    if (SetWindowPos((HWND)GetWindowLongPtr(text->hintlist,GWLP_HWNDPARENT),
                 HWND_TOP,
                 0,
                 0,
                 w+20,
                 (int)h*(MIN((int)cnt,10))+2,
                 SWP_NOMOVE|SWP_NOZORDER)==0)
      DisplayLastError(NULL);
    if (SetWindowPos(text->hintlist,
                 HWND_TOP,
                 0,
                 0,
                 w+20,
                 (int)h*(MIN((int)cnt,10))+2,
                 SWP_NOMOVE|SWP_NOZORDER)==0)
      DisplayLastError(NULL);
    ShowWindow((HWND)GetWindowLongPtr(text->hintlist,GWLP_HWNDPARENT),SW_SHOW);
    ShowWindow(text->hintlist,SW_SHOW);
    SetForegroundWindow(hwndTextBox);
    SetFocus(hwndTextBox);
    return 1;
  }
}

void FillHintListFromValues(TextWidget *text,char *values,char *lastword)
{
  char token[200];
  int x,lastpos=0;
  int len;

  len=(int)strlen(values);
  for (x=0;x<len;x++)
  {
    if (values[x]==',')
    {
      strncpy(token,&values[lastpos],x-lastpos);
      token[x-lastpos]=0;
      lastpos=x+1;
      if (!_strnicmp(token,lastword,strlen(lastword)))
        AddToHintList(text,token,0);
    }
  }
  strcpy(token,&values[lastpos]);
  if (!_strnicmp(token,lastword,strlen(lastword)))
    AddToHintList(text,token,0);
}

char *FindLastDirectory(char *command,int linepos)
{
  static char token[MAX_PATH]="";
  int x;

  token[0]='\0';
  for (x=linepos-1;(int)x>=0;x--)
  {
    if (strchr("\\",command[x])!=NULL)
    {
      strncpy(token,&command[x+1],linepos-1-x);
      token[linepos-1-x]=0;
      return token;
    }
  }   
  return token;
}

void FillHintListFromDirectory(TextWidget *text,char *command,int pos,char *lastword)
{
  char start_dir[MAX_PATH]="";
  WIN32_FIND_DATA find_data;
  HANDLE h;

  strncpy(start_dir,&command[start_of_dir],pos-1);
  start_dir[pos-start_of_dir]='\0';
  if (strlen(lastword) && strlen(start_dir) && start_dir[strlen(start_dir)-1]!='\\')
    strcat(start_dir,"\\");
  strcat(start_dir,lastword);
  strcat(start_dir,"*");
  h=FindFirstFile(start_dir,&find_data);
  if (h==INVALID_HANDLE_VALUE)
    return;
  if (strcmp(find_data.cFileName,".") && strcmp(find_data.cFileName,".."))
    AddToHintList(text,find_data.cFileName,0);
  while (FindNextFile(h,&find_data))
  {
    if (strcmp(find_data.cFileName,".") && strcmp(find_data.cFileName,".."))
      AddToHintList(text,find_data.cFileName,0);
  }
  FindClose(h);
}

int PreviousDelimiterIsPoint(char *command,int linepos,char point)
{
  int x;

  for (x=linepos-1;x>=0;x--)
  {
    if (strchr(DELIMITERS,command[x]))
    {
      if (command[x]==point)
      {
        return 1;
      }
      else
      {
        return 0;
      }
    }
  }
  return 0;
}

int FindObjectAlias(char *command,int linepos,char *object_name,int point)
{
  int x,found_alias=0;

//  for (x=linepos-1;(int)x>=0;x--)'
  linepos=(int)strlen(command);
  for (x=linepos-1;x>=0;x--)
  {
    if (strchr(DELIMITERS_HINT,command[x]) && (!point || command[x]!='.'))
    {
      if (!found_alias)
      {
        if (!_strnicmp(&command[x+1],object_name,linepos-x))
          found_alias=1;
        while (strchr(DELIMITERS_HINT,command[x]) && x>0)
          x--;
      }
      else
      {
        strncpy(object_name,&command[x+1],linepos-x);
        object_name[linepos-x]='\0';
        return 1;
      }
      linepos=x;
    }
  }
  return 0;
}

void FillHintListFromObjectElement(TextWidget *text,char *command,int linepos)
{
  int x,pointpos,objectpos;
  char object_name[100]="",*object_ptr=NULL,*owner=NULL,*object_type=NULL,column_name[100]="",*tmp;

  for (x=linepos-1;(int)x>=0;x--)
  {
    if (strchr(DELIMITERS,command[x]))
    {
      if (command[x]=='.')
      {
        strncpy(column_name,&command[x+1],linepos-x-1);
        pointpos=x;
      }
      else
      {
        strncpy(object_name,&command[x+1],pointpos-x-1);
        objectpos=x;
        break;
      }
    }
  }
  if (object_name[0]!='\0')
  {
    object_ptr=object_name;
    GetUserID(object_name,&owner,&object_ptr,0);
    if (owner==NULL || owner[0]=='\0')
    {
      if (FindObjectAlias(command,objectpos,object_name,0))
        GetUserID(object_name,&owner,&object_ptr,0);
    }
    if (owner==NULL && (tmp=strchr(object_name,'.'))!=NULL)
    {
      object_ptr=_strdup(tmp+1);
      owner=_strdup(object_name);
      tmp=strchr(owner,'.');
      *tmp='\0';
    }
    if (owner!=NULL)
    {
      object_type=GetOracleObjectType(owner,object_ptr,0);
      if (object_type!=NULL)
      {
        if (!strcmp(object_type,"TABLE") || !strcmp(object_type,"VIEW"))
          FillHintListFromQuery(text,"select lower(column_name) from all_tab_columns where column_name like upper(:1)||'%' and owner=upper(:2) and table_name=upper(:3)",column_name,owner,object_ptr);
        if (!strcmp(object_type,"PACKAGE"))
          FillHintListFromQuery(text,"select distinct lower(procedure_name) from all_procedures where procedure_name like upper(:1)||'%' and owner=upper(:2) and object_name=upper(:3)",column_name,owner,object_ptr);
      }
    }
    else
    {
      FillHintListFromQuery(text,"select distinct lower(object_name) from all_objects where object_name like upper(:1)||'%' and owner=upper(:2)",column_name,object_name,NULL);
      object_ptr=NULL;
    }
  }
  if (owner)
    free(owner);
  if (object_ptr)
    free(object_ptr);
}

void FillHintListFromArguments(TextWidget *text,char *command,int linepos)
{
  int x,pointpos,objectpos,obj_ptr_alloc=0;
  char object_name[100]="",*object_ptr=NULL,*owner=NULL,*object_type=NULL,column_name[100]="",*tmp;

  for (x=linepos-1;x>=0;x--)
  {
    if (strchr(DELIMITERS,command[x]))
    {
      if (command[x]=='(' && x)
      {
        pointpos=x;
      }
      else if (command[x]=='.')
      {
        strncpy(column_name,&command[x+1],pointpos-x-1);
        pointpos=x;
      }
      else
      {
        strncpy(object_name,&command[x+1],pointpos-x-1);
        objectpos=x;
        break;
      }
    }
  }
  if (object_name[0]!='\0')
  {
    object_ptr=object_name;
    GetUserID(object_name,&owner,&object_ptr,0);
    if (owner==NULL || owner[0]=='\0')
    {
      if (FindObjectAlias(command,objectpos,object_name,0))
        GetUserID(object_name,&owner,&object_ptr,0);
    }
    if (owner==NULL && (tmp=strchr(object_name,'.'))!=NULL)
    {
      obj_ptr_alloc=1;
      object_ptr=_strdup(tmp+1);
      owner=_strdup(object_name);
      tmp=strchr(owner,'.');
      *tmp='\0';
    }
    if (owner!=NULL)
    {
      object_type=GetOracleObjectType(owner,object_ptr,0);
      if (object_type!=NULL)
      {
        if (!strcmp(object_type,"PACKAGE"))
          FillHintListFromArgumentQuery(text,"select argument_name||' '||nvl2(argument_name,in_out,'')||' '||data_type,nvl(overload,1) from all_arguments where object_name = upper(:1) and owner=upper(:2) and package_name=upper(:3) and position>0 and data_level=0 order by overload,position",column_name,owner,object_ptr);
        else if (!strcmp(object_type,"PROCEDURE") || !strcmp(object_type,"FUNCTION"))
          FillHintListFromArgumentQuery(text,"select argument_name||' '||nvl2(argument_name,in_out,'')||' '||data_type,nvl(overload,1) from all_arguments where object_name = upper(:1) and owner=upper(:2) and :3 is null and position>0 and data_level=0 order by overload,position",object_ptr,owner,"");
      }
    }
  }
  if (owner)
    free(owner);
  if (obj_ptr_alloc)
    free(object_ptr);
}

int ShowODBCColumns(TextWidget *text,int linepos)
{
  int x,pos1=-1,pos2=-1,pos3=-1,pos4=-1;
  char alias[256]="",catalog[40]="",schema[40]="",table[40]="",column[40]="";

  for (x=linepos-1;x>=0;x--)
  {
    if (pos1==-1 && command[x]=='.')
      pos1=x;
    else if (command[x]=='.')
    {
      if (pos2==-1)
        pos2=x;
      else if (pos3==-1)
        pos3=x;
    }
    else if (strchr(SQL_DELIMITERS,command[x]) && command[x]!='.')
    {
      pos4=x;
      break;
    }
  }
  if (pos4==0 || pos4==-1)
    return 1;
  strncpy(alias,&command[pos4+1],pos1-pos4-1);
  strncpy(column,&command[pos1+1],linepos-pos1-1);
  if (strchr(alias,'.')) // not an alias but a table
  {
    if (pos3!=-1)
    {
      strncpy(catalog,&command[pos4+1],pos3-pos4-1);
      strncpy(schema,&command[pos3+1],pos2-pos3-1);
      strncpy(table,&command[pos2+1],pos1-pos2-1);
    }
    else if (pos2!=-1)
    {
      strcpy(catalog,"");
      strncpy(schema,&command[pos4+1],pos2-pos4-1);
      strncpy(table,&command[pos2+1],pos1-pos2-1);
    }
    else if (pos1!=-1)
    {
      strcpy(catalog,"");
      strcpy(schema,"");
      strncpy(table,&command[pos4+1],pos1-pos4-1);
    }
  }
  else
  {
    if (FindObjectAlias(command,linepos,alias,1))
    {
      x=sscanf(alias,"%[^.].%[^.].%s",catalog,schema,table);
      switch (x)
      {
        case 1:
          strcpy(table,catalog);
          strcpy(catalog,"");
          strcpy(schema,"");
          break;
        case 2:
          strcpy(table,schema);
          strcpy(schema,catalog);
          strcpy(catalog,"");
          break;
        case 0:
          return 1;
      }
    }
  }
  return ODBC_FillColumnsHintList(text,catalog,schema,table,column);
}

int ShowHint(TextWidget *text,char *command,int linepos)
{
  char *lastword,*firstword,*secondword;
  int lastknowntoken;

  if (text->hintlist)
  {
    DestroyHintList(text);
  }
  if (command[0]=='@')
  {
    if ((int)strlen(command)>1 && command[1]=='"')
      start_of_dir=2;
    else
      start_of_dir=1;
    lastword=FindLastDirectory(command,linepos);
    SetCursor(LoadCursor(NULL, IDC_WAIT));
    ShowHintList(text);
    FillHintListFromDirectory(text,command,linepos-(int)strlen(lastword),lastword);
    SetCursor(LoadCursor(NULL, IDC_ARROW));
  }
  else if (!_strnicmp(command,"spool ",6) || !_strnicmp(command,"start ",6))
  {
    if ((int)strlen(command)>1 && command[6]=='"')
      start_of_dir=7;
    else
      start_of_dir=6;
    lastword=FindLastDirectory(command,linepos);
    SetCursor(LoadCursor(NULL, IDC_WAIT));
    ShowHintList(text);
    FillHintListFromDirectory(text,command,linepos-(int)strlen(lastword),lastword);
    SetCursor(LoadCursor(NULL, IDC_ARROW));
  }
  else if (linepos && PreviousDelimiterIsPoint(command,linepos,'.'))
  {
    if (ora_connected)
    {
      SetCursor(LoadCursor(NULL, IDC_WAIT));
      ShowHintList(text);
      FillHintListFromObjectElement(text,command,linepos);
      SetCursor(LoadCursor(NULL, IDC_ARROW));
    }
    else
    {
      firstword=FindFirstWord(command,linepos);
      secondword=FindSecondWord(command,linepos);
      lastword=FindLastWord(command,linepos,1);
      lastknowntoken=FindLastKnownODBCToken(command,linepos-(int)strlen(lastword));
      if (lastknowntoken==-1)
      {
        return 0;
      }
      else
      {
        SetCursor(LoadCursor(NULL, IDC_WAIT));
        ShowHintList(text);
        if (odbc_tokens[lastknowntoken].queries & OT_TABLES)
          ODBC_FillTablesHintList(text,firstword,secondword,lastword);
        if (odbc_tokens[lastknowntoken].queries & OT_COLUMNS)
        {
          ShowODBCColumns(text,linepos);
        }
        SetCursor(LoadCursor(NULL, IDC_ARROW));
      }
    }
  }
  else if (linepos && PreviousDelimiterIsPoint(command,linepos,'('))
  {
    if (ora_connected)
    {
      SetCursor(LoadCursor(NULL, IDC_WAIT));
      ShowHintList(text);
      FillHintListFromArguments(text,command,linepos);
      SetCursor(LoadCursor(NULL, IDC_ARROW));
    }
  }
  else
  {
    if (ora_connected)
    {
      lastword=FindLastWord(command,linepos,0);
      if (lastword[0]=='\0')
        return 0;
      lastknowntoken=FindLastKnownToken(command,linepos-(int)strlen(lastword));
      if (lastknowntoken==-1)
      {
        return 0;
      }
      else
      {
        SetCursor(LoadCursor(NULL, IDC_WAIT));
        ShowHintList(text);
        if (sql_tokens[lastknowntoken].query!=NULL)
          FillHintListFromQuery(text,sql_tokens[lastknowntoken].query,lastword,NULL,NULL);
        if (sql_tokens[lastknowntoken].values!=NULL)
          FillHintListFromValues(text,sql_tokens[lastknowntoken].values,lastword);
        SetCursor(LoadCursor(NULL, IDC_ARROW));
      }
    }
    else if (odbc_connected)
    {
      lastword=FindLastWord(command,linepos,0);
      if (lastword[0]=='\0')
        return 0;
      lastknowntoken=FindLastKnownODBCToken(command,linepos-(int)strlen(lastword));
      if (lastknowntoken==-1)
      {
        return 0;
      }
      else
      {
        SetCursor(LoadCursor(NULL, IDC_WAIT));
        ShowHintList(text);
        if (odbc_tokens[lastknowntoken].queries & OT_TABLES)
          ODBC_FillTablesHintList(text,"","",lastword);
        if (odbc_tokens[lastknowntoken].queries & OT_COLUMNS)
          ODBC_FillColumnsHintList(text,"","","",lastword);
        SetCursor(LoadCursor(NULL, IDC_ARROW));
      }
    }
  }
  return SetHintListSize(text,linepos);
}

void SelectFromHint(TextWidget *text,int linepos)
{
  int sel,len;
  char *selection;

  if (command[0]=='@')
  {
    while (linepos>0 && strchr("\\@:\"",command[linepos-1])==NULL)
    {
      InsertLineBuffer(text,"%c",8);
      linepos--;
    }
  }
  else if (!_strnicmp(command,"spool ",6) || !_strnicmp(command,"start ",6))
  {
    while (linepos>5 && strchr("\\@:\"",command[linepos-1])==NULL)
    {
      InsertLineBuffer(text,"%c",8);
      linepos--;
    }
  }
  else
  {
    while (linepos>0 && strchr(SQL_DELIMITERS,command[linepos-1])==NULL)
    {
      InsertLineBuffer(text,"%c",8);
      linepos--;
    }
  }
  sel=(int)SendMessage(text->hintlist,LB_GETCURSEL,0,0);
  if (sel!=LB_ERR)
  {
    len=(int)SendMessage(text->hintlist,LB_GETTEXTLEN,sel,0);
    selection=(char*)malloc(len+1);
    SendMessage(text->hintlist,LB_GETTEXT,sel,(LPARAM)selection);
    if ((command[0]=='@' || !_strnicmp(command,"spool ",6) || !_strnicmp(command,"start ",6)) && linepos && command[linepos-1]==':')
      InsertLineBuffer(text,"\\%s",selection);
    else if (command[0]!='@' && _strnicmp(command,"spool ",6) && _strnicmp(command,"start ",6) && (linepos>=(int)strlen(command) || strchr(" \t\n\r",command[linepos])==NULL))
      InsertLineBuffer(text,"%s ",selection);
    else
      InsertUnparsedLineBuffer(text,selection);
    free(selection);
  }
  DestroyHintList(text);
}

