#include "jbsql.h"
#include "xml.h"

#ifndef __JBOCI_H__
#define __JBOCI_H__

#define ChkOCIErr(S) CheckOCIError(g_oci, S,__FILE__,__LINE__,1,0,NULL)
#define ChkOCIErr2(S) CheckOCIError(g_oci, S,__FILE__,__LINE__,2,0,NULL)
#define ChkOCIErrS(S) CheckOCIError(g_oci, S,__FILE__,__LINE__,3,0,hWnd)
#define ChkOCIErrN(S) CheckOCIError(g_oci, S,__FILE__,__LINE__,0,0,NULL)
#define ChkOCIErrI(S,E) CheckOCIError(g_oci, S,__FILE__,__LINE__,1,E,NULL)

#define SCHEMA_ARRAY_SIZE 1000
#define SOURCE_SIZE 4001

typedef struct {
    OCIEnv            *envhp;
    OCIServer         *srvhp;
    OCIError          *errhp;
    OCISvcCtx         *svchp;
    OCISession        *usrhp;
    OCIStmt           *stmtp;
    int               offset;
    OraText           **varnames;
    int               nvarnames;
	int               interactive;
  } OCIEnvironment;

extern OCIEnvironment *g_oci;


int CheckOCIError(OCIEnvironment *g_oci,sword status,char *file,int line,int show,ub4 ignore_code,HWND hWnd);
extern int query_finished;
extern int g_sid, g_instance;

// Load this dynamically to avoid oracle version dependency
typedef ubig_ora (*XmlSaveDomFunc)(xmlctx *xctx, xmlerr *err, xmlnode *root, ...);

extern XmlSaveDomFunc MyXmlSaveDom;

int ConnectToOracleInternal(OCIEnvironment **g_oci, char *username, char *password, char *database, char *connect_as, int add, int interactive);
int ConnectWithConnectStringInternal(char *connectstring, int add, int interactive, OCIEnvironment **oci);
int InitOCI(OCIEnvironment **oci);
int DisconnectFromOracleInternal(OCIEnvironment **oci);
int GetSingleValue(OCIEnvironment *g_oci,char *query, char *target, int target_size);
int ProcessQuery(OCIEnvironment* g_oci, HWND hWnd, char* query, QueryProc do_function, size_t len, ...); // Variable number of bind vars, last one must be NULL
void FillListBoxFromQuery(OCIEnvironment* g_oci, HWND hWnd, char* query, char** bindvar, int nbindvars, int listbox, int len);



#endif