#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "jboci.h"

int ora_connected = 0;
OCIEnvironment *g_oci = NULL;
char connectstring[MAX_PATH] = "", g_database[250] = "";
OCIServerReleaseFunc MyOCIServerRelease = NULL;
int g_oci_available = 0;
int g_sid, g_instance;

void ComposeConnectString(char *username, char *password, char *database, char *connect_as, char *datasource)
{
	if (username[0] == '\0' && password[0] == '\0')
		strcpy(connectstring, "/");
	else
	{
		strcpy(connectstring, username);
		strcat(connectstring, "/");
		strcat(connectstring, password);
	}
	if (database[0] != '\0')
	{
		strcat(connectstring, "@");
		strcat(connectstring, datasource);
		strcat(connectstring, ":");
		strcat(connectstring, database);
	}
	if (connect_as[0] != '\0')
	{
		strcat(connectstring, " as ");
		strcat(connectstring, connect_as);
	}
}

int CheckOCIError(OCIEnvironment *g_oci, sword status, char *file, int line, int show, ub4 ignore_code, HWND hWnd)
{
	text errbuf[512];
	sb4 errcode = 1;
	ub2 offset;

	if (!g_oci->interactive)
		show = 0;
	switch (status)
	{
		case OCI_SUCCESS:
			return 0;
			break;
		case OCI_SUCCESS_WITH_INFO:
			OCIErrorGet(g_oci->errhp,
				1,
				NULL,
				&errcode,
				errbuf,
				sizeof(errbuf),
				OCI_HTYPE_ERROR);
			if (show == 1)
			{
				if (errcode == 24344)
					WPrintf("\rTHERE ARE COMPILATION ERRORS\n");
				else
					WPrintf("\rSuccess with warnings, %s\n", errbuf);
			}
			else if (show == 2)
			{
				if (errcode == 24344)
					AnalyzeError("THERE ARE COMPILATION ERRORS");
				else
					AnalyzeError("Success with warnings, %s", errbuf);
			}
			else if (show == 3)
			{
				if (errcode == 24344)
					SchemaPrintf(hWnd, "THERE ARE COMPILATION ERRORS");
				else
					SchemaPrintf(hWnd, "Success with warnings, %s", errbuf);
			}
			else
			{
				if (errcode == 24344)
					Log("THERE ARE COMPILATION ERRORS\n");
				else
					Log("Success with warnings, %s\n", errbuf);
			}
			return 0;
			break;
		case OCI_NEED_DATA:
			if (show == 1)
				WPrintf("\rError - OCI_NEED_DATA (%s, line %d)\n", file, line);
			else if (show == 2)
				AnalyzeError("Error - OCI_NEED_DATA (%s, line %d)", file, line);
			else if (show == 3)
				SchemaPrintf(hWnd, "Error - OCI_NEED_DATA (%s, line %d)", file, line);
			else
				Log("Error - OCI_NEED_DATA (%s, line %d)\n", file, line);
			break;
		case OCI_NO_DATA:
			/*      if (show==1)
					WPrintf("\rError - OCI_NODATA (%s, line %d)\n",file,line);
				  else if (show==2)
					AnalyzeError("Error - OCI_NODATA (%s, line %d)",file,line);
				  else if (show==3)
					SchemaPrintf(hWnd,"Error - OCI_NODATA (%s, line %d)",file,line);
				  break;*/
		case OCI_ERROR:
			if (g_oci->errhp != NULL)
			{
				OCIErrorGet(g_oci->errhp,
					1,
					NULL,
					&errcode,
					errbuf,
					sizeof(errbuf),
					OCI_HTYPE_ERROR);
				if (ignore_code == errcode)
					return 0;
				if (g_oci->offset)
				{
					g_oci->offset = 0;
					if (!ChkOCIErr(OCIAttrGet(g_oci->stmtp,
						OCI_HTYPE_STMT,
						&offset,
						NULL,
						OCI_ATTR_PARSE_ERROR_OFFSET,
						g_oci->errhp)))
					{
						if (show==1)
							PrintErrorCharacter(offset);
					}
				}
				if (show == 1)
				{
					Log("%s - OCI_ERROR (%s, line %d)\n", errbuf, file, line);
					WPrintf("\r%s\n", errbuf);
				}
				else if (show == 2)
					AnalyzeError("%s", errbuf);
				else if (show == 3)
					SchemaPrintf(hWnd, "%s", errbuf);
				else
					Log("%s - OCI_ERROR (%s, line %d)\n", errbuf, file, line);
			}
			else
			{
				if (show == 1)
					WPrintf("Error - OCI_ERROR (%s, line %d)\n", file, line);
				if (show == 2)
					AnalyzeError("Error - OCI_ERROR (%s, line %d)", file, line);
				if (show == 3)
					SchemaPrintf(hWnd, "Error - OCI_ERROR (%s, line %d)", file, line);
				else
					Log("Error - OCI_ERROR (%s, line %d)\n", file, line);
			}
			break;
		case OCI_INVALID_HANDLE:
			if (show == 1)
				WPrintf("Error - OCI_INVALID_HANDLE (%s, line %d)\n", file, line);
			else if (show == 2)
				AnalyzeError("Error - OCI_INVALID_HANDLE (%s, line %d)", file, line);
			else if (show == 3)
				SchemaPrintf(hWnd, "Error - OCI_INVALID_HANDLE (%s, line %d)", file, line);
			else
				Log("Error - OCI_INVALID_HANDLE (%s, line %d)\n", file, line);
			break;
		case OCI_STILL_EXECUTING:
			if (show == 1)
				WPrintf("Error - OCI_STILL_EXECUTE (%s, line %d)\n", file, line);
			else if (show == 2)
				AnalyzeError("Error - OCI_STILL_EXECUTE (%s, line %d)\n", file, line);
			else if (show == 3)
				SchemaPrintf(hWnd, "Error - OCI_STILL_EXECUTE (%s, line %d)\n", file, line);
			else
				Log("Error - OCI_STILL_EXECUTE (%s, line %d)\n", file, line);
			break;
		default:
			break;
	}
	return errcode;
}


int InitOCI(OCIEnvironment **oci)
{
	OCIEnvironment *g_oci;

	if (!g_oci_available)
		return -2;
	g_oci = malloc(sizeof(OCIEnvironment));
	if (g_oci == NULL)
		return -1;
	memset(g_oci, 0, sizeof(OCIEnvironment));
	g_oci->interactive = 1;

	/*  if (ChkOCIErr(OCIEnvCreate(&g_oci->envhp,
								 OCI_THREADED|OCI_OBJECT,
								 NULL,
								 NULL,
								 NULL,
								 0,
								 NULL)))
	  {
		return -1;
	  }
	*/
	if (ChkOCIErr(OCIInitialize(OCI_THREADED | OCI_OBJECT,
		NULL,
		NULL,
		NULL,
		NULL)))
	{
		return -1;
	}

	if (ChkOCIErr(OCIEnvInit(&g_oci->envhp,
		OCI_DEFAULT,
		0,
		NULL)))
	{
		return -1;
	}

	if (ChkOCIErr(OCIHandleAlloc(g_oci->envhp,
		&g_oci->srvhp,
		OCI_HTYPE_SERVER,
		0,
		NULL)))
	{
		return -2;
	}

	if (ChkOCIErr(OCIHandleAlloc(g_oci->envhp,
		&g_oci->errhp,
		OCI_HTYPE_ERROR,
		0,
		NULL)))
	{
		return -3;
	}
	*oci = g_oci;
	return 0;
}

int GetSid(void)
{
	char *str1 = "select sys_context('USERENV','SID'),sys_context('USERENV','INSTANCE') from dual";
	int sid;
	int instance;
	int result;
	OCIBind *bndhp = NULL;
	OCIDefine *defhp = NULL;

	if (ChkOCIErrN(OCIHandleAlloc(g_oci->envhp,
		&g_oci->stmtp,
		OCI_HTYPE_STMT,
		0,
		NULL)))
	{
		return 0;
	}
	if (ChkOCIErrN(OCIStmtPrepare(g_oci->stmtp,
		g_oci->errhp,
		str1,
		(ub4)strlen(str1),
		OCI_NTV_SYNTAX,
		OCI_DEFAULT)))
	{
		OCIHandleFree(g_oci->stmtp, OCI_HTYPE_STMT);
		g_oci->stmtp = NULL;
		return 0;
	}
	if (ChkOCIErrN(OCIDefineByPos(g_oci->stmtp,
		&defhp,
		g_oci->errhp,
		1,
		&sid,
		sizeof(sid),
		SQLT_INT,
		NULL,
		NULL,
		NULL,
		OCI_DEFAULT)))
	{
		OCIHandleFree(g_oci->stmtp, OCI_HTYPE_STMT);
		g_oci->stmtp = NULL;
		return 0;
	}
	if (ChkOCIErrN(OCIDefineByPos(g_oci->stmtp,
		&defhp,
		g_oci->errhp,
		2,
		&instance,
		sizeof(instance),
		SQLT_INT,
		NULL,
		NULL,
		NULL,
		OCI_DEFAULT)))
	{
		OCIHandleFree(g_oci->stmtp, OCI_HTYPE_STMT);
		g_oci->stmtp = NULL;
		return 0;
	}
	g_oci->offset = 1;
	result = OCIStmtExecute(g_oci->svchp,
		g_oci->stmtp,
		g_oci->errhp,
		1,
		0,
		NULL,
		NULL,
		OCI_DEFAULT);
	if (result != OCI_SUCCESS && result != OCI_NO_DATA)
	{
		g_oci->offset = 0;
		OCIHandleFree(g_oci->stmtp, OCI_HTYPE_STMT);
		g_oci->stmtp = NULL;
		return 0;
	}
	g_oci->offset = 0;
	OCIHandleFree(g_oci->stmtp, OCI_HTYPE_STMT);
	g_oci->stmtp = NULL;
	g_sid = sid;
	g_instance = instance;
	return 1;
}

int OCI_SetConnected(char *username, char *password, char *database, char *connect_as, int add)
{
	char buffer[512];

	ora_connected = 1;
	odbc_connected = 0;
	if (!ChkOCIErr(OCIServerVersion(g_oci->svchp,
		g_oci->errhp,
		buffer,
		512,
		OCI_HTYPE_SVCCTX)))
	{
		WPrintf("\rConnected to:\n%s\n", buffer);
	}
	else
		WPrintf("\rConnected\n");
	strcpy(g_database, database);
	GetSid();
	SetWindowTitle(username, database, g_instance, g_sid);
	ComposeConnectString(username, password, database, connect_as, "oracle");
	strncpy(g_text->username, username, 100);
	_strupr(g_text->username);
	strncpy(g_text->database, database, 200);
	_strupr(g_text->database);
	strcpy(g_text->privilege, connect_as);
	_strupr(g_text->privilege);
	g_text->server_version = OCIGetServerVersion();
	g_text->server_release = OCIGetServerRelease();
	ClearCommand(g_text, add, 0);
	GetDefaultOptions(g_text);
	SetPWD(g_text);
	return 0;
}

int ConnectToOracleInternal(OCIEnvironment **oci,char *username, char *password, char *database, char *connect_as, int add, int interactive)
{
	char new_database[512], host[50], port[50], sid[50];
	ub4 mode, credentials, ret;
	OCIEnvironment *g_oci=*oci;

	if (interactive)
	{
        if (odbc_connected)
        {
            ClearList(hwndListView,1);
            DisconnectFromODBC();
        }
		if (ora_connected)
			DisconnectFromOracle();
		if (InitOCI(oci))
		{
			MessageBox(NULL, "Failed to initialize OCI, check your ORACLE_HOME and PATH", "OCI error", MB_OK | MB_ICONERROR);
			return 1;
		}
		g_oci = *oci;
	}
	if (connect_as == NULL || connect_as[0] == '\0')
		mode = OCI_DEFAULT;
	else if (!_stricmp(connect_as, "normal"))
		mode = OCI_DEFAULT;
	else if (!_stricmp(connect_as, "sysoper"))
		mode = OCI_SYSOPER;
	else if (!_stricmp(connect_as, "sysdba"))
		mode = OCI_SYSDBA;
	else
	{
		if (interactive)	
			WPrintf("Invalid connect mode %s\n", connect_as);
		else
			Log("Invalid connect mode %s\n", connect_as);
		return 1;
	}

	if (!strchr(database, ':'))
		strcpy(new_database, database);
	else
	{
		if (sscanf(database, "%[^:]:%[^/]/%s", host, port, sid) == 3)
		{
			sprintf(new_database, "(DESCRIPTION=(ADDRESS_LIST=(ADDRESS=(PROTOCOL=TCP)(HOST=%s)(PORT=%s)))(CONNECT_DATA=(SERVICE_NAME=%s)))", host, port, sid);
		}
		else if (sscanf(database, "%[^/]/%s", host, sid) == 2)
		{
			sprintf(new_database, "(DESCRIPTION=(ADDRESS_LIST=(ADDRESS=(PROTOCOL=TCP)(HOST=%s)(PORT=1521)))(CONNECT_DATA=(SERVICE_NAME=%s)))", host, sid);
		}
		else
		{
			switch (sscanf(database, "%[^:]:%[^:]:%s", host, port, sid))
			{
				case 3:
					sprintf(new_database, "(DESCRIPTION=(ADDRESS_LIST=(ADDRESS=(PROTOCOL=TCP)(HOST=%s)(PORT=%s)))(CONNECT_DATA=(SID=%s)))", host, port, sid);
					break;
				case 2:
					if (atoi(port) == 0)
						sprintf(new_database, "(DESCRIPTION=(ADDRESS_LIST=(ADDRESS=(PROTOCOL=TCP)(HOST=%s)(PORT=1521)))(CONNECT_DATA=(SID=%s)))", host, port);
					else
						sprintf(new_database, "(DESCRIPTION=(ADDRESS_LIST=(ADDRESS=(PROTOCOL=TCP)(HOST=%s)(PORT=%s)))(CONNECT_DATA=(SID=ORCL)))", host, port);
					break;
				default:
					strcpy(new_database, database);
					break;
			}
		}
	}
	if (interactive)
		SaveUserCredentials(username, database, DS_ORACLE);
	if (ChkOCIErr(OCIServerAttach(g_oci->srvhp,
		g_oci->errhp,
		new_database,
		(ub4)strlen(new_database),
		OCI_DEFAULT)))
	{
		return -1;
	}

	if (ChkOCIErr(OCIHandleAlloc(g_oci->envhp,
		&g_oci->svchp,
		OCI_HTYPE_SVCCTX,
		0,
		NULL)))
	{
		OCIServerDetach(g_oci->srvhp,
			g_oci->errhp,
			OCI_DEFAULT);
		return -2;
	}

	if (ChkOCIErr(OCIAttrSet(g_oci->svchp,
		OCI_HTYPE_SVCCTX,
		g_oci->srvhp,
		0,
		OCI_ATTR_SERVER,
		g_oci->errhp)))
	{
		OCIServerDetach(g_oci->srvhp,
			g_oci->errhp,
			OCI_DEFAULT);
		OCIHandleFree(g_oci->svchp, OCI_HTYPE_SVCCTX);
		g_oci->svchp = NULL;
		return -3;
	}

	if (ChkOCIErr(OCIHandleAlloc(g_oci->envhp,
		&g_oci->usrhp,
		OCI_HTYPE_SESSION,
		0,
		NULL)))
	{
		OCIServerDetach(g_oci->srvhp,
			g_oci->errhp,
			OCI_DEFAULT);
		OCIHandleFree(g_oci->svchp, OCI_HTYPE_SVCCTX);
		g_oci->svchp = NULL;
		return -4;
	}
	if (strcmp(username, "/") && (int)strlen(password) > 0)
	{
		if (ChkOCIErr(OCIAttrSet(g_oci->usrhp,
			OCI_HTYPE_SESSION,
			username,
			(ub4)strlen(username),
			OCI_ATTR_USERNAME,
			g_oci->errhp)))
		{
			OCIServerDetach(g_oci->srvhp,
				g_oci->errhp,
				OCI_DEFAULT);
			OCIHandleFree(g_oci->svchp, OCI_HTYPE_SVCCTX);
			g_oci->svchp = NULL;
			OCIHandleFree(g_oci->usrhp, OCI_HTYPE_SESSION);
			g_oci->usrhp = NULL;
			return -5;
		}

		if (ChkOCIErr(OCIAttrSet(g_oci->usrhp,
			OCI_HTYPE_SESSION,
			password,
			(ub4)strlen(password),
			OCI_ATTR_PASSWORD,
			g_oci->errhp)))
		{
			OCIServerDetach(g_oci->srvhp,
				g_oci->errhp,
				OCI_DEFAULT);
			OCIHandleFree(g_oci->svchp, OCI_HTYPE_SVCCTX);
			g_oci->svchp = NULL;
			OCIHandleFree(g_oci->usrhp, OCI_HTYPE_SESSION);
			g_oci->usrhp = NULL;
			return -6;
		}
		credentials = OCI_CRED_RDBMS;
	}
	else
	{
		credentials = OCI_CRED_EXT;
	}
	if (ChkOCIErr(OCIAttrSet(g_oci->svchp,
		OCI_HTYPE_SVCCTX,
		g_oci->usrhp,
		0,
		OCI_ATTR_SESSION,
		g_oci->errhp)))
	{
		OCISessionEnd(g_oci->svchp,
			g_oci->errhp,
			g_oci->usrhp,
			OCI_DEFAULT);
		OCIServerDetach(g_oci->srvhp,
			g_oci->errhp,
			OCI_DEFAULT);
		OCIHandleFree(g_oci->svchp, OCI_HTYPE_SVCCTX);
		g_oci->svchp = NULL;
		OCIHandleFree(g_oci->usrhp, OCI_HTYPE_SESSION);
		g_oci->usrhp = NULL;
		return -7;
	}
	ret = ChkOCIErr(OCISessionBegin(g_oci->svchp,
		g_oci->errhp,
		g_oci->usrhp,
		credentials,
		mode));
	if (ret)
	{
		if (ret == 28001)
			return 28001;
		else
			ret = -7;
		OCISessionEnd(g_oci->svchp,
			g_oci->errhp,
			g_oci->usrhp,
			OCI_DEFAULT);
		OCIServerDetach(g_oci->srvhp,
			g_oci->errhp,
			OCI_DEFAULT);
		OCIHandleFree(g_oci->svchp, OCI_HTYPE_SVCCTX);
		g_oci->svchp = NULL;
		OCIHandleFree(g_oci->usrhp, OCI_HTYPE_SESSION);
		g_oci->usrhp = NULL;
		return ret;
	}
	if (interactive)		
		OCI_SetConnected(username, password, database, connect_as, add);
	return 0;
}


int ConnectToOracle(char *username, char *password, char *database, char *connect_as, int add)
{
	return ConnectToOracleInternal(&g_oci, username, password, database, connect_as, add, 1);
}

int OCI_DisconnectServer()
{
	OCISessionEnd(g_oci->svchp,
		g_oci->errhp,
		g_oci->usrhp,
		OCI_DEFAULT);
	OCIServerDetach(g_oci->srvhp,
		g_oci->errhp,
		OCI_DEFAULT);
	OCIHandleFree(g_oci->svchp, OCI_HTYPE_SVCCTX);
	g_oci->svchp = NULL;
	OCIHandleFree(g_oci->usrhp, OCI_HTYPE_SESSION);
	g_oci->usrhp = NULL;
	return 0;
}

int ChangePassword(char *username, char *password, char *new_password, char *database, char *connect_as, int add)
{
	if (ChkOCIErr(OCIPasswordChange(g_oci->svchp, g_oci->errhp, (const oratext*)username, (ub4)strlen(username), (const oratext*)password, (ub4)strlen(password), (const oratext*)new_password, (ub4)strlen(new_password), OCI_AUTH)))
	{
		return 1;
	}
	OCI_SetConnected(username, password, database, connect_as, add);
	return 0;
}

int DisconnectFromOracleInternal(OCIEnvironment **oci)
{
	OCIEnvironment *g_oci = *oci;

	OCISessionEnd(g_oci->svchp,
		g_oci->errhp,
		g_oci->usrhp,
		OCI_DEFAULT);
	OCIServerDetach(g_oci->srvhp,
		g_oci->errhp,
		OCI_DEFAULT);
	OCIHandleFree(g_oci->svchp, OCI_HTYPE_SVCCTX);
	g_oci->svchp = NULL;
	OCIHandleFree(g_oci->usrhp, OCI_HTYPE_SESSION);
	g_oci->usrhp = NULL;
	OCIHandleFree(g_oci->envhp, OCI_HTYPE_SESSION);
	OCIHandleFree(g_oci->errhp, OCI_HTYPE_SESSION);
	OCIHandleFree(g_oci->srvhp, OCI_HTYPE_SESSION);

	if (g_oci->interactive)
	{
		ora_connected = 0;
		g_text->username[0] = '\0';
		g_text->database[0] = '\0';
		g_text->privilege[0] = '\0';
		g_text->server_version = NULL;
		g_text->server_release = NULL;

		InitOCI(oci);
	}
	return 0;
}

int DisconnectFromOracle(void)
{
    extern int stop_sqlmon;

	SetWindowTitle("", "", 0, 0);
    if (stop_sqlmon == 0)
    {
        SendMessage(g_text->sqlmonitor, WM_CLOSE, 0, 0);
            
        while (stop_sqlmon != -1)
        {
            Sleep(100);
        }
    }
    DisconnectFromOracleInternal(&g_oci);
    return 0;
}

int ConnectWithConnectStringInternal(char *connectstring, int add, int interactive, OCIEnvironment **oci)
{
	char *tmp, *tmp2;
	char username[100] = "", password[100] = "", database[512] = "", connect_as[20] = "", new_password[100], new_password2[100];
	char **argv;
	int argc, x, ret;
	OCIEnvironment *g_oci;

	ConvertCommandLine(connectstring, &argc, &argv);
	tmp = strchr(argv[0], '/');
	if (tmp != NULL)
	{
		*tmp = '\0';
		strncpy(username, argv[0], 100);
		if (username[0] == '\0')
			strncpy(username, "/", 100);
		tmp2 = tmp;
		tmp2++;
		tmp = strchr(tmp2, '@');
		if (tmp != NULL)
		{
			*tmp = '\0';
			strncpy(password, tmp2, 100);
			tmp2 = tmp;
			tmp2++;
			strncpy(database, tmp2, 512);
		}
		else
		{
			strncpy(password, tmp2, 100);
		}
	}
	else
	{
		tmp = strchr(argv[0], '@');
		if (tmp != NULL)
		{
			*tmp = '\0';
			strncpy(username, argv[0], 100);
			if (username[0] == '\0')
				strcpy(username, "/");
			tmp++;
			strncpy(database, tmp, 512);
		}
		else
		{
			strncpy(username, argv[0], 100);
		}
	}
	if (argc == 3)
	{
		if (!_stricmp(argv[1], "as"))
		{
			strncpy(connect_as, argv[2], 20);
			_snprintf(g_text->privilege, 12, "AS %s", connect_as);
			_strupr(g_text->privilege);
		}
		else
			return 1;
	}
	else
		g_text->privilege[0] = '\0';
	for (x = 0; x < argc; x++)
		free(argv[x]);
	free(argv);
	if (_stricmp(username, "internal") && _stricmp(username, "/") && password[0] == '\0')
	{
		if (interactive)
		{
			WPrintf("Enter password: ");
			WScanf(g_text, password, 1);
		}
		else
			Log("No password given\n");
	}
	if (!_strnicmp(database, "ODBC:", 5))
	{
		g_text->datasource = DS_ODBC;
		memmove(database, &database[5], strlen(database) - 4);
		return ConnectToODBC(username, password, database, add);
	}
	if (!_strnicmp(database, "ORACLE:", 7))
	{
		memmove(database, &database[7], strlen(database) - 6);
	}
	g_text->datasource = DS_ORACLE;
	ret = ConnectToOracleInternal(oci, username, password, database, connect_as, add, interactive);
	g_oci = *oci;
	g_oci->interactive = interactive;
	if (ret == 28001) // password expired
	{
		if (interactive)
		{
			while (ret)
			{
				WPrintf("\nEnter new password: ");
				WScanf(g_text, new_password, 1);
				if (new_password[0] == '\0')
					WPrintf("Password cannot be null\n");
				else
				{
					WPrintf("Confirm new password: ");
					WScanf(g_text, new_password2, 1);
					if (strcmp(new_password, new_password2))
						WPrintf("Passwords do not match\n");
					else
						ret = ChangePassword(username, password, new_password, database, connect_as, add);
				}
			}
		}
		else
			Log("Password is expired");
	}
	return ret;
}

int ConnectWithConnectString(char *connectstring, int add)
{
	return ConnectWithConnectStringInternal(connectstring, add, 1, &g_oci);
}

typedef sword(*OCIClientVersionFunc) (sword        *major_version,
	sword        *minor_version,
	sword        *update_num,
	sword        *patch_num,
	sword        *port_update_num);


void GetXMLFunctions(void)
{
	HMODULE module, xmlmodule;
	char oci_full_path[MAX_PATH], *pos;
	WIN32_FIND_DATA find_data;
	HANDLE h;

	module = LoadLibrary("oci.dll");
	if (module)
	{
		if (GetModuleFileName(module, oci_full_path, MAX_PATH))
		{
			pos = strrchr(oci_full_path, '\\');
			if (pos)
			{
				*pos = '\0';
				strcat(oci_full_path, "\\oraxml*.dll");
				if ((h = FindFirstFile(oci_full_path, &find_data)) != INVALID_HANDLE_VALUE)
				{
					xmlmodule = LoadLibrary(find_data.cFileName);
					if (xmlmodule)
					{
						MyXmlSaveDom = (XmlSaveDomFunc)GetProcAddress(xmlmodule, "XmlSaveDom");
						//FreeLibrary(xmlmodule);
					}
				}
			}
		}

		//FreeLibrary(module);
	}
}

typedef sword(*OCIClientVersionFunc) (sword        *major_version,
	sword        *minor_version,
	sword        *update_num,
	sword        *patch_num,
	sword        *port_update_num);

void PrintOCIVersion(void)
{
	sword major, minor, update, patch, port;
	static HMODULE module = NULL;
	OCIClientVersionFunc GetOCIClientVersion;

	module = LoadLibrary("oci.dll");
	if (module)
	{
		g_oci_available = 1;
		GetOCIClientVersion = (OCIClientVersionFunc)GetProcAddress(module, "OCIClientVersion");
		if (GetOCIClientVersion)
		{
			GetOCIClientVersion(&major, &minor, &update, &patch, &port);
			WPrintf("OCI version %d.%d.%d.%d.%d\n", (int)major, (int)minor, (int)update, (int)patch, (int)port);
		}
		MyOCIServerRelease = (OCIServerReleaseFunc)GetProcAddress(module, "OCIServerRelease");
	}
}