#include "jboci.h"

int PrintServerOutput(TextWidget *text,int fast)
{
  char sqlstr[]="begin dbms_output.get_line(:1,:2); end;";
  OCIStmt *stmtp;
  OCIBind *bndhp=NULL;
  char *line;
  int status;
  ub2 ind1,ind2;

  if (!ora_connected)
  {
    return -1;
  }
  if (ChkOCIErr(OCIHandleAlloc(g_oci->envhp, 
                               &stmtp,
                               OCI_HTYPE_STMT, 
                               0, 
                               NULL)))
  {
    return -1;
  }
  if (ChkOCIErr(OCIStmtPrepare(stmtp,
                               g_oci->errhp,
                               sqlstr,
                               (ub4)strlen(sqlstr),
                               OCI_NTV_SYNTAX,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -2;
  }
  line = malloc(32768);
  if (ChkOCIErr(OCIBindByPos(stmtp,
                             &bndhp,
                             g_oci->errhp,
                             1,
                             line,
                             32768,
                             SQLT_STR,
                             &ind1,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
	free(line);
    return -2;
  }
  if (ChkOCIErr(OCIBindByPos(stmtp,
                             &bndhp,
                             g_oci->errhp,
                             2,
                             &status,
                             sizeof(int),
                             SQLT_INT,
                             &ind2,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
	free(line);
	return -2;
  }
  if (fast)
    StartFastDraw(text,1);
  for (;;)
  {
    if (ChkOCIErr(OCIStmtExecute(g_oci->svchp,
                                 stmtp,
                                 g_oci->errhp,
                                 1,
                                 0,
                                 NULL,
                                 NULL,
                                 OCI_DEFAULT)))
    {
      OCIHandleFree(stmtp,OCI_HTYPE_STMT);
      EndFastDraw(text);
	  free(line);
	  return -2;
    }
    if (status!=0)
      break;
    line[32767]='\0';
    WPrintf("%s\n",line);
  }
  if (fast)
    EndFastDraw(text);
  OCIHandleFree(stmtp,OCI_HTYPE_STMT);
  free(line);
  return 0;
}
