#include "jbodbc.h"

int ODBC_DescribeTable(TextWidget* text, char* catalog, char* schema, char* table)
{
    SQLRETURN ret;
    ExecuteStruct* es;
    int old_arraysize = INT_OPTION(ARRAYSIZE);

    ret = SQLAllocHandle(SQL_HANDLE_STMT, g_odbc->dbc_handle_source, &g_odbc->stmt_handle_source);
    if (ret == SQL_INVALID_HANDLE || ret == SQL_ERROR)
    {
        ChkODBCErr(ret, SQL_HANDLE_DBC, g_odbc->dbc_handle_source);
        return 1;
    }
    ToUpper(catalog);
    ToUpper(schema);
    ToUpper(table);
    if (catalog[0] == '\0' && schema[0] == '\0')
        ret = SQLColumns(g_odbc->stmt_handle_source, NULL, 0, NULL, 0, (SQLCHAR*)table, SQL_NTS, (SQLCHAR*)"%", SQL_NTS);
    else if (catalog[0] == '\0')
        ret = SQLColumns(g_odbc->stmt_handle_source, NULL, 0, (SQLCHAR*)schema, SQL_NTS, (SQLCHAR*)table, SQL_NTS, (SQLCHAR*)"%", SQL_NTS);
    else
        ret = SQLColumns(g_odbc->stmt_handle_source, (SQLCHAR*)catalog, SQL_NTS, (SQLCHAR*)schema, SQL_NTS, (SQLCHAR*)table, SQL_NTS, (SQLCHAR*)"%", SQL_NTS);

    INT_OPTION(ARRAYSIZE) = 1;
    es = (ExecuteStruct*)malloc(sizeof(ExecuteStruct));
    es->text = text;
    es->data = _strdup("");
    strcpy(es->action, "");
    strcpy(es->executestr, "");
    es->fast = 0;
    if (tid == 0)
    {
        CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)ExecuteQuery, es, 0, &tid);
    }
    else
    {
        ExecuteQuery(es);
    }
    INT_OPTION(ARRAYSIZE) = old_arraysize;
    return 0;
}

int ODBC_Dir(TextWidget * text, char* object)
{
    SQLRETURN ret;
    ExecuteStruct* es;
    char catalog[40] = "", schema[40] = "", table[40] = "", column[40] = "";
    int old_arraysize = INT_OPTION(ARRAYSIZE), x;

    x = sscanf(object, "%[^.].%[^.].%s", catalog, schema, table);
    Trim(catalog);
    Trim(schema);
    Trim(table);
    switch (x)
    {
        case 1:
            strcpy(table, catalog);
            strcpy(catalog, "");
            strcpy(schema, "");
            break;
        case 2:
            strcpy(table, schema);
            strcpy(schema, catalog);
            strcpy(catalog, "");
            break;
        case 0:
            return 1;
    }
    ret = SQLAllocHandle(SQL_HANDLE_STMT, g_odbc->dbc_handle_source, &g_odbc->stmt_handle_source);
    if (ret == SQL_INVALID_HANDLE || ret == SQL_ERROR)
    {
        ChkODBCErr(ret, SQL_HANDLE_DBC, g_odbc->dbc_handle_source);
        return 1;
    }
    ToUpper(catalog);
    ToUpper(schema);
    ToUpper(table);
    if (catalog[0] == '\0' && schema[0] == '\0')
        ret = SQLTables(g_odbc->stmt_handle_source, NULL, 0, NULL, 0, (SQLCHAR*)table, SQL_NTS, (SQLCHAR*)"TABLE,VIEW", SQL_NTS);
    else if (catalog[0] == '\0')
        ret = SQLTables(g_odbc->stmt_handle_source, NULL, 0, (SQLCHAR*)schema, SQL_NTS, (SQLCHAR*)table, SQL_NTS, (SQLCHAR*)"TABLE,VIEW", SQL_NTS);
    else
        ret = SQLTables(g_odbc->stmt_handle_source, (SQLCHAR*)catalog, SQL_NTS, (SQLCHAR*)schema, SQL_NTS, (SQLCHAR*)table, SQL_NTS, (SQLCHAR*)"TABLE,VIEW", SQL_NTS);

    INT_OPTION(ARRAYSIZE) = 1;
    es = (ExecuteStruct*)malloc(sizeof(ExecuteStruct));
    es->text = text;
    es->data = _strdup("");
    strcpy(es->action, "\r%d row%s selected");
    strcpy(es->executestr, "");
    es->fast = 0;
    ExecuteQuery(es);
    INT_OPTION(ARRAYSIZE) = old_arraysize;
    return 0;
}