#include "jbodbc.h"
#include "match.h"

int ODBC_FillTablesHintList(TextWidget *text,char *firstword,char *secondword,char *lastword)
{
  SQLRETURN ret;
  int buffersize,numcols=5,i;
  struct DataBinding* catalogResult;
  char tables[256],schemas[256],schema[256],catalog[256];

  ret=SQLAllocHandle(SQL_HANDLE_STMT,g_odbc->dbc_handle_source,&g_odbc->stmt_handle_source);
  if (ret==SQL_INVALID_HANDLE || ret==SQL_ERROR)
  {
    ChkODBCErr(ret,SQL_HANDLE_DBC,g_odbc->dbc_handle_source);
    return 1;
  }
  buffersize = 1024;

  catalogResult = (struct DataBinding*) malloc( numcols * sizeof(struct DataBinding) );

  for ( i = 0 ; i < numcols ; i++ ) {
    catalogResult[i].TargetType = SQL_C_CHAR;
    catalogResult[i].BufferLength = (buffersize + 1);
    catalogResult[i].TargetValuePtr = malloc( sizeof(unsigned char)*catalogResult[i].BufferLength );
    ret = SQLBindCol(g_odbc->stmt_handle_source, (SQLUSMALLINT)i + 1, catalogResult[i].TargetType, catalogResult[i].TargetValuePtr, catalogResult[i].BufferLength, &(catalogResult[i].StrLen_or_Ind));
  }
  if (firstword[0]=='\0' && secondword[0]=='\0')
  {
    sprintf(tables,"%s%%",lastword);
    sprintf(schemas,"%s*",lastword);
    ToUpper(tables);
    ToUpper(schemas);

    ret = SQLTables( g_odbc->stmt_handle_source, NULL, 0, NULL, 0, (SQLCHAR*)tables, SQL_NTS, (SQLCHAR*)"TABLE, VIEW", SQL_NTS );
    while ((ret = SQLFetch(g_odbc->stmt_handle_source))==SQL_SUCCESS)
    {
      if (catalogResult[2].StrLen_or_Ind!=SQL_NULL_DATA)
        AddToHintList(text, (char*)catalogResult[2].TargetValuePtr,1 );
    }   
    SQLCloseCursor(g_odbc->stmt_handle_source);

    ret = SQLTables( g_odbc->stmt_handle_source, (SQLCHAR*)SQL_ALL_CATALOGS, SQL_NTS, (SQLCHAR*)"", SQL_NTS, (SQLCHAR*)"", SQL_NTS, (SQLCHAR*)"", SQL_NTS );
    while ((ret = SQLFetch(g_odbc->stmt_handle_source))==SQL_SUCCESS)
    {
      if (catalogResult[0].StrLen_or_Ind!=SQL_NULL_DATA)
      {
        strcpy(schema,(char*)catalogResult[0].TargetValuePtr);
        ToUpper(schema);
        if (match(schemas,schema))
          AddToHintList(text, (char*)catalogResult[0].TargetValuePtr,1 );
      }
    }
    SQLCloseCursor(g_odbc->stmt_handle_source);
    
    ret = SQLTables( g_odbc->stmt_handle_source, (SQLCHAR*)"", SQL_NTS, (SQLCHAR*)SQL_ALL_SCHEMAS, SQL_NTS, (SQLCHAR*)"", SQL_NTS, (SQLCHAR*)"", SQL_NTS );
    while ((ret = SQLFetch(g_odbc->stmt_handle_source))==SQL_SUCCESS)
    {
      if (catalogResult[1].StrLen_or_Ind!=SQL_NULL_DATA)
      {
        strcpy(schema,(char*)catalogResult[1].TargetValuePtr);
        ToUpper(schema);
        if (match(schemas,schema))
          AddToHintList(text, (char*)catalogResult[1].TargetValuePtr,1 );
      }
    }
    SQLCloseCursor(g_odbc->stmt_handle_source);
  }
  else if (firstword[0]=='\0' && secondword[0]!='\0')
  {
    sprintf(tables,"%s%%",lastword);
    sprintf(schema,"%s",secondword);
    ToUpper(tables);
    ToUpper(schema);

    ret = SQLTables( g_odbc->stmt_handle_source, NULL, 0, (SQLCHAR*)schema, SQL_NTS, (SQLCHAR*)tables, SQL_NTS, (SQLCHAR*)"TABLE, VIEW", SQL_NTS );
    while ((ret = SQLFetch(g_odbc->stmt_handle_source))==SQL_SUCCESS)
    {
      if (catalogResult[2].StrLen_or_Ind!=SQL_NULL_DATA)
        AddToHintList(text, (char*)catalogResult[2].TargetValuePtr,1 );
    }   
    SQLCloseCursor(g_odbc->stmt_handle_source);

    sprintf(schemas,"%s*",lastword);
    ToUpper(schemas);
    ret = SQLTables( g_odbc->stmt_handle_source, (SQLCHAR*)"", SQL_NTS, (SQLCHAR*)SQL_ALL_SCHEMAS, SQL_NTS, (SQLCHAR*)"", SQL_NTS, (SQLCHAR*)"", SQL_NTS );
    while ((ret = SQLFetch(g_odbc->stmt_handle_source))==SQL_SUCCESS)
    {
      if (catalogResult[1].StrLen_or_Ind!=SQL_NULL_DATA)
      {
        strcpy(schema,(char*)catalogResult[1].TargetValuePtr);
        ToUpper(schema);
        if (match(schemas,schema))
          AddToHintList(text, (char*)catalogResult[1].TargetValuePtr,1 );
      }
    }
    SQLCloseCursor(g_odbc->stmt_handle_source);
  }
  else if (firstword[0]!='\0' && secondword[0]!='\0')
  {
    sprintf(tables,"%s%%",lastword);
    sprintf(schema,"%s",secondword);
    sprintf(catalog,"%s",firstword);
    ToUpper(tables);
    ToUpper(schema);
    ToUpper(catalog);

    ret = SQLTables( g_odbc->stmt_handle_source,  (SQLCHAR*)catalog, SQL_NTS, (SQLCHAR*)schema, SQL_NTS, (SQLCHAR*)tables, SQL_NTS, (SQLCHAR*)"TABLE, VIEW", SQL_NTS );
    while ((ret = SQLFetch(g_odbc->stmt_handle_source))==SQL_SUCCESS)
    {
      if (catalogResult[2].StrLen_or_Ind!=SQL_NULL_DATA)
        AddToHintList(text, (char*)catalogResult[2].TargetValuePtr,1 );
    }   
    SQLCloseCursor(g_odbc->stmt_handle_source);

  }
  for ( i = 0 ; i < numcols ; i++ ) {
    free(catalogResult[i].TargetValuePtr);
  }
  free(catalogResult);
  SQLFreeHandle(SQL_HANDLE_STMT,&g_odbc->stmt_handle_source);
  g_odbc->stmt_handle_source=NULL;

  return 0;
}

int ODBC_FillColumnsHintList(TextWidget *text,char *catalog,char *schema,char *table,char *column)
{
  SQLRETURN ret;
  int buffersize,numcols=18,i;
  struct DataBinding* catalogResult;
  char columns[256];

  ret=SQLAllocHandle(SQL_HANDLE_STMT,g_odbc->dbc_handle_source,&g_odbc->stmt_handle_source);
  if (ret==SQL_INVALID_HANDLE || ret==SQL_ERROR)
  {
    ChkODBCErr(ret,SQL_HANDLE_DBC,g_odbc->dbc_handle_source);
    return 1;
  }
  buffersize = 1024;

  catalogResult = (struct DataBinding*) malloc( numcols * sizeof(struct DataBinding) );

  for ( i = 0 ; i < numcols ; i++ ) {
    catalogResult[i].TargetType = SQL_C_CHAR;
    catalogResult[i].BufferLength = (buffersize + 1);
    catalogResult[i].TargetValuePtr = malloc( sizeof(unsigned char)*catalogResult[i].BufferLength );
    ret = SQLBindCol(g_odbc->stmt_handle_source, (SQLUSMALLINT)i + 1, catalogResult[i].TargetType, catalogResult[i].TargetValuePtr, catalogResult[i].BufferLength, &(catalogResult[i].StrLen_or_Ind));
  }
  ToUpper(catalog);
  ToUpper(schema);
  ToUpper(table);
  sprintf(columns,"%s%%",column);
  ToUpper(columns);
  if (catalog[0]=='\0' && schema[0]=='\0')
    ret = SQLColumns( g_odbc->stmt_handle_source,  NULL, 0, NULL, 0, (SQLCHAR*)table, SQL_NTS, (SQLCHAR*)columns, SQL_NTS );
  else if (catalog[0]=='\0')
    ret = SQLColumns( g_odbc->stmt_handle_source,  NULL, 0, (SQLCHAR*)schema, SQL_NTS, (SQLCHAR*)table, SQL_NTS, (SQLCHAR*)columns, SQL_NTS );
  else
    ret = SQLColumns( g_odbc->stmt_handle_source,  (SQLCHAR*)catalog, SQL_NTS, (SQLCHAR*)schema, SQL_NTS, (SQLCHAR*)table, SQL_NTS, (SQLCHAR*)columns, SQL_NTS );
  while ((ret = SQLFetch(g_odbc->stmt_handle_source))==SQL_SUCCESS)
  {
    if (catalogResult[3].StrLen_or_Ind!=SQL_NULL_DATA)
      AddToHintList(text, (char*)catalogResult[3].TargetValuePtr,1 );
  }   
  SQLCloseCursor(g_odbc->stmt_handle_source);

  for ( i = 0 ; i < numcols ; i++ ) {
    free(catalogResult[i].TargetValuePtr);
  }
  free(catalogResult);
  SQLFreeHandle(SQL_HANDLE_STMT,&g_odbc->stmt_handle_source);
  g_odbc->stmt_handle_source=NULL;
  return 0;
}
