#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "jbodbc.h"


int ODBC_DoCommand(char *str,int feedback,char *executestr)
{
  SQLLEN qrows;
  SQLRETURN ret;

  if (!odbc_connected)
  {
    WPrintf("Not connected to a database\n");
    return -1;
  }
  ret=SQLAllocHandle(SQL_HANDLE_STMT,g_odbc->dbc_handle_source,&g_odbc->stmt_handle_source);
  if (ret==SQL_INVALID_HANDLE || ret==SQL_ERROR)
  {
    ChkODBCErr(ret,SQL_HANDLE_DBC,g_odbc->dbc_handle_source);
    return 1;
  }
  if (feedback)
  {
    if (executestr==NULL || executestr[0]=='\0')
      WPrintfOnly("\rExecuting statement");
    else
      WPrintfOnly("\r%s",executestr);
  }
  ret=SQLExecDirect(g_odbc->stmt_handle_source,(SQLCHAR*)str,(SQLINTEGER)strlen(str));
  if (ret==SQL_INVALID_HANDLE || ret==SQL_ERROR)
  {
    ChkODBCErr(ret,SQL_HANDLE_STMT,g_odbc->stmt_handle_source);
    return -2;
  }
  ret=SQLRowCount(g_odbc->stmt_handle_source,&qrows);
  if (ret==SQL_INVALID_HANDLE || ret==SQL_ERROR)
  {
    ChkODBCErr(ret,SQL_HANDLE_STMT,g_odbc->stmt_handle_source);
    return -3;
  }
  if (qrows<0)
    qrows=0;
  SQLFreeHandle(SQL_HANDLE_DBC,g_odbc->stmt_handle_source);
  g_odbc->stmt_handle_source=NULL;
  return (int)qrows; 
}

void ODBC_Commit(void)
{
  SQLRETURN ret;

  if (!odbc_connected)
  {
    WPrintf("Not connected to a database\n");
    return;
  }
  ret=SQLEndTran(SQL_HANDLE_DBC,g_odbc->dbc_handle_source,SQL_COMMIT);
  if (ret==SQL_INVALID_HANDLE || ret==SQL_ERROR)
  {
    ChkODBCErr(ret,SQL_HANDLE_DBC,g_odbc->dbc_handle_source);
  }
}

void ODBC_Rollback(void)
{
  SQLRETURN ret;

  if (!odbc_connected)
  {
    WPrintf("Not connected to a database\n");
    return;
  }
  ret=SQLEndTran(SQL_HANDLE_DBC,g_odbc->dbc_handle_source,SQL_ROLLBACK);
  if (ret==SQL_INVALID_HANDLE || ret==SQL_ERROR)
  {
    ChkODBCErr(ret,SQL_HANDLE_DBC,g_odbc->dbc_handle_source);
  }

  return;
}


void ODBC_AbortQuery(void)
{
  if (tid)
  {
    if (!query_finished && total_qrows)
      query_finished=1;
    else
    {
      if (g_odbc->stmt_handle_source);
      SQLCancel(g_odbc->stmt_handle_source);
    }
    if (g_text->scripts)
      g_text->cancelled=1;
  }
  else
  {
    RecallCommand(g_text,NULL);
  }
}

int ODBC_ExecuteDDLStatement(char *str)
{
  return ODBC_DoCommand(str,1,"");
}

