#include "options.h"
#include <shlobj.h>

int noptions = sizeof(default_options) / sizeof(Option);
Option *new_options = NULL;
char last_usernames[10][100] = { "","","","","","","","","","" };
char last_databases[10][100] = { "","","","","","","","","","" };

void CopyOptions(Option *source, Option *target)
{
	int x;

	for (x = 0; x < noptions; x++)
	{
		strcpy(target[x].option, source[x].option);
		switch (source[x].type)
		{
			case O_CHAR:case O_DIR:case O_FONT:case O_FONTVAR:case O_COLOR:
				target[x].value.str_value = (char*)malloc(source[x].value_size);
                if (target[x].value.str_value)
    				memcpy(target[x].value.str_value, source[x].value.str_value, source[x].value_size);
				break;
			case O_INT:case O_BOOLEAN:
				target[x].value.int_value = source[x].value.int_value;
				break;
		}
		target[x].value_size = source[x].value_size;
		target[x].icon = source[x].icon;
		target[x].on_toolbar = source[x].on_toolbar;
		target[x].type = source[x].type;
		target[x].proc = source[x].proc;
		if (source[x].description)
			target[x].description = _strdup(source[x].description);
		target[x].min_value = source[x].min_value;
		target[x].settable = source[x].settable;
		target[x].subkey = source[x].subkey;
	}
}

void FreeOptions(Option *source)
{
	int x;

	for (x = 0; x < noptions; x++)
	{
		switch (source[x].type)
		{
			case O_CHAR:case O_DIR:case O_FONT:case O_FONTVAR:case O_COLOR:
				free(source[x].value.str_value);
				break;
			case O_INT:case O_BOOLEAN:
				break;
		}
		if (source[x].description)
			free(source[x].description);
	}
}

void OptionSelected(HWND hWnd)
{
	int x;

	x = (int)SendDlgItemMessage(hWnd, IDC_OPTION_LIST, LB_GETCURSEL, 0, 0);
	if (x != LB_ERR)
	{
		EnableWindow(GetDlgItem(hWnd, IDC_OPTION_VALUE), TRUE);
		SetDlgItemText(hWnd, IDC_OPTION_DESCRIPTION, new_options[x].description);
		switch (new_options[x].type)
		{
			case O_CHAR:
				ShowWindow(GetDlgItem(hWnd, IDC_OPTION_BOOLEAN), SW_HIDE);
				ShowWindow(GetDlgItem(hWnd, IDC_OPTION_BROWSE), SW_HIDE);
				ShowWindow(GetDlgItem(hWnd, IDC_OPTION_VALUE), SW_SHOW);
				ShowWindow(GetDlgItem(hWnd, IDC_OPTION_DESCRIPTION), SW_SHOW);
				ShowWindow(GetDlgItem(hWnd, IDC_OPTION_VALUE_TEXT), SW_SHOW);
				ShowWindow(GetDlgItem(hWnd, IDC_TOOLBAR), SW_HIDE);
				SetDlgItemText(hWnd, IDC_OPTION_VALUE, new_options[x].value.str_value);
				break;
			case O_INT:
				{
					char tmpstr[20];

					sprintf(tmpstr, "%d", new_options[x].value.int_value);
					ShowWindow(GetDlgItem(hWnd, IDC_OPTION_BOOLEAN), SW_HIDE);
					ShowWindow(GetDlgItem(hWnd, IDC_OPTION_BROWSE), SW_HIDE);
					ShowWindow(GetDlgItem(hWnd, IDC_OPTION_VALUE), SW_SHOW);
					ShowWindow(GetDlgItem(hWnd, IDC_OPTION_DESCRIPTION), SW_SHOW);
					ShowWindow(GetDlgItem(hWnd, IDC_OPTION_VALUE_TEXT), SW_SHOW);
					ShowWindow(GetDlgItem(hWnd, IDC_TOOLBAR), SW_HIDE);
					SetDlgItemText(hWnd, IDC_OPTION_VALUE, tmpstr);
				}
				break;
			case O_BOOLEAN:
				ShowWindow(GetDlgItem(hWnd, IDC_OPTION_BOOLEAN), SW_SHOW);
				ShowWindow(GetDlgItem(hWnd, IDC_OPTION_BROWSE), SW_HIDE);
				ShowWindow(GetDlgItem(hWnd, IDC_OPTION_VALUE), SW_HIDE);
				ShowWindow(GetDlgItem(hWnd, IDC_OPTION_DESCRIPTION), SW_SHOW);
				ShowWindow(GetDlgItem(hWnd, IDC_OPTION_VALUE_TEXT), SW_SHOW);
				ShowWindow(GetDlgItem(hWnd, IDC_TOOLBAR), SW_SHOW);
				SendDlgItemMessage(hWnd, IDC_OPTION_BOOLEAN, BM_SETCHECK, new_options[x].value.int_value, 0);
				SendDlgItemMessage(hWnd, IDC_TOOLBAR, BM_SETCHECK, new_options[x].on_toolbar, 0);
				break;
			case O_DIR:
				ShowWindow(GetDlgItem(hWnd, IDC_OPTION_BOOLEAN), SW_HIDE);
				ShowWindow(GetDlgItem(hWnd, IDC_OPTION_BROWSE), SW_SHOW);
				ShowWindow(GetDlgItem(hWnd, IDC_OPTION_VALUE), SW_SHOW);
				ShowWindow(GetDlgItem(hWnd, IDC_OPTION_DESCRIPTION), SW_SHOW);
				ShowWindow(GetDlgItem(hWnd, IDC_OPTION_VALUE_TEXT), SW_SHOW);
				ShowWindow(GetDlgItem(hWnd, IDC_TOOLBAR), SW_HIDE);
				SetDlgItemText(hWnd, IDC_OPTION_VALUE, new_options[x].value.str_value);
				break;
			case O_FONT:
			case O_FONTVAR:
			case O_COLOR:
				ShowWindow(GetDlgItem(hWnd, IDC_OPTION_BOOLEAN), SW_HIDE);
				ShowWindow(GetDlgItem(hWnd, IDC_OPTION_BROWSE), SW_SHOW);
				ShowWindow(GetDlgItem(hWnd, IDC_OPTION_VALUE), SW_SHOW);
				ShowWindow(GetDlgItem(hWnd, IDC_OPTION_DESCRIPTION), SW_SHOW);
				ShowWindow(GetDlgItem(hWnd, IDC_OPTION_VALUE_TEXT), SW_SHOW);
				ShowWindow(GetDlgItem(hWnd, IDC_TOOLBAR), SW_HIDE);
				SetDlgItemText(hWnd, IDC_OPTION_VALUE, new_options[x].value.str_value);
				EnableWindow(GetDlgItem(hWnd, IDC_OPTION_VALUE), FALSE);
				break;
		}
	}
	else
	{
		ShowWindow(GetDlgItem(hWnd, IDC_OPTION_BOOLEAN), SW_HIDE);
		ShowWindow(GetDlgItem(hWnd, IDC_OPTION_BROWSE), SW_HIDE);
		ShowWindow(GetDlgItem(hWnd, IDC_OPTION_VALUE), SW_HIDE);
		ShowWindow(GetDlgItem(hWnd, IDC_OPTION_DESCRIPTION), SW_HIDE);
		ShowWindow(GetDlgItem(hWnd, IDC_OPTION_VALUE_TEXT), SW_HIDE);
		ShowWindow(GetDlgItem(hWnd, IDC_TOOLBAR), SW_HIDE);
	}
}

void SetOption(HWND hWnd)
{
	int x;

	x = (int)SendDlgItemMessage(hWnd, IDC_OPTION_LIST, LB_GETCURSEL, 0, 0);
	if (x != LB_ERR)
	{
		switch (new_options[x].type)
		{
			case O_CHAR:case O_DIR:case O_FONT:case O_FONTVAR:case O_COLOR:
				GetDlgItemText(hWnd, IDC_OPTION_VALUE, new_options[x].value.str_value, new_options[x].value_size);
				break;
			case O_INT:
				{
					char tmpstr[20];

					GetDlgItemText(hWnd, IDC_OPTION_VALUE, tmpstr, 20);
					new_options[x].value.int_value = atoi(tmpstr);
				}
				break;
			case O_BOOLEAN:
				new_options[x].value.int_value = (int)SendDlgItemMessage(hWnd, IDC_OPTION_BOOLEAN, BM_GETCHECK, 0, 0);
				new_options[x].on_toolbar = (int)SendDlgItemMessage(hWnd, IDC_TOOLBAR, BM_GETCHECK, 0, 0);
				break;
		}
	}
}

void BrowseFolders(HWND hWnd)
{
	BROWSEINFO bi;
	char buffer[MAX_PATH];
	LPITEMIDLIST lpiddl;
	LPMALLOC malc;

	SHGetMalloc(&malc);
	bi.hwndOwner = hWnd;
	bi.pidlRoot = NULL;
	bi.pszDisplayName = buffer;
	bi.lpszTitle = "Select Directory";
	bi.ulFlags = BIF_RETURNONLYFSDIRS;
	bi.lpfn = NULL;
	bi.lParam = 0;
	if ((lpiddl = SHBrowseForFolder(&bi)) != NULL)
	{
		SHGetPathFromIDList(lpiddl, buffer);
		SetDlgItemText(hWnd, IDC_OPTION_VALUE, buffer);
	}
	malc->lpVtbl->Free(malc, lpiddl);
}

int ParseFontString(char *fontstr, char *font, int *pointsize, int *weight, int *italic)
{
	char *pos1, *pos2, *pos3;

	pos1 = strchr(fontstr, ',');
	if (pos1)
	{
		*pos1 = '\0';
		strcpy(font, fontstr);
		pos2 = strchr(pos1 + 1, ',');
		if (pos2)
		{
			*pos2 = '\0';
			*pointsize = atoi(pos1 + 1);
			pos3 = strchr(pos2 + 1, ',');
			if (pos3)
			{
				*pos3 = '\0';
				*weight = atoi(pos2 + 1);
				*pos3 = ',';
				*italic = atoi(pos3 + 1);
			}
			*pos2 = ',';
		}
		*pos1 = ',';
		return 0;
	}
	return 1;
}

void BrowseFonts(TextWidget *text, HWND hwnd, int all_fonts, char *default_font)
{
	CHOOSEFONT cfd;
	LOGFONT lf;
	HDC hdc;
	char font[MAX_PATH];
	int pointsize, weight, italic;

	cfd.lStructSize = sizeof(cfd);
	cfd.hwndOwner = hwnd;
	cfd.lpLogFont = &lf;
	if (all_fonts)
		cfd.Flags = CF_INITTOLOGFONTSTRUCT | CF_FORCEFONTEXIST;
	else
		cfd.Flags = CF_INITTOLOGFONTSTRUCT | CF_FIXEDPITCHONLY | CF_FORCEFONTEXIST;

	ParseFontString(default_font, font, &pointsize, &weight, &italic);
	hdc = GetDC(hwnd);
	lf.lfHeight = -MulDiv(pointsize, GetDeviceCaps(hdc, LOGPIXELSY), 72);
	lf.lfWidth = 0;
	lf.lfEscapement = 0;
	lf.lfOrientation = 0;
	lf.lfWeight = weight;
	lf.lfItalic = italic;
	lf.lfUnderline = FALSE;
	lf.lfStrikeOut = FALSE;
	lf.lfCharSet = DEFAULT_CHARSET;
	lf.lfOutPrecision = OUT_DEFAULT_PRECIS;
	lf.lfClipPrecision = CLIP_DEFAULT_PRECIS;
	lf.lfQuality = DEFAULT_QUALITY;
	lf.lfPitchAndFamily = FIXED_PITCH | FF_MODERN;
	strncpy(lf.lfFaceName, font, 32);
	ChooseFont(&cfd);
	pointsize = -MulDiv(lf.lfHeight, 72, GetDeviceCaps(hdc, LOGPIXELSY));
	sprintf(font, "%s,%d,%d,%d", lf.lfFaceName, pointsize, (int)lf.lfWeight, (int)lf.lfItalic);
	SetDlgItemText(hwnd, IDC_OPTION_VALUE, font);
	ReleaseDC(hwnd, hdc);
}

void ParseColorString(char *color, COLORREF *rgb)
{
	int r, g, b;

	if (sscanf(color, "r%dg%db%d", &r, &g, &b) == 3)
	{
		*rgb = RGB(r, g, b);
	}
}

void BrowseColors(TextWidget *text, HWND hwnd, char *default_color)
{
	CHOOSECOLOR cfd;
	COLORREF initial_color=0;
	char color[13];
	static COLORREF custom_colors[16] = { 0 };

	cfd.lStructSize = sizeof(cfd);
	cfd.hwndOwner = hwnd;
	if (default_color != NULL && default_color[0])
		ParseColorString(default_color, &initial_color);
	cfd.rgbResult = initial_color;
	cfd.lpCustColors = custom_colors;
	cfd.Flags = CC_ANYCOLOR;
	cfd.lCustData = (LPARAM)NULL;
	cfd.lpfnHook = NULL;
	cfd.lpTemplateName = NULL;
	if (ChooseColor(&cfd))
	{
		sprintf(color, "r%03dg%03db%03d", (int)GetRValue(cfd.rgbResult), (int)GetGValue(cfd.rgbResult), (int)GetBValue(cfd.rgbResult));
		SetDlgItemText(hwnd, IDC_OPTION_VALUE, color);
	}
}

BOOL FAR PASCAL OptionProc(HWND hWnd, unsigned message, DWORD wParam, LONG lParam)
{
	static DWORD time_left;
	static TextWidget *text;

	switch (message)
	{
		case WM_INITDIALOG:
			{
				int x;

				new_options = malloc(noptions * sizeof(Option));
				text = g_text;
				for (x = 0; x < noptions; x++)
				{
					new_options[x] = text->options[x];
					if (new_options[x].type == O_CHAR || new_options[x].type == O_DIR || new_options[x].type == O_FONT || new_options[x].type == O_FONTVAR || new_options[x].type == O_COLOR)
					{
						new_options[x].value.str_value = malloc(new_options[x].value_size);
                        if (new_options[x].value.str_value)
    						strcpy(new_options[x].value.str_value, text->options[x].value.str_value);
					}
					SendDlgItemMessage(hWnd, IDC_OPTION_LIST, LB_ADDSTRING, 0, (LPARAM)new_options[x].option);
				}
				SendDlgItemMessage(hWnd, IDC_OPTION_LIST, LB_SETCURSEL, 0, 0);
				OptionSelected(hWnd);
			}
			return TRUE;
		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
				case ID_OPTION_OK:
					{
						int x;
						char subkey[40], subkey_toolbar[40];

						for (x = 0; x < noptions; x++)
						{
							if (new_options[x].subkey)
								sprintf(subkey, "SOFTWARE\\JBSQL\\%s", new_options[x].option);
							else
								strcpy(subkey, "SOFTWARE\\JBSQL");
							sprintf(subkey_toolbar, "%s\\toolbar", subkey);
							if (new_options[x].type == O_CHAR || new_options[x].type == O_DIR || new_options[x].type == O_FONT || new_options[x].type == O_FONTVAR || new_options[x].type == O_COLOR)
							{
								strcpy(text->options[x].value.str_value, new_options[x].value.str_value);
								free(new_options[x].value.str_value);
								WriteRegistryString(subkey, text->options[x].subkey ? text->database : text->options[x].option, text->options[x].value.str_value);
								if (text->options[x].proc)
									text->options[x].proc(text, text->options[x].value.str_value);
							}
							else
							{
								if (new_options[x].type == O_INT && new_options[x].value.int_value <= 0)
									new_options[x].value.int_value = 1;
								text->options[x].value.int_value = new_options[x].value.int_value;
								text->options[x].on_toolbar = new_options[x].on_toolbar;
								WriteRegistryInteger(subkey, text->options[x].subkey ? text->database : text->options[x].option, text->options[x].value.int_value);
								if (new_options[x].type == O_BOOLEAN)
									WriteRegistryInteger(subkey_toolbar, text->options[x].subkey ? text->database : text->options[x].option, text->options[x].on_toolbar);
								if (text->options[x].proc)
									text->options[x].proc(text, &text->options[x].value);
							}
						}
					}
					free(new_options);
					SetPWD(text);
					EndDialog(hWnd, 0);
                    if (!tid)
                    {
                        if (text->toolbar)
                            DestroyWindow(text->toolbar);
                        text->toolbar = BuildToolbar(text, g_hInst, g_hWnd);
                    }
					break;
				case ID_OPTION_CANCEL:
					{
						int x;

						for (x = 0; x < noptions; x++)
						{
							if (new_options[x].type == O_CHAR || new_options[x].type == O_DIR || new_options[x].type == O_FONT || new_options[x].type == O_FONTVAR || new_options[x].type == O_COLOR)
							{
								free(new_options[x].value.str_value);
							}
						}
					}
					free(new_options);
					EndDialog(hWnd, 0);
					break;
				case IDC_OPTION_LIST:
					if (HIWORD(wParam) == LBN_SELCHANGE)
						OptionSelected(hWnd);
					break;
				case IDC_OPTION_VALUE:
					if (HIWORD(wParam) == EN_CHANGE)
						SetOption(hWnd);
					break;
				case IDC_OPTION_BOOLEAN:
					SetOption(hWnd);
					break;
				case IDC_TOOLBAR:
					SetOption(hWnd);
					break;
				case IDC_OPTION_BROWSE:
					{
						int x;

						x = (int)SendDlgItemMessage(hWnd, IDC_OPTION_LIST, LB_GETCURSEL, 0, 0);
						if (x != LB_ERR)
						{
							switch (new_options[x].type)
							{
								case O_DIR:
									BrowseFolders(hWnd);
									break;
								case O_FONT:
									BrowseFonts(text, hWnd, 0, STR_OPTION(FONT));
									break;
								case O_FONTVAR:
									BrowseFonts(text, hWnd, 1, STR_OPTION(FONT_LV));
									break;
								case O_COLOR:
									BrowseColors(text, hWnd, STR_OPTION(BACKGROUNDCOLOR));
									break;
							}
						}
					}
					break;
			}
			break;
		case WM_CLOSE:
		{
			int x;

			for (x = 0; x < noptions; x++)
			{
				if (new_options[x].type == O_CHAR || new_options[x].type == O_DIR || new_options[x].type == O_FONT || new_options[x].type == O_FONTVAR || new_options[x].type == O_COLOR)
				{
					free(new_options[x].value.str_value);
				}
			}
		}
		free(new_options);
		EndDialog(hWnd, 0);
		break;
		default:
			break;
	}
	return FALSE;
}

int GetDefaultOptions(TextWidget *text)
{
	int x;
	Option *o;
	char subkey[40], subkey_toolbar[40], subkey_toolbar_old[40];

	text->options = malloc(sizeof(Option)*noptions);
	if (text->options == NULL)
	{
		return -1;
	}
	o = text->options;
	for (x = 0; x < noptions; x++)
	{
		o[x].description = _strdup(default_options[x].description);
		strcpy(o[x].option, default_options[x].option);
		o[x].type = default_options[x].type;
		o[x].value_size = default_options[x].value_size;
		o[x].icon = default_options[x].icon;
		o[x].on_toolbar = default_options[x].on_toolbar;
		o[x].proc = default_options[x].proc;
		o[x].min_value = default_options[x].min_value;
		o[x].settable = default_options[x].settable;
		o[x].subkey = default_options[x].subkey;
		if (o[x].subkey)
			sprintf(subkey, "SOFTWARE\\JBSQL\\%s", o[x].option);
		else
			strcpy(subkey, "SOFTWARE\\JBSQL");
		sprintf(subkey_toolbar, "%s\\toolbar", subkey);
		sprintf(subkey_toolbar_old, "%s\toolbar", subkey);
		switch (default_options[x].type)
		{
			case O_CHAR:case O_DIR:case O_FONT:case O_FONTVAR:case O_COLOR:
				o[x].value.str_value = malloc(o[x].value_size);
				if (!ReadRegistryString(subkey, o[x].subkey ? text->database : o[x].option, o[x].value.str_value, o[x].value_size))
					strcpy(o[x].value.str_value, default_options[x].value.str_value);
				if (text->options[x].proc)
					text->options[x].proc(text, text->options[x].value.str_value);
				break;
			case O_INT:case O_BOOLEAN:
				if (!ReadRegistryInteger(subkey, o[x].subkey ? text->database : o[x].option, &o[x].value.int_value))
					o[x].value.int_value = default_options[x].value.int_value;
				if (!ReadRegistryInteger(subkey_toolbar, o[x].subkey ? text->database : o[x].option, &o[x].on_toolbar))
				{
					if (!ReadRegistryInteger(subkey_toolbar_old, o[x].subkey ? text->database : o[x].option, &o[x].on_toolbar)) // Old bug, wrong reg location
						o[x].on_toolbar = default_options[x].on_toolbar;
				}
				if (text->options[x].proc)
					text->options[x].proc(text, &text->options[x].value.int_value);
				break;
			default:
				return -2;
		}
	}
	if (!text->old_version)
	{
		text->old_version = 1;
		ReadRegistryInteger(subkey, "version", &text->old_version);
		WriteRegistryInteger(subkey, "version", CURRENT_JBSQL_VERSION);
	}
	return 0;
}

int MatchOption(TextWidget *text, char *pattern)
{
	int cnt = 0, match, x;

	for (x = 0; x < noptions; x++)
	{
		if (!_strnicmp(text->options[x].option, pattern, strlen(pattern)))
		{
			match = x;
			cnt++;
		}
	}
	if (cnt != 1)
		return -1;
	return match;
}

void SetCommandLineOption(TextWidget *text, char *settings)
{
	int x, y;
	char **argv;
	int argc;
	char subkey[40];

	ConvertCommandLine(settings, &argc, &argv);
	for (y = 0; y < argc; y += 2)
	{
		x = MatchOption(text, argv[y]);
		if (x != -1)
		{
			if (text->options[x].subkey)
				sprintf(subkey, "SOFTWARE\\JBSQL\\%s", text->options[x].option);
			else
				strcpy(subkey, "SOFTWARE\\JBSQL");

			if (!text->options[x].settable)
				WPrintf("Cannot set this option via set command\n");
			else
			{
				switch (text->options[x].type)
				{
					case O_CHAR:case O_DIR:case O_FONT:case O_FONTVAR:case O_COLOR:
						strncpy(text->options[x].value.str_value, argv[y + 1], text->options[x].value_size - 1);
						text->options[x].value.str_value[text->options[x].value_size - 1] = '\0';
						if (!tid)
							WriteRegistryString(subkey, text->options[x].subkey ? text->database : text->options[x].option, text->options[x].value.str_value);
						if (text->options[x].proc)
							text->options[x].proc(text, text->options[x].value.str_value);
						break;
					case O_INT:
						Log("Setting option %s to value %d (minvalue=%d)", argv[y], atoi(argv[y + 1]), text->options[x].min_value);
						text->options[x].value.int_value = atoi(argv[y + 1]);
						if (text->options[x].value.int_value <= text->options[x].min_value)
							text->options[x].value.int_value = text->options[x].min_value;
						if (!tid)
							WriteRegistryInteger(subkey, text->options[x].subkey ? text->database : text->options[x].option, text->options[x].value.int_value);
						if (text->options[x].proc)
							text->options[x].proc(text, &text->options[x].value.int_value);
						break;
					case O_BOOLEAN:
						if (!_stricmp(argv[y + 1], "on"))
						{
							text->options[x].value.int_value = 1;
							if (!tid)
								WriteRegistryInteger(subkey, text->options[x].subkey ? text->database : text->options[x].option, 1);
							if (text->options[x].proc)
								text->options[x].proc(text, &text->options[x].value.int_value);
						}
						else if (!_stricmp(argv[y + 1], "off"))
						{
							text->options[x].value.int_value = 0;
							if (!tid)
								WriteRegistryInteger(subkey, text->options[x].subkey ? text->database : text->options[x].option, 0);
							if (text->options[x].proc)
								text->options[x].proc(text, &text->options[x].value.int_value);
						}
						else
							WPrintf("Usage: set %s on|off\n", argv[y]);
						break;
				}
				if (!_stricmp(argv[y], "directory"))
					SetPWD(text);
			}
		}
		else
			WPrintf("Unknown option %s\n", argv[y]);
	}
    if (!tid && !ptid)
    {
        if (text->toolbar)
            DestroyWindow(text->toolbar);
        text->toolbar = BuildToolbar(text, g_hInst, g_hWnd);
    }
	for (x = 0; x < argc; x++)
		free(argv[x]);
	free(argv);
}


void SetPWD(TextWidget *text)
{
	if (!SetCurrentDirectory(STR_OPTION(DIRECTORY)))
	{
		LPVOID lpMsgBuf;
		char str[BUFLEN];

		FormatMessage(
			FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
			NULL,
			GetLastError(),
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
			(LPTSTR)&lpMsgBuf, 0, NULL);
		sprintf(str, "Cannot set current directory to %s\n%s", STR_OPTION(DIRECTORY), (char*)lpMsgBuf);
		Error(NULL, str);
		LocalFree(lpMsgBuf);
	}
}

void PrintOptions(TextWidget *text)
{
	int x;

	for (x = 0; x < noptions; x++)
	{
		switch (text->options[x].type)
		{
			case O_CHAR:case O_DIR:case O_FONT:case O_FONTVAR:case O_COLOR:
				WPrintf("%-20s = %s\n", text->options[x].option, text->options[x].value.str_value);
				break;
			case O_INT:
				WPrintf("%-20s = %d\n", text->options[x].option, text->options[x].value.int_value);
				break;
			case O_BOOLEAN:
				WPrintf("%-20s = %s\n", text->options[x].option, text->options[x].value.int_value ? "on" : "off");
				break;
		}
	}
	WPrintf("\nUsage: set parameter value [parameter value ...]\n");
}

char *GetCommandHistoryFileName(void)
{
	static char pdir[MAX_PATH + 100];

	GetEnvironmentVariable("APPDATA", pdir, MAX_PATH + 100);

	strcat(pdir, "\\jbsql\\jbsql.his");
	return pdir;
}

void SaveCommandHistory(TextWidget *text)
{
	HANDLE f;
	int x, len;
	char str[3];
	DWORD bytes_written, ret;
	HANDLE mutex;

	if (!INT_OPTION(SAVEHISTORY))
		return;
	mutex = CreateMutex(NULL, TRUE, "jbsql_save_commandhistory");
	if (mutex == NULL)
	{
		DisplayLastError(NULL);
		return;
	}
	ret = WaitForSingleObject(mutex, INFINITE);
	if (ret != WAIT_OBJECT_0 && ret != WAIT_ABANDONED)
		DisplayLastError(NULL);
	f = CreateFile(GetCommandHistoryFileName(),
		GENERIC_WRITE,
		FILE_SHARE_READ,
		NULL,
		CREATE_ALWAYS,
		0,
		NULL);

	if (f == INVALID_HANDLE_VALUE)
	{
		DisplayLastError(NULL);
		return;
	}
	for (x = 0; x < nold_commands; x++)
	{
		if (old_commands[x].lastchar == ';')
		{
			len = (int)strlen(old_commands[x].command) + 1;
			WriteFile(f, &len, sizeof(int), &bytes_written, NULL);
			WriteFile(f, old_commands[x].command, (int)strlen(old_commands[x].command), &bytes_written, NULL);
			sprintf(str, "%c", old_commands[x].lastchar);
			WriteFile(f, str, 1, &bytes_written, NULL);
		}
		else if (old_commands[x].lastchar == '/')
		{
			len = (int)strlen(old_commands[x].command) + 2;
			WriteFile(f, &len, sizeof(int), &bytes_written, NULL);
			WriteFile(f, old_commands[x].command, (int)strlen(old_commands[x].command), &bytes_written, NULL);
			sprintf(str, "\n%c", old_commands[x].lastchar);
			WriteFile(f, str, 2, &bytes_written, NULL);
		}
		else
		{
			len = (int)strlen(old_commands[x].command);
			WriteFile(f, &len, sizeof(int), &bytes_written, NULL);
			WriteFile(f, old_commands[x].command, (int)strlen(old_commands[x].command), &bytes_written, NULL);
		}
	}
	CloseHandle(f);
	ReleaseMutex(mutex);
	CloseHandle(mutex);
}

void ReadCommandHistory(TextWidget *text)
{
	HANDLE f;
	int len, history;
	char str[MAX_PATH], windir[MAX_PATH];
	DWORD bytes_read;

	if (!INT_OPTION(SAVEHISTORY))
		return;
	f = CreateFile(GetCommandHistoryFileName(),
		GENERIC_READ,
		FILE_SHARE_READ,
		NULL,
		OPEN_EXISTING,
		0,
		NULL);

	if (f == INVALID_HANDLE_VALUE)
	{
		GetWindowsDirectory(windir, MAX_PATH);
		sprintf(str, "%s\\jbsql.his", windir);
		f = CreateFile(str,
			GENERIC_READ,
			FILE_SHARE_READ,
			NULL,
			OPEN_EXISTING,
			0,
			NULL);

		if (f == INVALID_HANDLE_VALUE)
		{
			return;
		}
	}
	text->termout = 0;
	history = INT_OPTION(HISTORY);
	INT_OPTION(HISTORY) = 0;
	for (;;)
	{
		if (ReadFile(f, &len, sizeof(int), &bytes_read, NULL) == 0 || bytes_read == 0)
			break;
		if (command)
			FreeCommand();
		command = (char*)MallocCommand(len + 1);
		if (command == NULL)
		{
			WPrintf("\nOut of memory while reading history file\n");
			command = _strdupCommand("");
			break;
		}
		ReadFile(f, command, len, &bytes_read, NULL);
		command[len] = '\0';
		ClearCommand(text, 1, 0);
	}
	text->termout = 1;
	INT_OPTION(HISTORY) = history;
	CloseHandle(f);
}

void SaveUserCredentials(char *username, char *database, DataSource datasource)
{
	int x, y, found;

	found = 0;
	for (x = 0; x < 10; x++)
	{
		if (!_stricmp(username, last_usernames[x]))
		{
			found = 1;
			if (x)
			{
				for (y = x - 1; y >= 0; y--)
				{
					strcpy(last_usernames[y + 1], last_usernames[y]);
				}
				strcpy(last_usernames[0], username);
			}
		}
	}
	if (!found)
	{
		for (y = 8; y >= 0; y--)
		{
			strcpy(last_usernames[y + 1], last_usernames[y]);
		}
		strcpy(last_usernames[0], username);
	}
	found = 0;

	for (x = 0; x < 10; x++)
	{
		if (!_stricmp(database, last_databases[x]))
		{
			found = 1;
			if (x)
			{
				for (y = x - 1; y >= 0; y--)
				{
					strcpy(last_databases[y + 1], last_databases[y]);
				}
				strcpy(last_databases[0], database);
			}
		}
	}
	if (!found)
	{
		for (y = 8; y >= 0; y--)
		{
			strcpy(last_databases[y + 1], last_databases[y]);
		}
		strcpy(last_databases[0], database);
	}

	WriteRegistryBytes("SOFTWARE\\JBSQL", "last_usernames", (void*)last_usernames, sizeof(last_usernames));
	WriteRegistryBytes("SOFTWARE\\JBSQL", "last_databases", (void*)last_databases, sizeof(last_databases));
	WriteRegistryInteger("SOFTWARE\\JBSQL", "last_datasource", datasource);
}

void ReadUserCredentials(void)
{
	DWORD ds;
	ReadRegistryString("SOFTWARE\\JBSQL", "last_usernames", (void*)last_usernames, sizeof(last_usernames));
	ReadRegistryString("SOFTWARE\\JBSQL", "last_databases", (void*)last_databases, sizeof(last_databases));
	if (!ReadRegistryInteger("SOFTWARE\\JBSQL", "last_datasource", &ds))
		ds = DS_ORACLE;
	g_text->datasource = (DataSource)ds;
}

void ToggleOption(TextWidget *text, int option)
{
	text->options[option].value.int_value = !text->options[option].value.int_value;
	WriteRegistryInteger("SOFTWARE\\JBSQL", text->options[option].subkey ? text->database : text->options[option].option, text->options[option].value.int_value);
}

int EnableServerOutput(TextWidget *text, void *value)
{
	if (text->datasource == DS_ORACLE)
	{
		if (ora_connected)
		{
			if (*(int*)value)
				return OCI_ExecuteDDLStatement("begin dbms_output.enable(100000); end;");
		}
	}
	return 0;
}
