#include "jbsql.h"

Option default_options[]={
  {"allow_newline", (char*)   0,         0, IDI_NEWLINE,      1, O_BOOLEAN, "Allow newline typing",   "If set, pressing Enter inside a sql statement inserts a newline. If not set, then the statement is executed.",NULL,0,1,0},
  {"arraysize",     (char*)1000,         0, 0,                0, O_INT,     "",                       "How many records are fetched at once?",NULL,1,1,0},
  {"askbind",       (char*)   1,         0, IDI_ASKBIND,      0, O_BOOLEAN, "Ask for bind variables", "Should the bind variables window be shown when statement contains bind variables?",NULL,0,1,0},
  {"autocomplete",  (char*)   1,         0, IDI_AUTOCOMPLETE, 0, O_BOOLEAN, "Autocomplete",           "Should autocomplete be active when you press TAB?",NULL,0,1,0},
  {"autotrace",     (char*)   0,         0, IDI_AUTOTRACE,    0, O_BOOLEAN, "Autotrace",              "When autotrace is enabled, the execution plan is displayed in the sql analyzer window",NULL,0,1,0},
  {"backgroundcolor",(char*)"r255g255b255",          13, 0,   0, O_COLOR,   "",                       "What is the background color for this database?",(SetOptionProc)ChangeBackgroundColor,0,1,1 },
  {"commandhistory",(char*)100,          0, 0,                0, O_INT,     "",                       "How many previous commands are kept in memory?",NULL,1,1,0 },
  {"debug",         (char*)   0,         0, IDI_DEBUG,        0, O_BOOLEAN, "Turn debug on",          "If set, debug information is written to jbsql.log",NULL,0,1,0},
  {"directory",     ".",          MAX_PATH, 0,                0, O_DIR,     "",                       "What is the startup directory?",NULL,0,1,0 },
  {"editor",        "notepad.exe",MAX_PATH, 0,                0, O_CHAR,    "",                       "Specifies what editor to use with the 'edit' command",NULL,0,1,0 },
  {"edit_filename", "afiedt.buf", MAX_PATH, 0,                0, O_CHAR,    "",                       "Specifies what filename to create with the 'edit' command",NULL,0,1,0 },
  {"fastresults",   (char*)  20,         0, 0,                0, O_INT,     "",                       "show this many results as soon as they are available",NULL,0,1,0 },
  {"favdir",        (char*)  "",  MAX_PATH, 0,                0, O_DIR,     "",                       "The directory where to store the favourites",NULL,0,1,0 },
  {"feedback",      (char*)   1,         0, IDI_FEEDBACK,     0, O_BOOLEAN, "Show Feedback",          "If set, then a result is shown each time a statement is successfully processed",NULL,0,1,0 },
  {"font",          "Courier New,10,400,0",  MAX_PATH, 0,     0, O_FONT,    "Font",                   "The font to use in the command window",ChangeFont,0,0,0 },
  {"font_lv",       "Segoe UI,9,400,0",      MAX_PATH, 0,     0, O_FONTVAR, "Font Listview",          "The font to use in the results listview",(SetOptionProc)ChangeLVFont,0,0,0 },
  {"heading",       (char*)   1,         0, IDI_HEADING,      0, O_BOOLEAN, "Show Headers",           "Should headings be printed when output to screen is enabled or spooling is on?",NULL,0,1,0 },
  {"history",       (char*)   1,         0, IDI_HISTORY,      0, O_BOOLEAN, "Keep history",           "Keep a history of all executed statements",NULL,0,1,0 },
  {"listview",      (char*)   1,         0, IDI_LISTVIEW,     0, O_BOOLEAN, "Show results in list",   "Should query output appear in the listview table at the bottom?",NULL,0,1,0 },
  {"long",          (char*)4000,         0, 0,                0, O_INT,     "",                       "The size queries from LONG, LONG RAW, BLOB, CLOB and BFILE colums",NULL,1,1,0 },
  {"max_scripts",   (char*)20,           0, 0,                0, O_INT,     "",                       "How many nested scripts are allowed?",NULL,1,1,0 },
  {"maxlines",      (char*)1000,         0, 0,                0, O_INT,     "",                       "How many lines are buffered in the console window?",NULL,1,1,0 },
  {"maxmem",        (char*)10485760,     0, 0,                0, O_INT,     "",                       "The maximum memory usage for queries, if array_size*record_size > maximum_memory then the arraysize is automatically adjusted to fit into the maximum memory usage",NULL,1,1,0 },
  {"nullstr",       "(null)",     MAX_PATH, 0,                0, O_CHAR,    "",                       "Specifies the value to print for NULL values",NULL,0,1,0 },
  {"savehistory",   (char*)   1,         0, IDI_SAVEHISTORY,  0, O_BOOLEAN, "Save history",           "Saves the command history to a file when you exit jbsql and reads them back in when you start jbsql",NULL,0,1,0 },
  {"scan",          (char*)   1,         0, IDI_SCAN,         0, O_BOOLEAN, "Scan scripts",           "Scan scripts for & characters and ask for replacements",NULL,0,1,0 },
  {"screen",        (char*)   0,         0, IDI_SCREEN,       1, O_BOOLEAN, "Output to screen",       "Is output from queries to the console on?",NULL,0,1,0 },
  {"serveroutput",  (char*)   1,         0, IDI_SERVEROUTPUT, 1, O_BOOLEAN, "Show server output",     "Displays output generated by dbms_output",EnableServerOutput,0,1,0 },
  {"sound",         (char*)   1,         0, IDI_SOUND,        1, O_BOOLEAN, "Make a sound",           "Make a sound when long running statements are finished",NULL,0,1,0 },
  {"soundfile",     "ringin.wav", MAX_PATH, 0,                0, O_CHAR,    "The wav file",           "Specifies the WAV file to play when a long running statement has finished",NULL,0,1,0 },
  {"soundtime",     (char*)  60,         0, 0,                0, O_INT,     "The time of a statement","The number of seconds a statement must be running and after which a sound should be played",NULL,0,1,0 },
  {"sqlprompt",     "SQL>",            200, 0,                0, O_CHAR,    "",                       "The console prompt. The following variables are replaced: \n_CONNECT_IDENTIFIER\n_DATE\n_EDITOR\n_O_VERSION\n_O_RELEASE\n_PRIVILEGE\n_SQLPLUS_RELEASE\n_USER\n+ any 'defined' variable",NULL,0,1,0 },
  {"timing",        (char*)   1,         0, IDI_TIMING,       0, O_BOOLEAN, "Show timing",            "If enabled, displays elapsed time information for each sql statement",NULL,0,1,0 },
  {"trimspool",     (char*)   1,         0, IDI_TRIMSPOOL,    0, O_BOOLEAN, "Trim spoolfile",         "If enabled, trims end of lines in spoolfile",NULL,0,1,0 },
  {"verify",        (char*)   1,         0, IDI_VERIFY,       0, O_BOOLEAN, "Verify user input",      "If enabled, displays old and new values for replaced && variables in a script",NULL,0,1,0 },
  {"versioncheck",  (char*)   1,         0, IDI_VERSIONCHECK, 0, O_BOOLEAN, "Check for new version",  "If enabled, Regularely check for a new version of jbsql",NULL,0,1,0 },
};
