#include "jbsql.h"
#include "ccsplitter.h"

#define SPLITTER_CLASS_NAME "SplitterClass"
int window_h_offset, window_v_offset;

/*void ResizeOtherWindows(void)
{
  RECT  sr;
  RECT  rc;
  RECT  sr2;
  RECT  tr;

  if (GetClientRect(g_hWnd, &rc)==0)
    return;
  if (GetWindowRect(hwndSplitter, &sr)==0)
    return;
  if (GetClientRect(hwndSplitter, &sr2)==0)
    return;
  if (GetWindowRect(g_toolbar, &tr)==0)
    return;

  MoveWindow( hwndTextBox,
    0,
    tr.bottom-tr.top,
    rc.right - rc.left,
    (rc.bottom-rc.top)-(sr.bottom - sr.top)+window_v_offset-(tr.bottom-tr.top),
    TRUE);
  MoveWindow( hwndListView,
    0,
    0,
    rc.right - rc.left,
    (sr2.bottom-sr2.top),
    TRUE);
  MoveWindow( g_toolbar,
    0,
    0,
    rc.right-rc.left,
    tr.bottom-tr.top,
    TRUE);
} */

/*void ResizeSplitter(HWND hwndSplitter, HWND hwndParent)
{
  RECT  rc;
  RECT  sr;

  GetClientRect(hwndParent, &rc);
  GetWindowRect(hwndSplitter, &sr);

  MoveWindow( hwndSplitter,
    -window_h_offset,            // Don't show the left resize border
    (rc.bottom-rc.top)-(sr.bottom-sr.top)+window_v_offset, // Height of parent window - splitter height
    (rc.right - rc.left)+2*window_h_offset, // Don't show the right resize border
    sr.bottom - sr.top,     // Old height
    TRUE);
  ResizeOtherWindows();
}*/

int IsSimpleQuery(char* command, char* owner, char* table)
{
    size_t x, lastpos, from_found = 0, len = strlen(command);
    char* token = NULL;
    int brackets = 0, in_quotes = 0;

    Trim(command);
    for (x = 0; x < len; x++)
    {
        if (strchr(SQL_DELIMITERS, command[x]))
        {
            if (command[x] == '"')
            {
                command[x] = '\0';
                in_quotes = !in_quotes;
                if (in_quotes)
                    lastpos = x + 1;
                continue;
            }
            if (in_quotes)
                continue;
            if (token == NULL) // First token must be SELECT
            {
                command[x] = '\0';
                token = command;
                if (_stricmp(token, "SELECT"))
                    return 0;
                lastpos = x + 1;
            }
            else
            {
                if (!from_found)
                {
                    if (command[x] == '(')
                        brackets++;
                    else if (brackets && command[x] == ')')
                        brackets--;
                    if (!brackets)
                    {
                        command[x] = '\0';
                        token = &command[lastpos];
                        if (!_stricmp(token, "FROM"))
                        {
                            from_found = 1;
                        }
                    }
                }
                else
                {
                    if (from_found == 1)
                    {
                        if (command[x] == '.')
                        {
                            command[x] = '\0';
                            token = &command[lastpos];
                            strncpy(owner, token, 30);
                        }
                        else
                        {
                            command[x] = '\0';
                            token = &command[lastpos];
                            strcpy(table, token);
                        }
                    }
                    else if (from_found == 2) // after the from comes the table name, so skip one token
                    {
                        if (command[x] == ',') // There should be no "," -> select from multiple tables
                            return 0;
                        else
                        {
                            command[x] = '\0';
                            token = &command[lastpos];
                            if (!_stricmp(token, "UNION") || !_stricmp(token, "JOIN") || !_stricmp(token, "LEFT") || !_stricmp(token, "RIGHT") || !_stricmp(token, "INNER") || !_stricmp(token, "NATURAL") || !_stricmp(token, "FULL"))
                                return 0;
                            if (owner[0] != '\0')
                            {
                                strncpy(table, token, 30);
                            }
                        }
                    }
                    else if (from_found == 3 || from_found == 4)
                    {
                        command[x] = '\0';
                        token = &command[lastpos];
                        if (!_stricmp(token, "UNION") || !_stricmp(token, "JOIN") || !_stricmp(token, "LEFT") || !_stricmp(token, "RIGHT") || !_stricmp(token, "INNER") || !_stricmp(token, "NATURAL") || !_stricmp(token, "FULL"))
                            return 0;
                    }
                    else
                    {
                        if (!_stricmp(token, "UNION"))
                            return 0;
                    }
                    from_found++;
                }
                lastpos = x + 1;
            }
        }
    }
    if (from_found && owner[0] == '\0')
    {
        char* object_ptr = NULL, * owner_ptr = NULL;
        if (table[0] == '\0')
            GetUserID(&command[lastpos], &owner_ptr, &object_ptr, 0);
        else
            GetUserID(table, &owner_ptr, &object_ptr, 0);
        if (owner_ptr)
        {
            strncpy(owner, owner_ptr, 30);
            free(owner_ptr);
        }
        if (object_ptr)
        {
            strncpy(table, object_ptr, 30);
            free(object_ptr);
        }
    }
    return (int)from_found;
}

void ClearTableMenu(TextWidget * text, HMENU * menu)
{
    int x, y;

    for (x = 0; x < text->ntable_items; x++)
    {
        free(text->table_items[x].owner);
        free(text->table_items[x].table);
        free(text->table_items[x].constraint);
        free(text->table_items[x].columns);
        for (y = 0; y < text->table_items[x].nrcolumns; y++)
        {
            free(text->table_items[x].rcolumns[y]);
        }
        free(text->table_items[x].rcolumns);
    }
    DestroyMenu(*menu);
    *menu = CreatePopupMenu();
    free(text->table_items);
    text->table_items = NULL;
    text->ntable_items = 0;
}


int GetTableList(TextWidget * text, HMENU * menu, int child_tables)
{
    int retval = 1, ncommand;

    char table_name[129] = "", owner[129] = "", * command;
    ncommand = GetPreviousSQLCommand();
    if (ncommand != -1)
    {
        command = _strdup(old_commands[ncommand].command);
        if (IsSimpleQuery(command, owner, table_name))
        {
            HCURSOR hc;

            ClearTableMenu(text, menu);

            hc = SetCursor(LoadCursor(NULL, IDC_WAIT));
            if (child_tables)
                retval = !OCIFillMenuFromQuery(text, *menu, "select ac2.owner,ac2.table_name,ac2.constraint_name,ac1.constraint_name from all_constraints ac1,all_constraints ac2 where (ac1.owner=upper(:1) or ac1.owner=:1) and (ac1.table_name=:2 or ac1.table_name=upper(:2)) and ac1.constraint_type IN ('P','U') and ac2.r_constraint_name=ac1.constraint_name and ac2.r_owner=ac1.owner order by 1,2", owner, table_name);
            else
                retval = !OCIFillMenuFromQuery(text, *menu, "select ac2.owner,ac2.table_name,ac1.constraint_name,ac2.constraint_name from all_constraints ac1,all_constraints ac2 where (ac1.owner=upper(:1) or ac1.owner=:1) and (ac1.table_name=:2 or ac1.table_name=upper(:2)) and ac1.constraint_type IN ('R') and ac2.constraint_name=ac1.r_constraint_name and ac2.owner=ac1.r_owner order by 1,2", owner, table_name);
            SetCursor(hc);
        }
        else
            retval = 0;
    }
    return retval;
}


void ShowParentChildTables(TextWidget * text, HWND hWnd)
{
    if (ora_connected && GetTableList(text, &g_menu_tables, text->table_children))
    {
        POINT cursorPos;
        int x;
        BOOL menuitem;


        GetCursorPos(&cursorPos);

        menuitem = TrackPopupMenu(g_menu_tables,
            TPM_LEFTALIGN | TPM_TOPALIGN | TPM_RETURNCMD | TPM_RIGHTBUTTON | TPM_RECURSE,
            cursorPos.x,
            cursorPos.y,
            0,
            hWnd,
            NULL);

        for (x = 0; x < text->ntable_items; x++)
        {
            if (text->table_items[x].item == menuitem)
            {
                SelectTableData(text, &text->table_items[x]);
                break;
            }
        }
    }
}

HWND CreateSplitter(HINSTANCE hInstance, HWND hwndParent)
{
    RECT rc;

    GetClientRect(hwndParent, &rc);

    HWND hSplitter = CreateWindowEx(
        0,						// Extended window style
        WC_CCSPLITTER,			// Window class name
        NULL,					// Window name
        WS_CHILD | WS_VISIBLE,	// Window style
        0, 0, rc.right, rc.bottom,				// Position & size
        hwndParent,					// Parent window handle
        (HMENU)ID_SPLITTER,		// Application defined ID
        hInst,					// Application instance
        0);						// Parameter

    if (hSplitter == NULL) {
        MessageBox(0, "CreateWindowEx failed in MonitorProc", NULL, MB_ICONSTOP | MB_OK);
        exit(1);
    }
    return hSplitter;
}

