#include "sql_analyze.h"
#include "ccsplitter.h"
#include "jboci.h"

#define SQLSPLITTER_CLASS_NAME "SQLSplitterClass"

char *planstr = NULL;
HWND hWndAnalyzeSplitter;

void FillIndexList(HWND tables, HWND listbox)
{
	int selection_count, *selected_items, x;
	char *table_name;

	selection_count = (int)SendMessage(tables, LB_GETSELCOUNT, 0, 0);
	if (selection_count > 0)
	{
		selected_items = (int*)malloc(selection_count * sizeof(int));
		SendMessage(tables, LB_GETSELITEMS, selection_count, (LPARAM)selected_items);
		for (x = 0; x < selection_count; x++)
		{
			table_name = (char*)malloc(40 * sizeof(char));
			SendMessage(tables, LB_GETTEXT, selected_items[x], (LPARAM)table_name);
			FillListBoxFromQuery(g_oci, listbox, "select index_name from all_indexes where owner=sys_context( 'userenv', 'current_schema' ) and table_name=:table_name", (char**)&table_name, 1, 1, 129);
			free(table_name);
		}
		free(selected_items);
	}
	else if (selection_count == LB_ERR)
	{
		x = (int)SendMessage(tables, LB_GETCURSEL, 0, 0);
		if (x != LB_ERR)
		{
			table_name = (char*)malloc(40 * sizeof(char));
			SendMessage(tables, LB_GETTEXT, x, (LPARAM)table_name);
			FillListBoxFromQuery(g_oci, listbox, "select index_name from all_indexes where owner=sys_context( 'userenv', 'current_schema' ) and table_name=:table_name", (char**)&table_name, 1, 1, 129);
			free(table_name);
		}
	}
}

void FillHintLists(HWND hWnd)
{
	int selection, x;
	char hint[40];
	HWND tables;

	SendDlgItemMessage(hWnd, IDC_TABLES, LB_RESETCONTENT, 0, 0);
	SendDlgItemMessage(hWnd, IDC_INDEXES, LB_RESETCONTENT, 0, 0);
	SendDlgItemMessage(hWnd, IDC_TABLES2, LB_RESETCONTENT, 0, 0);
	SendDlgItemMessage(hWnd, IDC_INDEXES2, LB_RESETCONTENT, 0, 0);
	ShowWindow(GetDlgItem(hWnd, IDC_TABLES), SW_HIDE);
	ShowWindow(GetDlgItem(hWnd, IDC_INDEXES), SW_HIDE);
	ShowWindow(GetDlgItem(hWnd, IDC_TABLES2), SW_HIDE);
	ShowWindow(GetDlgItem(hWnd, IDC_INDEXES2), SW_HIDE);
	ShowWindow(GetDlgItem(hWnd, IDC_TABLE_TEXT), SW_HIDE);
	ShowWindow(GetDlgItem(hWnd, IDC_INDEX_TEXT), SW_HIDE);
	selection = (int)SendDlgItemMessage(hWnd, IDC_HINTS, CB_GETCURSEL, 0, 0);
	if (selection != CB_ERR)
	{
		SendDlgItemMessage(hWnd, IDC_HINTS, CB_GETLBTEXT, selection, (LPARAM)hint);
		for (x = 0; x < nhints; x++)
		{
			if (!strcmp(hint, sqlhints[x].hint))
			{
				SetDlgItemText(hWnd, IDC_HINT_TIP, sqlhints[x].description);
				if (sqlhints[x].table)
				{
					if (sqlhints[x].table == 1)
					{
						tables = GetDlgItem(hWnd, IDC_TABLES);
						SetDlgItemText(hWnd, IDC_TABLE_TEXT, "Table:");
					}
					else
					{
						tables = GetDlgItem(hWnd, IDC_TABLES2);
						SetDlgItemText(hWnd, IDC_TABLE_TEXT, "Tables:");
					}
					ShowWindow(tables, SW_SHOW);
					ShowWindow(GetDlgItem(hWnd, IDC_TABLE_TEXT), SW_SHOW);
					FillListBoxFromQuery(g_oci, tables, "select table_name from all_tables where owner=sys_context( 'userenv', 'current_schema' )", NULL, 0, 1, 129);
					if (sqlhints[x].index == 1)
					{
						ShowWindow(GetDlgItem(hWnd, IDC_INDEX_TEXT), SW_SHOW);
						SetDlgItemText(hWnd, IDC_INDEX_TEXT, "Index:");
						ShowWindow(GetDlgItem(hWnd, IDC_INDEXES), SW_SHOW);
						FillIndexList(tables, GetDlgItem(hWnd, IDC_INDEXES));
					}
					else if (sqlhints[x].index > 1)
					{
						ShowWindow(GetDlgItem(hWnd, IDC_INDEX_TEXT), SW_SHOW);
						SetDlgItemText(hWnd, IDC_INDEX_TEXT, "Indexes:");
						ShowWindow(GetDlgItem(hWnd, IDC_INDEXES2), SW_SHOW);
						FillIndexList(tables, GetDlgItem(hWnd, IDC_INDEXES2));
					}
				}
				break;
			}
		}
	}
}

void TableHintChanged(HWND hWnd)
{
	int selection, x;
	char hint[40];
	HWND tables;

	SendDlgItemMessage(hWnd, IDC_INDEXES, LB_RESETCONTENT, 0, 0);
	SendDlgItemMessage(hWnd, IDC_INDEXES2, LB_RESETCONTENT, 0, 0);
	selection = (int)SendDlgItemMessage(hWnd, IDC_HINTS, CB_GETCURSEL, 0, 0);
	if (selection != CB_ERR)
	{
		SendDlgItemMessage(hWnd, IDC_HINTS, CB_GETLBTEXT, selection, (LPARAM)hint);
		for (x = 0; x < nhints; x++)
		{
			if (!strcmp(hint, sqlhints[x].hint))
			{
				if (sqlhints[x].table)
				{
					if (sqlhints[x].table == 1)
					{
						tables = GetDlgItem(hWnd, IDC_TABLES);
					}
					else
					{
						tables = GetDlgItem(hWnd, IDC_TABLES2);
					}
					if (sqlhints[x].index == 1)
					{
						FillIndexList(tables, GetDlgItem(hWnd, IDC_INDEXES));
					}
					else if (sqlhints[x].index > 1)
					{
						FillIndexList(tables, GetDlgItem(hWnd, IDC_INDEXES2));
					}
				}
				break;
			}
		}
	}
}

char *ComposeHint(HWND hWnd)
{
	int selection, x, table_selection, index_selection, table_count, *selected_tables, index_count, *selected_indexes;
	char hint[40], table[40], index[40];
	static char new_hint[1000] = "";

	new_hint[0] = '\0';
	selection = (int)SendDlgItemMessage(hWnd, IDC_HINTS, CB_GETCURSEL, 0, 0);
	if (selection != CB_ERR)
	{
		SendDlgItemMessage(hWnd, IDC_HINTS, CB_GETLBTEXT, selection, (LPARAM)hint);
		for (x = 0; x < nhints; x++)
		{
			if (!strcmp(hint, sqlhints[x].hint))
			{
				if (x == 0)
					break;
				sprintf(new_hint, "/*+ %s", hint);
				if (sqlhints[x].table)
				{
					strcat(new_hint, " (");
					if (sqlhints[x].table == 1)
					{
						table_selection = (int)SendDlgItemMessage(hWnd, IDC_TABLES, LB_GETCURSEL, 0, 0);
						if (table_selection != LB_ERR)
						{
							SendDlgItemMessage(hWnd, IDC_TABLES, LB_GETTEXT, table_selection, (LPARAM)table);
							strcat(new_hint, table);
						}
					}
					else
					{
						table_count = (int)SendDlgItemMessage(hWnd, IDC_TABLES2, LB_GETSELCOUNT, 0, 0);
						if (table_count > 0)
						{
							selected_tables = (int*)malloc(table_count * sizeof(int));
							SendDlgItemMessage(hWnd, IDC_TABLES2, LB_GETSELITEMS, table_count, (LPARAM)selected_tables);
							for (x = 0; x < table_count; x++)
							{
								SendDlgItemMessage(hWnd, IDC_TABLES2, LB_GETTEXT, selected_tables[x], (LPARAM)table);
								if (x > 0)
									strcat(new_hint, " ");
								strcat(new_hint, table);
							}
							free(selected_tables);
						}
					}
					if (sqlhints[x].index == 1)
					{
						index_selection = (int)SendDlgItemMessage(hWnd, IDC_INDEXES, LB_GETCURSEL, 0, 0);
						if (index_selection != LB_ERR)
						{
							SendDlgItemMessage(hWnd, IDC_INDEXES, LB_GETTEXT, index_selection, (LPARAM)index);
							strcat(new_hint, index);
						}
					}
					else if (sqlhints[x].index > 1)
					{
						index_count = (int)SendDlgItemMessage(hWnd, IDC_INDEXES2, LB_GETSELCOUNT, 0, 0);
						if (index_count > 0)
						{
							selected_indexes = (int*)malloc(index_count * sizeof(int));
							SendDlgItemMessage(hWnd, IDC_INDEXES2, LB_GETSELITEMS, index_count, (LPARAM)selected_indexes);
							for (x = 0; x < index_count; x++)
							{
								SendDlgItemMessage(hWnd, IDC_INDEXES2, LB_GETTEXT, selected_indexes[x], (LPARAM)index);
								strcat(new_hint, " ");
								strcat(new_hint, index);
							}
							free(selected_indexes);
						}
					}
					strcat(new_hint, ")");
				}
				strcat(new_hint, " */");
				break;
			}
		}
	}
	return new_hint;
}

void DeleteCharacterFromString(char *str, int x)
{
	memmove(&str[x], &str[x + 1], strlen(&str[x + 1]) + 1);
}

void InsertStringIntoString(char *str, int x, char *chars)
{
	memmove(&str[x + strlen(chars)], &str[x], strlen(&str[x]) + 1);
	memcpy(&str[x], chars, strlen(chars));
}

void AddNewHint(HWND hWnd)
{
	char *new_hint, *sql_statement;
	int stmt_len, x;
	char tmp;

	new_hint = ComposeHint(hWnd);
	stmt_len = (int)SendDlgItemMessage(hWnd, IDC_SQL_STATEMENT, WM_GETTEXTLENGTH, 0, 0);
	sql_statement = (char*)malloc(stmt_len + 1000);
	GetDlgItemText(hWnd, IDC_SQL_STATEMENT, sql_statement, stmt_len + 1);
	for (x = 0; x < (int)strlen(sql_statement); x++)
	{
		if (strchr(" \t\n\r", sql_statement[x]))
		{
			tmp = sql_statement[x];
			sql_statement[x] = '\0';
			if (!_stricmp(sql_statement, "select") ||
				!_stricmp(sql_statement, "update") ||
				!_stricmp(sql_statement, "delete"))
			{
				sql_statement[x] = tmp;
				x++;
				/* Find next non blank */
				while (x < (int)strlen(sql_statement) && strchr(" \t\n\r", sql_statement[x]))
					x++;
				if (!strncmp(&sql_statement[x], "/*+", 3)) /* Hint is already there */
				{
					DeleteCharacterFromString(sql_statement, x);
					DeleteCharacterFromString(sql_statement, x);
					DeleteCharacterFromString(sql_statement, x);
					while (sql_statement[x] && strncmp(&sql_statement[x], "*/", 2))
						DeleteCharacterFromString(sql_statement, x);
					if (!strncmp(&sql_statement[x], "*/", 2))
					{
						DeleteCharacterFromString(sql_statement, x);
						DeleteCharacterFromString(sql_statement, x);
						if (strlen(new_hint) == 0 && sql_statement[x] == ' ')
							DeleteCharacterFromString(sql_statement, x);
					}
					InsertStringIntoString(sql_statement, x, new_hint);
				}
				else
				{
					if (strlen(new_hint) > 0)
					{
						InsertStringIntoString(sql_statement, x, new_hint);
						InsertStringIntoString(sql_statement, x + (int)strlen(new_hint), " ");
					}
				}
			}
			else
				sql_statement[x] = tmp;
			break;
		}
	}
	SetDlgItemText(hWnd, IDC_SQL_STATEMENT, sql_statement);
	free(sql_statement);
}

void ResizeSQLAnalyzer(HWND hWnd)
{
	RECT r, r2;
#define ITEM_DISTANCE 7
#define HINT_TIP_HEIGHT 70
#define PLAN_TREE_HEIGHT 150
#define BUTTON_HEIGHT 20
#define BUTTON_WIDTH 70
#define PROMPT_WIDTH 40
	int splitter_height;
	HWND shWnd;

	GetClientRect(hWnd, &r);
    shWnd = CCsplitter_GetHandle(hWndAnalyzeSplitter, CCSPV_BOTTOM);
    if (shWnd == NULL)
        return;
	GetWindowRect(shWnd, &r2);
	splitter_height = r2.bottom - r2.top;

    SetWindowPos(GetDlgItem(hWnd, IDC_HINT_TIP),
		NULL,
		10 + window_h_offset,
		r.bottom - HINT_TIP_HEIGHT - window_v_offset - 5,
		(r.right - r.left) - 20,
		HINT_TIP_HEIGHT - 5 - window_v_offset,
		SWP_NOACTIVATE | SWP_NOZORDER);
    SetWindowPos(GetDlgItem(hWnd, IDC_PLAN_TREE),
		NULL,
		10 + window_h_offset,
		(r.bottom - splitter_height) + 5,
		(r.right - r.left) - 20,
		splitter_height - HINT_TIP_HEIGHT - ITEM_DISTANCE - 10 - window_v_offset,
		SWP_NOACTIVATE );
	SetWindowPos(GetDlgItem(hWnd, IDC_EXECUTE),
		NULL,
		10,
		r.bottom - splitter_height - BUTTON_HEIGHT - ITEM_DISTANCE * 1,
		BUTTON_WIDTH,
		BUTTON_HEIGHT,
		SWP_NOACTIVATE | SWP_NOZORDER);
	SetWindowPos(GetDlgItem(hWnd, IDC_CLOSE),
		NULL,
		10 + BUTTON_WIDTH + ITEM_DISTANCE,
		r.bottom - splitter_height - BUTTON_HEIGHT - ITEM_DISTANCE * 1,
		BUTTON_WIDTH,
		BUTTON_HEIGHT,
		SWP_NOACTIVATE | SWP_NOZORDER);
	SetWindowPos(GetDlgItem(hWnd, IDC_EXPLAIN_PLAN),
		NULL,
		10,
		r.bottom - splitter_height - 2 * BUTTON_HEIGHT - ITEM_DISTANCE * 2,
		BUTTON_WIDTH,
		BUTTON_HEIGHT,
		SWP_NOACTIVATE | SWP_NOZORDER);
	SetWindowPos(GetDlgItem(hWnd, IDC_COPY_CLIPBOARD),
		NULL,
		10 + BUTTON_WIDTH + ITEM_DISTANCE,
		r.bottom - splitter_height - 2 * BUTTON_HEIGHT - ITEM_DISTANCE * 2,
		BUTTON_WIDTH,
		BUTTON_HEIGHT,
		SWP_NOACTIVATE | SWP_NOZORDER);
	SetWindowPos(GetDlgItem(hWnd, IDC_HINT_TEXT),
		NULL,
		10,
		r.bottom - splitter_height - 3 * BUTTON_HEIGHT - ITEM_DISTANCE * 3 + 2,
		PROMPT_WIDTH - 20,
		BUTTON_HEIGHT,
		SWP_NOACTIVATE | SWP_NOZORDER);
	SetWindowPos(GetDlgItem(hWnd, IDC_HINTS),
		NULL,
		10 + PROMPT_WIDTH - 10,
		r.bottom - splitter_height - 3 * BUTTON_HEIGHT - ITEM_DISTANCE * 3,
		(r.right - r.left - 20) / 3 - PROMPT_WIDTH + 10 - ITEM_DISTANCE,
		BUTTON_HEIGHT,
		SWP_NOACTIVATE | SWP_NOZORDER);
	SetWindowPos(GetDlgItem(hWnd, IDC_TABLE_TEXT),
		NULL,
		10 + (r.right - r.left - 20) / 3,
		r.bottom - splitter_height - 3 * BUTTON_HEIGHT - ITEM_DISTANCE * 3 + 2,
		PROMPT_WIDTH,
		BUTTON_HEIGHT,
		SWP_NOACTIVATE | SWP_NOZORDER);
	SetWindowPos(GetDlgItem(hWnd, IDC_TABLES),
		NULL,
		10 + (r.right - r.left - 20) / 3 + PROMPT_WIDTH,
		r.bottom - splitter_height - 3 * BUTTON_HEIGHT - ITEM_DISTANCE * 3,
		(r.right - r.left - 20) / 3 - PROMPT_WIDTH - ITEM_DISTANCE,
		3 * BUTTON_HEIGHT + 2 * ITEM_DISTANCE,
		SWP_NOACTIVATE | SWP_NOZORDER);
	SetWindowPos(GetDlgItem(hWnd, IDC_TABLES2),
		NULL,
		10 + (r.right - r.left - 20) / 3 + PROMPT_WIDTH,
		r.bottom - splitter_height - 3 * BUTTON_HEIGHT - ITEM_DISTANCE * 3,
		(r.right - r.left - 20) / 3 - PROMPT_WIDTH - ITEM_DISTANCE,
		3 * BUTTON_HEIGHT + 2 * ITEM_DISTANCE,
		SWP_NOACTIVATE | SWP_NOZORDER);
	SetWindowPos(GetDlgItem(hWnd, IDC_INDEX_TEXT),
		NULL,
		10 + 2 * ((r.right - r.left - 20) / 3),
		r.bottom - splitter_height - 3 * BUTTON_HEIGHT - ITEM_DISTANCE * 3 + 2,
		PROMPT_WIDTH,
		BUTTON_HEIGHT,
		SWP_NOACTIVATE | SWP_NOZORDER);
	SetWindowPos(GetDlgItem(hWnd, IDC_INDEXES),
		NULL,
		10 + 2 * ((r.right - r.left - 20) / 3) + PROMPT_WIDTH,
		r.bottom - splitter_height - 3 * BUTTON_HEIGHT - ITEM_DISTANCE * 3,
		(r.right - r.left - 20) / 3 - PROMPT_WIDTH,
		3 * BUTTON_HEIGHT + 2 * ITEM_DISTANCE,
		SWP_NOACTIVATE | SWP_NOZORDER);
	SetWindowPos(GetDlgItem(hWnd, IDC_INDEXES2),
		NULL,
		10 + 2 * ((r.right - r.left - 20) / 3) + PROMPT_WIDTH,
		r.bottom - splitter_height - 3 * BUTTON_HEIGHT - ITEM_DISTANCE * 3,
		(r.right - r.left - 20) / 3 - PROMPT_WIDTH,
		3 * BUTTON_HEIGHT + 2 * ITEM_DISTANCE,
		SWP_NOACTIVATE | SWP_NOZORDER);
	SetWindowPos(GetDlgItem(hWnd, IDC_SQL_STATEMENT),
		NULL,
		10,
		10,
		(r.right - r.left) - 20,
		r.bottom - (splitter_height + 4 * BUTTON_HEIGHT + ITEM_DISTANCE * 3),
		SWP_NOACTIVATE | SWP_NOZORDER);
	InvalidateRect(hWnd, &r, TRUE);
}

HWND CreateSQLSplitter(HINSTANCE hInstance, HWND hwndParent)
{
    RECT rc;
    GetClientRect(hwndParent, &rc);
    HWND hSplitter = CreateWindowEx(
        0,						// Extended window style
        WC_CCSPLITTER,			// Window class name
        NULL,					// Window name
        WS_CHILD | WS_VISIBLE,	// Window style
        0, 0, rc.right, rc.bottom,				// Position & size
        hwndParent,					// Parent window handle
        (HMENU)ID_SQLSPLITTER,		// Application defined ID
        hInst,					// Application instance
        0);						// Parameter
    return hSplitter;
}

void CopyPlanToClipboard(HWND hWnd)
{
	char *newplanstr, *lockedplanstr;

	if (OpenClipboard(hWnd))
	{
		EmptyClipboard();
		if (!planstr)
			planstr = _strdup("");
		newplanstr = GlobalAlloc(GMEM_DDESHARE, strlen(planstr) + 1);
		if (newplanstr != NULL)
		{
			lockedplanstr = GlobalLock(newplanstr);
			if (lockedplanstr != NULL)
			{
				strcpy(lockedplanstr, planstr);
				GlobalUnlock(newplanstr);
				if (SetClipboardData(CF_TEXT, newplanstr) == NULL)
					DisplayLastError(NULL);
			}
		}
		CloseClipboard();
	}
}

LRESULT CALLBACK AnalyzeProc(HWND hWnd,
	UINT uMessage,
	WPARAM wParam,
	LPARAM lParam)
{
	switch (uMessage)
	{
		case WM_INITDIALOG:
			{
				HFONT f;
				HDC hDC;
				int x;
				HWND h;

				SetFocus(hWnd);
				hDC = GetDC(hWnd);
				f = CreateFont(-MulDiv(10, GetDeviceCaps(hDC, LOGPIXELSY), 72), // logical height of font
					0,                     // logical average character width
					0,                     // angle of escapement
					0,                     // base-line orientation angle
					FW_NORMAL,             // font weight
					FALSE,                 // italic attribute flag
					FALSE,                 // underline attribute flag
					FALSE,                 // strikeout attribute flag
					DEFAULT_CHARSET,       // character set identifier
					OUT_DEFAULT_PRECIS,    // output precision
					CLIP_DEFAULT_PRECIS,   // clipping precision
					DEFAULT_QUALITY,       // output quality
					FF_MODERN,             // pitch and family
					"Courier New"          // pointer to typeface name string
				);

				SendMessage(GetDlgItem(hWnd, IDC_SQL_STATEMENT), WM_SETFONT, (WPARAM)f, (LPARAM)TRUE);
				SendMessage(GetDlgItem(hWnd, IDC_SQL_STATEMENT), EM_SETLIMITTEXT, (WPARAM)0xFFFFFFFF, (LPARAM)0);

				ReleaseDC(hWnd, hDC);
				for (x = 0; x < nhints; x++)
				{
					SendDlgItemMessage(hWnd, IDC_HINTS, CB_ADDSTRING, 0, (LPARAM)sqlhints[x].hint);
				}
				SendDlgItemMessage(hWnd, IDC_HINTS, CB_SETCURSEL, SendDlgItemMessage(hWnd, IDC_HINTS, CB_FINDSTRING, -1, (LPARAM)"None"), 0);
				FillHintLists(hWnd);

                h = CreateWindowEx(WS_EX_WINDOWEDGE,          // ex style
                    "EDIT",                    // class name
                    "",                        // dummy text
                    WS_CHILD | WS_VISIBLE | WS_BORDER | ES_READONLY | WS_VSCROLL | ES_LEFT | ES_MULTILINE | ES_AUTOVSCROLL,     // style
                    10,                        // x position
                    1,                         // y position
                    100,                       // width
                    HINT_TIP_HEIGHT,           // height
                    hWnd,                     // parent
                    (HMENU)IDC_HINT_TIP,       // ID
                    g_hInst,                   // instance
                    NULL);                     // no extra data
                SendMessage(h, WM_SETFONT, (WPARAM)f, (LPARAM)TRUE);
                

                h = CreateWindowEx(WS_EX_WINDOWEDGE,          // ex style
                    WC_TREEVIEW,             // class name
                    "",                        // dummy text
                    WS_CHILD | WS_VISIBLE | TVS_HASLINES | TVS_HASBUTTONS,     // style
                    10,                        // x position
                    1,                         // y position
                    100,                       // width
                    PLAN_TREE_HEIGHT,          // height
                    hWnd,                     // parent
                    (HMENU)IDC_PLAN_TREE,      // ID
                    g_hInst,                   // instance
                    NULL);                     // no extra data

                hWndAnalyzeSplitter = CreateSQLSplitter(g_hInst, hWnd);

				h = CreateWindowEx(WS_EX_WINDOWEDGE,          // ex style
					GS_VIEW_WINDOW,             // class name
					"",                        // dummy text
					WS_CHILD ,     // style
					10,                        // x position
					1,                         // y position
					100,                       // width
					PLAN_TREE_HEIGHT,          // height
                    hWndAnalyzeSplitter,                     // parent
					(HMENU)1,      // ID
					g_hInst,                   // instance
					NULL);                     // no extra data
                CCsplitter_SetHandle(hWndAnalyzeSplitter, CCSPV_TOP, h);

                h = CreateWindowEx(WS_EX_WINDOWEDGE,          // ex style
                    GS_VIEW_WINDOW,             // class name
                    "",                        // dummy text
                    WS_CHILD ,     // style
                    10,                        // x position
                    1,                         // y position
                    100,                       // width
                    PLAN_TREE_HEIGHT,          // height
                    hWndAnalyzeSplitter,                     // parent
                    (HMENU)2,      // ID
                    g_hInst,                   // instance
                    NULL);                     // no extra data
                CCsplitter_SetHandle(hWndAnalyzeSplitter, CCSPV_BOTTOM, h);



                CCSPLIT	spy;			// Y-split data
                RECT rc;

                GetClientRect(hWnd, &rc);
                spy.cbSize = sizeof(spy);
                spy.flags = CCSP_POS;
                spy.pos = rc.bottom / 2;
                CCsplitter_SetSplit(hWndAnalyzeSplitter, NULL, &spy);

				ResizeSQLAnalyzer(hWnd);
                DeleteObject(f);
				break;
			}
		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
				case IDC_EXPLAIN_PLAN:
					{
						int len;
						char *str;

						if (tid)
							return TRUE;
						len = (int)SendMessage(GetDlgItem(hWnd, IDC_SQL_STATEMENT), WM_GETTEXTLENGTH, 0, 0);
						if (len)
						{
							str = (char*)malloc(len + 1);
							GetDlgItemText(hWnd, IDC_SQL_STATEMENT, str, len + 1);
                            SendMessage(GetDlgItem(hWnd, IDC_PLAN_TREE), WM_SETREDRAW, FALSE, 0);
                            ExplainPlan(hWnd, str);
                            SendMessage(GetDlgItem(hWnd, IDC_PLAN_TREE), WM_SETREDRAW, TRUE, 0);
                            free(str);
						}
						return TRUE;
					}
				case IDC_EXECUTE:
					{
						int len, slen, x, lastx = 0;
						char *str;

						if (tid)
							return TRUE;
						len = (int)SendMessage(GetDlgItem(hWnd, IDC_SQL_STATEMENT), WM_GETTEXTLENGTH, 0, 0);
						if (len)
						{
							str = (char*)malloc(len + 2);
							GetDlgItemText(hWnd, IDC_SQL_STATEMENT, str, (int)len + 2);
							Trim(str);
							if (str[strlen(str) - 1] != ';')
								strcat(str, ";");
							g_text->no_process = 1;
							StartFastDraw(g_text, 0);
							slen = (int)strlen(str);
							for (x = 0; x < slen; x++)
							{
								switch (str[x])
								{
									case '\r':
										str[x] = '\0';
										InsertLineBuffer(g_text, "%s", &str[lastx]);
										InsertNewLineBuffer(g_text);
										lastx = x + 2;
										break;
									default:
										break;
								}
							}
							if (lastx < slen)
								InsertLineBuffer(g_text, "%s", &str[lastx]);
							g_text->no_process = 0;
							EndFastDraw(g_text);
							InsertNewLineBuffer(g_text);
							free(str);
						}
						return TRUE;
					}
				case IDC_CLOSE:
					EndDialog(hWnd, FALSE);
					g_text->analyze = NULL;
					return TRUE;
				case IDC_COPY_CLIPBOARD:
					CopyPlanToClipboard(hWnd);
					return TRUE;
				case IDC_HINTS:
					if (tid)
						return TRUE;
					if (HIWORD(wParam) == CBN_SELCHANGE)
					{
						FillHintLists(hWnd);
						AddNewHint(hWnd);
					}
					break;
				case IDC_TABLES:
					if (tid)
						return TRUE;
					if (HIWORD(wParam) == CBN_SELCHANGE)
					{
						TableHintChanged(hWnd);
						AddNewHint(hWnd);
					}
					break;
				case IDC_TABLES2:
					if (tid)
						return TRUE;
					if (HIWORD(wParam) == CBN_SELCHANGE)
					{
						TableHintChanged(hWnd);
						AddNewHint(hWnd);
					}
					break;
				case IDC_INDEXES:
					if (tid)
						return TRUE;
					if (HIWORD(wParam) == CBN_SELCHANGE)
						AddNewHint(hWnd);
					break;
				case IDC_INDEXES2:
					if (tid)
						return TRUE;
					if (HIWORD(wParam) == CBN_SELCHANGE)
						AddNewHint(hWnd);
					break;
				case IDC_SQL_STATEMENT:
					switch (HIWORD(wParam))
					{
						case EN_ERRSPACE:
							{
								int stmt_len;
								char *sql_statement;
								HANDLE h;

								stmt_len = (int)SendDlgItemMessage(hWnd, IDC_SQL_STATEMENT, WM_GETTEXTLENGTH, 0, 0);
								sql_statement = (char*)malloc(stmt_len + 1000);
								GetDlgItemText(hWnd, IDC_SQL_STATEMENT, sql_statement, stmt_len + 1);
								h = (HANDLE)SendDlgItemMessage(hWnd, IDC_SQL_STATEMENT, EM_GETHANDLE, 0, 0);
								LocalFree(h);
								h = LocalAlloc(LMEM_FIXED, stmt_len * 2);
								SendDlgItemMessage(hWnd, IDC_SQL_STATEMENT, EM_SETHANDLE, (WPARAM)h, 0);
								SetDlgItemText(hWnd, IDC_SQL_STATEMENT, sql_statement);
								break;
							}
					}
					break;
				case IDA_SELECT_ALL:
					SendMessage(GetDlgItem(hWnd, IDC_SQL_STATEMENT), EM_SETSEL, (WPARAM)0, (LPARAM)-1);
					break;
			}
			break;

		case WM_CLOSE:
			EndDialog(hWnd, FALSE);
			g_text->analyze = NULL;
			return TRUE;

		case WM_SIZE:
			//ResizeSQLAnalyzer(hWnd);
            MoveWindow(hWndAnalyzeSplitter, 0, 0, LOWORD(lParam), HIWORD(lParam), TRUE);

			break;
        case WM_NOTIFY:
            if (wParam == ID_SQLSPLITTER)
                ResizeSQLAnalyzer(hWnd);
            break;
		default:
			break;
	}
	return FALSE;
}


void SetWindowTitleEx(HWND hWnd, char *window)
{
	char title[260];

	sprintf_s(title, 260, "%s - %s", window, g_title);
	SetWindowText(hWnd, title);
}

HWND ShowSqlAnalyzer(HWND parenthWnd)
{
	FARPROC analyzeproc;
	HWND w;

	analyzeproc = MakeProcInstance((FARPROC)AnalyzeProc, hInst);
	w = CreateDialogParam(hInst, MAKEINTRESOURCE(IDD_ANALYZE), parenthWnd, (DLGPROC)analyzeproc, 0);
	ShowWindow(w, SW_SHOW);
	SetWindowTitleEx(w, "SQL Analyzer");
	SendMessage(w, WM_SETICON, ICON_SMALL, (LPARAM)LoadIcon(g_hInst, MAKEINTRESOURCE(IDI_JBSQL)));

	FreeProcInstance(analyzeproc);

	return w;
}

void SetAnalyzerText(TextWidget *text, char *sqlstmt)
{
	char *str = NULL;
	int slen, lastx = 0, x, slen2;

	slen = (int)strlen(sqlstmt);
	str = _strdup("");
	for (x = 0; x < slen; x++)
	{
		switch (sqlstmt[x])
		{
			case '\n':
				slen2 = (int)strlen(str);
				str = realloc(str, slen2 + x - lastx + 3);
				memcpy(&str[slen2], &sqlstmt[lastx], x - lastx);
				str[slen2 + x - lastx] = '\r';
				str[slen2 + x - lastx + 1] = '\n';
				str[slen2 + x - lastx + 2] = '\0';
				lastx = x + 1;
				break;
			default:
				break;
		}
	}
	if (lastx < (int)slen)
	{
		slen2 = (int)strlen(str);
		str = realloc(str, slen2 + x - lastx + 1);
		memcpy(&str[slen2], &sqlstmt[lastx], x - lastx);
		str[slen2 + x - lastx] = '\0';
	}
	SetDlgItemText(text->analyze, IDC_SQL_STATEMENT, str);
	free(str);
}


void ShowAutotrace(ExecuteStruct *s)
{
	if (ora_connected)
	{
		if (s->INT_OPTION(AUTOTRACE))
		{
			if (s->text->analyze == NULL)
				s->text->analyze = ShowSqlAnalyzer(NULL);
			SetAnalyzerText(s->text, s->data);
			ExplainPlan(s->text->analyze, s->data);
		}
	}
}

void AnalyzeError(char *fmt, ...)
{
	va_list param;
	char *str;
	TVINSERTSTRUCT item_data;
	HTREEITEM tree_item;

	va_start(param, fmt);
	str = myvsprintf(fmt, param);
	va_end(param);

    HWND tree = GetDlgItem(g_text->analyze, IDC_PLAN_TREE);
	TreeView_DeleteAllItems(tree);

	item_data.hParent = TVI_ROOT;
	item_data.hInsertAfter = TVI_LAST;
	item_data.item.mask = TVIF_STATE | TVIF_TEXT;
	item_data.item.state = TVIS_EXPANDED;
	item_data.item.stateMask = TVIS_EXPANDED;
	item_data.item.pszText = str;
	item_data.item.cchTextMax = (int)strlen(str);

	if (planstr)
		free(planstr);
	planstr = _strdup(str);

	tree_item = TreeView_InsertItem(tree, &item_data);
    free(str);
}
