#include "jboci.h"
#include "ccsplitter.h"
#include "TreeList.h"

#define SQLMSPLITTER_CLASS_NAME "SQLMSplitterClass"
#define	SPLITTER_BAR_WIDTH		2

DWORD sqlmon_threadid = 0;
int stop_sqlmon = -1;
char g_prev_sqlid[20] = "";
int g_sqlmon_inst_id, g_sqlmon_sid;
int xSizing = 0;
HCURSOR hcSizeNS = 0;
HWND hSplitter, topWindow, bottomWindow, hwnd_sqltext, hwnd_sqltextprompt, hwnd_sessionlist;
TREELIST_HANDLE bottomTree;
HashTable htm;
OCIEnvironment* g_sqlmon_oci;
CRITICAL_SECTION g_sqlmonmutex;


#define ID_MON_SESSIONS 2001

void ResizeSQLMonitor(HWND hWnd)
{
    RECT rc;

    GetClientRect(topWindow, &rc);
    SetWindowPos(hwnd_sqltext, NULL, 0, 26, rc.right, rc.bottom - 26, 0);
}

void FillSessions(HWND hWnd)
{
    ComboBox_ResetContent(hWnd);
    FillListBoxFromQuery(g_sqlmon_oci, hWnd, "select inst_id||','||sid||','||username||','||program||','||osuser||','||status from gv$session where type!='BACKGROUND' order by inst_id,sid", NULL, 0, 0, 129);
}

LRESULT CALLBACK TopWindowProc(HWND hWnd,
    UINT uMessage,
    WPARAM wParam,
    LPARAM lParam)
{
    switch (uMessage)
    {
        case WM_CTLCOLORSTATIC:
            {
                if ((HWND)lParam == hwnd_sqltext)
                {
                    HDC hdcStatic = (HDC)wParam;
                    static HBRUSH hbrBkgnd = NULL;

                    SetTextColor(hdcStatic, RGB(0, 0, 0));
                    SetBkColor(hdcStatic, RGB(255, 255, 255));

                    if (hbrBkgnd == NULL)
                    {
                        hbrBkgnd = CreateSolidBrush(RGB(255, 255, 255));
                    }
                    return (INT_PTR)hbrBkgnd;
                }
                break;
            }
        case WM_COMMAND:
            switch (LOWORD(wParam))
            {
                case ID_MON_SESSIONS:
                    switch (HIWORD(wParam))
                    {
                        case CBN_DROPDOWN:
                            {
                                HCURSOR c;
                                c = SetCursor(LoadCursor(NULL, IDC_WAIT));
                                EnterCriticalSection(&g_sqlmonmutex);
                                FillSessions((HWND)lParam);
                                LeaveCriticalSection(&g_sqlmonmutex);
                                SetCursor(c);
                                g_sqlmon_inst_id = g_instance;
                                g_sqlmon_sid = g_sid;
                                break;
                            }
                        case CBN_SELCHANGE:
                            {
                                char str[512], * pos, * inst_id, * sid;
                                ComboBox_GetText((HWND)lParam, str, sizeof(str));
                                inst_id = str;
                                pos = strchr(str, ',');
                                *pos = '\0';
                                sid = pos + 1;
                                pos = strchr(sid, ',');
                                *pos = '\0';
                                g_sqlmon_inst_id = atoi(inst_id);
                                g_sqlmon_sid = atoi(sid);
                            }
                    }
                    break;
            }
    }
    return DefWindowProc(hWnd, uMessage, wParam, lParam);
}

void CreateSqlMonChildWindows(HWND hWnd)
{
    CCSPLIT	spy;			// Y-split data
    RECT rc;

    GetClientRect(hWnd, &rc);

    hSplitter = CreateWindowEx(
        0,						// Extended window style
        WC_CCSPLITTER,			// Window class name
        NULL,					// Window name
        WS_CHILD | WS_VISIBLE,	// Window style
        0, 0, rc.right, rc.bottom,				// Position & size
        hWnd,					// Parent window handle
        (HMENU)ID_SPLITTER,		// Application defined ID
        g_hInst,					// Application instance
        0);						// Parameter

    if (hSplitter == NULL) {
        MessageBox(0, "CreateWindowEx failed in MonitorProc", NULL, MB_ICONSTOP | MB_OK);
        exit(1);
    }

    topWindow = CreateWindowEx(
        WS_EX_CLIENTEDGE,		// Extended window style
        GS_VIEW_WINDOW,			// Window class name
        NULL,		// Window name
        WS_CHILD | WS_VISIBLE,	// Window style
        0, 0, 0, 0,			// Position & size
        hWnd,			// Parent window handle
        NULL,			// Menu handle
        g_hInst,		// Application instance
        0);				// Parameter

    if (topWindow == NULL) {
        MessageBox(0, "CreateWindowEx failed in CreateChildWindows", NULL, MB_ICONSTOP | MB_OK);
        exit(1);
    }
    SetWindowLongPtr(topWindow, GWLP_WNDPROC, (LONG_PTR)TopWindowProc);


    hwnd_sqltextprompt = CreateWindowEx(
        0,		// Extended window style
        "STATIC",			// Window class name
        "Session:",		// Window name
        WS_CHILD | WS_VISIBLE,	// Window style
        4, 4, 200, 20,			// Position & size
        topWindow,			// Parent window handle
        NULL,			// Menu handle
        g_hInst,		// Application instance
        0);
    hwnd_sessionlist = CreateWindowEx(
        0,		// Extended window style
        "COMBOBOX",			// Window class name
        "Sessions",		// Window name
        WS_CHILD | WS_VISIBLE | CBS_DROPDOWNLIST | CBS_DISABLENOSCROLL | WS_VSCROLL,	// Window style
        100, 1, 800, 20,			// Position & size
        topWindow,			// Parent window handle
        (HMENU)ID_MON_SESSIONS,			// Menu handle
        g_hInst,		// Application instance
        0);
    hwnd_sqltext = CreateWindowEx(
        WS_EX_CLIENTEDGE,		// Extended window style
        "EDIT",			// Window class name
        NULL,		// Window name
        WS_CHILD | WS_VISIBLE | ES_MULTILINE | ES_AUTOHSCROLL | ES_AUTOVSCROLL | ES_LEFT | ES_READONLY | WS_HSCROLL | WS_VSCROLL,	// Window style
        0, 26, 50, 50,			// Position & size
        topWindow,			// Parent window handle
        NULL,			// Menu handle
        g_hInst,		// Application instance
        0);				// Parameter

    if (hwnd_sqltext == NULL) {
        MessageBox(0, "CreateWindowEx failed in CreateChildWindows", NULL, MB_ICONSTOP | MB_OK);
        exit(1);
    }
    SendMessage(hwnd_sqltext, WM_SETFONT, (WPARAM)g_text->hfont, FALSE);

    CCsplitter_SetHandle(hSplitter, CCSPV_TOP, topWindow);

    bottomWindow = CreateWindowEx(
        WS_EX_CLIENTEDGE,		// Extended window style
        GS_VIEW_WINDOW,			// Window class name
        NULL,		// Window name
        WS_CHILD | WS_VISIBLE,	// Window style
        0, 0, 100, 100,			// Position & size
        hWnd,			// Parent window handle
        NULL,			// Menu handle
        g_hInst,		// Application instance
        0);				// Parameter

    if (bottomWindow == NULL) {
        MessageBox(0, "CreateWindowEx failed in CreateChildWindows", NULL, MB_ICONSTOP | MB_OK);
        exit(1);
    }

    bottomTree = TreeListCreate(g_hInst, bottomWindow, NULL, TREELIST_DRAW_EDGE | TREELIST_ANCHOR_RIGHT | TREELIST_ANCHOR_BOTTOM, NULL);
    TreeListError terr;
    terr = TreeListAddColumn(bottomTree, "Step", 500);
    terr = TreeListAddColumn(bottomTree, "%Complete", 80);
    terr = TreeListAddColumn(bottomTree, "Rows", 80);
    terr = TreeListAddColumn(bottomTree, "Execs", 80);
    terr = TreeListAddColumn(bottomTree, "Read req", 80);
    terr = TreeListAddColumn(bottomTree, "Write req", 80);
    terr = TreeListAddColumn(bottomTree, "Memory", 80);
    terr = TreeListAddColumn(bottomTree, "Temp", 80);
    CCsplitter_SetHandle(hSplitter, CCSPV_BOTTOM, bottomWindow);


    spy.cbSize = sizeof(spy);
    spy.flags = CCSP_POS;
    spy.pos = rc.bottom / 2;
    CCsplitter_SetSplit(hSplitter, NULL, &spy);
}

int ProcessSqlText(HWND hWnd, char* str)
{
    // get the current selection
    DWORD StartPos, EndPos;
    SendMessage(hwnd_sqltext, EM_GETSEL, (WPARAM)& StartPos, (LPARAM)& EndPos);

    // move the caret to the end of the text
    int outLength = GetWindowTextLength(hwnd_sqltext);
    SendMessage(hwnd_sqltext, EM_SETSEL, outLength, outLength);

    // insert the text at the new caret position
    ReplaceString(str, "\n", "\r\n");
    SendMessage(hwnd_sqltext, EM_REPLACESEL, TRUE, (LPARAM)str);

    // restore the previous selection
    SendMessage(hwnd_sqltext, EM_SETSEL, StartPos, EndPos);

    SendMessage(hwnd_sqltext, EM_SCROLLCARET, 0, 0);

    return 0;
}

int ProcessSqlPlan(HWND hWnd, char* str)
{
    char* s_id, * s_parent_id, * plan, * pos;
    int id, parent_id;
    MonitorPlanElement pe;
    NODE_HANDLE parent_node;

    pos = strchr(str, ';');
    if (pos)
        * pos = '\0';
    s_id = str;
    s_parent_id = ++pos;
    pos = strchr(pos, ';');
    if (pos)
        * pos = '\0';
    plan = pos + 1;

    id = atoi(s_id);
    parent_id = atoi(s_parent_id);

    if (HTGetRecord(htm, &parent_id, &pe))
        parent_node = pe.tree_item;
    else
        parent_node = NULL;
    TreeListNodeData node_data[8];
    strcpy(node_data[0].Data, plan);
    strcpy(node_data[1].Data, "");
    strcpy(node_data[2].Data, "");
    strcpy(node_data[3].Data, "");
    strcpy(node_data[4].Data, "");
    strcpy(node_data[5].Data, "");
    strcpy(node_data[6].Data, "");
    strcpy(node_data[7].Data, "");
    pe.tree_item = TreeListAddNode(bottomTree, parent_node, node_data, 8);
    pe.id = id;
    HTAddRecord(htm, &pe);
    return 0;
}

int ProcessSqlLongOps(HWND hWnd, char* str)
{
    char* s_id, * s_pct, * pos;
    int id;
    MonitorPlanElement pe;

    pos = strchr(str, ';');
    if (pos)
        * pos = '\0';
    s_id = str;
    s_pct = ++pos;

    id = atoi(s_id);

    if (HTGetRecord(htm, &id, &pe))
    {
        TreeListUpdateValue(bottomTree, pe.tree_item, 1, s_pct);
    }
    return 0;
}

int ProcessSqlMonitor(HWND hWnd, char* str)
{
    char* s_id, * s_rows, * s_read, * s_write, * s_mem, * s_temp, * s_starts, * pos;
    int id;
    MonitorPlanElement pe;

    pos = strchr(str, ';');
    if (pos == NULL)
        return 1;
    *pos = '\0';
    s_id = str;
    s_rows = ++pos;
    pos = strchr(s_rows, ';');
    if (pos == NULL)
        return 1;
    *pos = '\0';
    s_read = ++pos;
    pos = strchr(s_read, ';');
    if (pos == NULL)
        return 1;
    *pos = '\0';
    s_write = ++pos;
    pos = strchr(s_write, ';');
    if (pos == NULL)
        return 1;
    *pos = '\0';
    s_mem = ++pos;
    pos = strchr(s_mem, ';');
    if (pos == NULL)
        return 1;
    *pos = '\0';
    s_temp = pos + 1;
    pos = strchr(s_temp, ';');
    if (pos == NULL)
        return 1;
    *pos = '\0';
    s_starts = pos + 1;

    id = atoi(s_id);

    if (HTGetRecord(htm, &id, &pe))
    {
        TreeListUpdateValue(bottomTree, pe.tree_item, 2, s_rows);
        TreeListUpdateValue(bottomTree, pe.tree_item, 3, s_starts);
        TreeListUpdateValue(bottomTree, pe.tree_item, 4, s_read);
        TreeListUpdateValue(bottomTree, pe.tree_item, 5, s_write);
        TreeListUpdateValue(bottomTree, pe.tree_item, 6, s_mem);
        TreeListUpdateValue(bottomTree, pe.tree_item, 7, s_temp);
    }
    return 0;
}

void ShowSqlMonitorData(OCIEnvironment* l_oci)
{
    char sqlid[200] = "";
    char query[200];
    char* pos = NULL, * sql_child = NULL, * sql_exec_id = NULL, * sql_exec_start = NULL;
    char instance[10];
    int same_sqlid = 1;

    if (l_oci == NULL)
        return;
    EnterCriticalSection(&g_sqlmonmutex);
    sprintf(instance, "%d", g_sqlmon_inst_id);
    sprintf(query, "select s.sql_id||','||s.sql_child_number||','||s.sql_exec_id||','||to_char(s.sql_exec_start,'yyyymmddhh24miss') from gv$session s where s.sid=%d and s.inst_id=%s", g_sqlmon_sid, instance);
    if (GetSingleValue(l_oci, query, sqlid, sizeof(sqlid)))
    {
        SetWindowText(hwnd_sqltext, "");
        LeaveCriticalSection(&g_sqlmonmutex);
        return;
    }
    if (strcmp(sqlid, g_prev_sqlid))
    {
        strcpy(g_prev_sqlid, sqlid);
        same_sqlid = 0;
    }
    pos = strchr(sqlid, ',');
    if (pos == NULL)
    {
        LeaveCriticalSection(&g_sqlmonmutex);
        return;
    }
    *pos = '\0';
    sql_child = pos + 1;
    pos = strchr(sql_child, ',');
    if (pos == NULL)
    {
        LeaveCriticalSection(&g_sqlmonmutex);
        return;
    }
    *pos = '\0';
    sql_exec_id = pos + 1;
    pos = strchr(sql_exec_id, ',');
    if (pos == NULL)
    {
        LeaveCriticalSection(&g_sqlmonmutex);
        return;
    }
    *pos = '\0';
    sql_exec_start = pos + 1;
    if (!same_sqlid)
    {

        SendMessage(hwnd_sqltext, WM_SETREDRAW, FALSE, 0);
        SetWindowText(hwnd_sqltext, "");
        if (ProcessQuery(l_oci, g_text->sqlmonitor, "SELECT SQL_TEXT FROM gv$sqltext_with_newlines WHERE sql_id=:sql_id AND inst_id=:inst_id ORDER BY PIECE", (QueryProc)ProcessSqlText, 100, "sql_id", sqlid, "inst_id", instance, NULL) != 0)
        {
            LeaveCriticalSection(&g_sqlmonmutex);
            return;
        }
        SendMessage(hwnd_sqltext, WM_SETREDRAW, TRUE, 0);

        TreeListBeginUpdate(bottomTree);
        TreeListClear(bottomTree);
        if (htm.data)
            HTDestroy(htm);
        htm = HTCreate(101, sizeof(int), sizeof(PlanElement), NULL, NULL, NULL, NULL);
        if (ProcessQuery(l_oci, g_text->sqlmonitor, "select id||';'||parent_id||';'||plan  from (  select  sp.id,sp.parent_id, substr(sp.OPERATION|| DECODE(sp.OTHER_TAG,NULL,'','*')|| DECODE(sp.OPTIONS,NULL,'',' ('||sp.OPTIONS||')')|| DECODE(sp.OBJECT_NAME,NULL,'',' OF '''||sp.OBJECT_OWNER||'.'||sp.OBJECT_NAME||'''')|| DECODE(sp.OBJECT_TYPE,NULL,'',' ('||sp.OBJECT_TYPE||')')|| DECODE(sp.ID,0,DECODE(sp.OPTIMIZER,NULL,'',' Optimizer='||sp.OPTIMIZER))|| DECODE(sp.COST,NULL,'',' (Cost='||sp.COST|| DECODE(sp.CARDINALITY,NULL,'',' Rows='||sp.CARDINALITY)|| DECODE(sp.BYTES,NULL,'',' Bytes='||sp.BYTES)|| DECODE(sp.CPU_COST,NULL,'',' CPU='||sp.CPU_COST)|| DECODE(sp.IO_COST,NULL,'',' IO='||sp.IO_COST)|| DECODE(sp.TEMP_SPACE,NULL,'',' TEMP='||sp.TEMP_SPACE)||')')|| DECODE(sp.PARTITION_START,NULL,'',' PStart='||sp.PARTITION_START)|| DECODE(sp.PARTITION_STOP,NULL,'',' PStop='||sp.PARTITION_STOP)|| DECODE(sp.PARTITION_ID,NULL,'',' PId='||sp.PARTITION_ID)|| DECODE(sp.QBLOCK_NAME,NULL,'',' QBLOCK='||sp.QBLOCK_NAME)|| DECODE(sp.access_predicates,null,'',' ACCESS=('||substr(sp.access_predicates,1,500)||')')|| DECODE(sp.filter_predicates,null,'',' FILTER=('||substr(sp.filter_predicates,1,500)||')') ,1,2000 ) PLAN from gv$sql_plan sp WHERE sp.sql_id = :sql_id and sp.child_number = :child_number  and sp.inst_id=:inst_id   ) START WITH ID=0 CONNECT BY PRIOR ID=PARENT_ID ", (QueryProc)ProcessSqlPlan, 2000, "sql_id", sqlid, "child_number", sql_child, "inst_id", instance, NULL) != 0)
        {
            LeaveCriticalSection(&g_sqlmonmutex);
            TreeListEndUpdate(bottomTree);
            return;
        }
        TreeListEndUpdate(bottomTree);
    }
    if (strcmp(sqlid, ""))
    {
        if (ProcessQuery(l_oci, g_text->sqlmonitor, "select sql_plan_line_id||';'||DECODE(sofar,null,'',DECODE(totalwork, 0, 100, round(sofar/totalwork*100)) || '%') from gv$session_longops where sql_id=:sql_id and sql_exec_id = :sql_exec_id and sql_exec_start=TO_DATE(:sql_exec_start,'YYYYMMDDHH24MISS') and inst_id=:inst_id", (QueryProc)ProcessSqlLongOps, 200, "sql_id", sqlid, "sql_exec_id", sql_exec_id, "sql_exec_start", sql_exec_start, "inst_id", instance, NULL) != 0)
        {
            LeaveCriticalSection(&g_sqlmonmutex);
            return;
        }
        if (ProcessQuery(l_oci, g_text->sqlmonitor, "select m.plan_line_id||';'||sum(m.output_rows)||';'||sum(m.physical_read_requests)||';'||sum(m.physical_write_requests)||';'||sum(m.workarea_max_mem)||';'||sum(m.workarea_max_tempseg)||';'||sum(m.starts) from gv$sql_plan_monitor m where sql_id=:sql_id and sql_exec_id = :sql_exec_id and sql_exec_start=TO_DATE(:sql_exec_start,'YYYYMMDDHH24MISS') and inst_id=:inst_id group by m.plan_line_id", (QueryProc)ProcessSqlMonitor, 200, "sql_id", sqlid, "sql_exec_id", sql_exec_id, "sql_exec_start", sql_exec_start, "inst_id", instance, NULL) != 0)
        {
            LeaveCriticalSection(&g_sqlmonmutex);
            return;
        }

    }
    LeaveCriticalSection(&g_sqlmonmutex);
}

LRESULT CALLBACK MonitorProc(HWND hWnd,
    UINT uMessage,
    WPARAM wParam,
    LPARAM lParam)
{
    switch (uMessage)
    {
        case WM_INITDIALOG:
            {
                CreateSqlMonChildWindows(hWnd);
                break;
            }
        case WM_COMMAND:
            switch (LOWORD(wParam))
            {
                case IDC_CLOSE:
                    EndDialog(hWnd, FALSE);
                    g_text->sqlmonitor = NULL;
                    stop_sqlmon = 1;
                    return TRUE;
                    break;
                case IDA_SELECT_ALL:
                    SendMessage(hwnd_sqltext, EM_SETSEL, (WPARAM)0, (LPARAM)-1);
                    break;
            }
            break;

        case WM_CLOSE:
            stop_sqlmon = 1;
            KillTimer(hWnd, 1);
            EndDialog(hWnd, FALSE);
            g_text->sqlmonitor = NULL;
            TreeListDestroy(bottomTree);
            return TRUE;

        case WM_SIZE:
            MoveWindow(hSplitter, 0, 0, LOWORD(lParam), HIWORD(lParam), TRUE);

            break;

        case WM_NOTIFY:
            if (((NMHDR*)lParam)->idFrom == ID_SPLITTER)
            {
                NMCCSPLIT* spn;			// Splitter notification
                spn = (NMCCSPLIT*)lParam;
                switch (spn->hdr.code)
                {
                    case CCSPN_POSCHANGED:
                        ResizeSQLMonitor(hWnd);
                        break;
                }
            }
            break;
        case WM_TIMER:
            ShowSqlMonitorData(g_sqlmon_oci);
            break;
    }
    return FALSE;
}

void SqlMonitorMainProc(LPVOID lpThreadParameter)
{
    FARPROC monitorproc;
    HWND w = NULL;

    InitOCI(&g_sqlmon_oci);
    if (!ConnectWithConnectStringInternal(connectstring, 0, 0, &g_sqlmon_oci))
    {
        monitorproc = MakeProcInstance((FARPROC)MonitorProc, hInst);
        w = CreateDialogParam(hInst, MAKEINTRESOURCE(IDD_SQLMONITOR), (HWND)NULL, (DLGPROC)monitorproc, 0);
        g_text->sqlmonitor = w;
        ShowWindow(w, SW_SHOW);
        SetWindowTitleEx(w, "SQL Monitor");
        MoveWindow(w, 0, 0, 1100, 600, FALSE);
        SendMessage(w, WM_SETICON, ICON_SMALL, (LPARAM)LoadIcon(g_hInst, MAKEINTRESOURCE(IDI_JBSQL)));
        stop_sqlmon = 0;

        SetTimer(w, 1, 500, NULL);

        g_prev_sqlid[0] = '\0';
        g_sqlmon_inst_id = g_instance;
        g_sqlmon_sid = g_sid;
        stop_sqlmon = 0;
        HACCEL acctable;
        acctable = LoadAccelerators(g_hInst, MAKEINTRESOURCE(IDR_ACCELERATOR));
        MSG  msg;
        while (stop_sqlmon==0 && GetMessage(&msg, NULL, 0x00, 0x00) > 0)
        {
            if (msg.message == WM_KEYDOWN)
            {
                HWND focus = GetFocus();
                if (focus == hwnd_sqltext)
                {
                    if (TranslateAccelerator(g_text->sqlmonitor, acctable, &msg))
                        continue;
                }
            }
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        }
        DisconnectFromOracleInternal(&g_sqlmon_oci);
        stop_sqlmon = -1;
        DeleteCriticalSection(&g_sqlmonmutex);
        DestroyWindow(w);
        FreeProcInstance(monitorproc);
    }
    else
    {
        Log("Cannot connect, stopping sqlmonitor thread\n");
    }
}


HWND ShowSqlMonitor(HWND parenthWnd)
{

    if (ora_connected)
    {
        InitializeCriticalSection(&g_sqlmonmutex);
        CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)SqlMonitorMainProc, (LPVOID)parenthWnd, 0, &sqlmon_threadid);
    }
    return NULL;
}


